#!/usr/bin/perl5.8.0

# to make perl2exe happy
use Tie::Handle;

package Nikki::Config;

$VER = '0.5.1a';

# Default Language Strings
$STRINGS_CONFIG = {
    app_title                => q{Nikki - Livejournal},

    app_widget_submit        => q{Submit},
    app_widget_commit        => q{Commit},
    app_widget_search        => q{Search},
    app_widget_cancel        => q{Cancel},
    app_widget_advanced      => q{Advanced},
    app_widget_security      => q{Security},
    app_widget_comment       => q{Comments},
    app_widget_resources     => q{Resource},
    app_widget_addnew        => q{Add New},
    app_widget_test          => q{Test},
    app_widget_delete        => q{Delete},
    app_widget_sync          => q{Sync},
    app_widget_ok            => q{OK},
    app_widget_music         => q{Music},
    app_widget_mood          => q{Mood},
    app_widget_picture       => q{Picture},
    app_widget_default       => q{Default},

    app_widget_photo_title   => q{Title},
    app_widget_photo_description => q{Description},
    app_widget_photo_artist  => q{Artist},

    app_lbl_host             => q{Hostname},
    app_lbl_port             => q{Port Number},
    app_lbl_path             => q{Interface Path},
    app_lbl_ftp_path         => q{FTP Upload Path},
    app_lbl_ftp_url          => q{FTP Upload URL},
    app_lbl_ftp_account      => q{FTP Account},
    app_lbl_username         => q{Username},
    app_lbl_password         => q{Password},
    app_lbl_save_pass        => q{Save Password?},
    app_lbl_use_sftp         => q{Use SFTP?},
    app_lbl_acc_info         => q{Account Details},
    app_lbl_photo            => q{Editing image: %s},

    app_default_account      => q{Default Account},
    app_default_status       => q{Welcome to Nikki!},
    app_default_host         => q{www.livejournal.com},

    app_dlg_images_import    => q{Please select images to import},
    app_dlg_images_files     => q{All Files|*.*},
    app_dlg_newgal_message   => q{New Gallery Name},
    app_dlg_newgal_title     => q{Create New Gallery},

    app_win_search           => q{Search Records},
    app_win_event_new        => q{New Event},
    app_win_event_edit       => q{Editing Event ID: %s},
    app_win_calendar         => q{Calendar},
    app_win_advanced         => q{Advanced Options},
    app_win_accounts         => q{Account Options},
    app_win_draft            => q{Manage Draft Entries},
    app_win_photo            => q{Photo Gallery},
    app_win_resources        => q{Please Choose Resources},
    app_win_zoom             => q{Viewing Main Sized Image},

    app_about_text           => q{Nikki LiveJournal client ver %s by Aki Mimoto.},
    app_about_title          => q{About Nikki},

    app_str_daysofweek       => q{Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday},
    app_str_months           => q{January|February|March|April|May|June|July|August|September|October|November|December},
    app_str_security         => q{Public|Friends-Only|Private|Custom},
    app_str_comment          => q{Default|Don't Email|Disabled},
    app_str_hosts            => q{www.livejournal.com|www.deadjournal.com|www.blurty.com},
    app_str_acc_test         => q{Account Login Test},
    app_str_acc_test_fail    => qq{Sorry, the login attempt failed for the parameters specified.\n\%s},
    app_str_acc_test_success => q{Login test success},
    app_str_sync_start       => q{Starting Syncronization},
    app_str_sync_success     => q{Syncronization Completed Succesfully},
    app_str_post_fail        => qq{Could not post event because\n\%sWould you like to mark this entry as draft to submit later?},
    app_str_post_fail_title  => q{Could not post event},
    app_str_cancel_title     => q{Cancel Changes?},
    app_str_cancel_quest     => q{Would you like like to save this changed entry as a draft?},
    app_str_security         => q{Public|Friends|Private|Custom...},
    app_str_ftp_columns      => q{Default|Username|Host|Port|Path|URL|Protocol},
    app_str_acc_columns      => q{Default|Username|Host|Port},
    app_str_default_account  => q{default},

    app_sync_reindex         => q{Indexed %i Records.},
    app_sync_reindex_start   => q{Starting Reindex.},
    app_sync_start           => q{Starting Syncronization.},
    app_sync_done            => q{Done.},
    app_sync_item            => q{Syncing Item: %i.},

    gal_log_image_add        => qq{Adding image: \%s\n},

    gal_ftp_error            => q{FTP error: %s},
    gal_ftp_username         => q{Missing Username},
    gal_ftp_password         => q{Missing Password},
    gal_ftp_login            => q{Login Failed},
    gal_ftp_cwd              => q{Couldn't CWD},
    gal_ftp_put              => q{Couldn't Upload Datafile},
    gal_ftp_delete           => q{Couldn't Delete Datafile},
    gal_image_acquiring      => q{Acquiring Images (this may take some time)},
    gal_root_name            => q{Root},

    err_cantconnect          => q{Couldn't connect to server: '%s' because: '%s'},
    err_requestfail          => q{Request '%s' Failed because '%s'},
    err_reqentry             => q{Require entry text.},
    err_missing_key          => q{Missing required key '%s'},

    app_menu_structure       => [
        [ 
            "&File",
            [ "Accounts", "Setup Accounts", "OnAccounts" ],
            [ "&New\tCtrl-N", "Create New Event",       "OnCreateNewEvent" ],
            [ "E&xit\tCtrl-X", "Quit this program.",    "OnQuit" ],
        ],
        [ 
            "&Journal",
            [ "&Browse\tCtrl-B", "Calendar display of older events", "OnBrowseEvents" ],
            [ "&Search\tCtrl-S", "Search all old events", "OnSearchEvents" ],
            [ "&Drafts\tCtrl-D", "Incomplete Entries or Updates", "OnViewDrafts" ]
        ],
        [
            "&Gallery",
            [ "View Gallery\tCtrl-G", "Manage your galleries", "OnGallery" ],
            [ "Settings", "Manage your gallery and upload settings.", "OnGallerySettings" ]
        ],
        [ 
            "&Help",
            [ "&About", "Show about dialog.",   "OnAbout" ], 
        ],
    ],

    gal_menu_structure        => [

        [ "Edit Description", "", "image_action", "edit_description"  ],
        [ "View",             "", "image_action", "edit_view"         ],
        [ "Copy",             "", "image_action", "copy_single"       ],
        [ "Delete",           "", "image_action", "edit_delete"       ],
        [ "Select All",       "", "image_action", "edit_select_all"   ],
        [ "De-Select All",    "", "image_action", "edit_deselect_all" ],
        [ "Gimp Original",    "", "image_action", "gimp_original"     ],
        [ "Gimp Medium",      "", "image_action", "gimp_medium"       ],

        '---------------------------------------',

# Commented since this causes the occasional interface error that I haven't
# diagnosed yet.
#        [ "View All", "", "image_action", "edit_view_all" ],
        [ "Copy Selected",   "", "image_action", "copy_selected"      ],
        [ "Delete Selected", "", "image_action", "mass_delete" ],
        [ "Delete Selected + Orignal", "", "image_action", "mass_delete_orig" ],
        [ "Sort by Time", "", "image_action", "sort_bytime" ],

        [ "Rotate Clockwise", "", "image_action", "rotate_clockwise" ],
        [ "Rotate Counter-Clockwise", "", "image_action", "rotate_counter_clockwise" ],
        [ "Desaturate", "", "image_action", "desaturate" ],

        [ "Gamma Up", "", "image_action", "gamma_up" ],
        [ "Gamma Down", "", "image_action", "gamma_down" ],

#        [ "Annotate", "", "image_action", "annotate" ],
#        [ "Blur", "", "image_action", "blur" ],
#        [ "Charcoal", "", "image_action", "charcoal" ],
#        [ "Emboss", "", "image_action", "emboss" ],
#        [ "Enhance", "", "image_action", "enhance" ],
#        [ "Equalize", "", "image_action", "equalize" ],
        [ "Flip Vertical", "", "image_action", "flip_vertical" ],
        [ "Flip Horizontal", "", "image_action", "flip_horizontal" ],
#        [ "Gamma", "", "image_action", "gamma" ],
#        [ "Level", "", "image_action", "level" ],
#        [ "Brightness/Saturation/Hue", "", "image_action", "modulate" ],
#        [ "Motion Blur", "", "image_action", "motion_blur" ],
#        [ "Negate", "", "image_action", "negate" ],
        [ "Normalize", "", "image_action", "normalize" ],
#        [ "Oil Paint", "", "image_action", "oil_paint" ],
#        [ "Roll", "", "image_action", "roll" ],
#        [ "Sharpen", "", "image_action", "sharpen" ],
#        [ "Solarize", "", "image_action", "solarize" ],
#        [ "Swirl", "", "image_action", "swirl" ],
#        [ "Wave", "", "image_action", "wave" ],

    ],

    app_display_search_results => '
    <table>
    <?if search_results?>
        <?loop search_results?>

            <tr>
                <td>
                <a href="edit://<?itemid?>/<?account?>">
                    <u><font size="1"><?eventtime?></font></u>
                </a>
                </td>
            </tr>

            <tr>
                <td><font size="1">
                    <?display?>
                </font></td>
            </tr>

        <?endloop?>
    <?endif?>
    </table>
    ',

    app_display_drafts => '
    <table>
    <?if drafts_list?>
        <?loop drafts_list?>

            <tr>
                <td>
                    <font size="1">
                        <u><a href="draft://<?fentry?>/<?account?>"><?datestr?></a></u>
                        <a href="draft://<?fentry?>/delete/<?account?>">Delete</a>
                    </font>
                </td>
            </tr>

            <tr>
                <td><font size="1">
                    <?display?>
                </font></td>
            </tr>
        <?endloop?>
    <?endif?>
    </table>
    ',

    gal_display_gallery => '
<html>

<body>

<table>

    <tr>
        <td>
            Gallery: <a href="subgallery:///">Root</a><?loop gallery_path_loop?> / <a href="subgallery://<?gallery_link_path?>"><?gallery_path_name?></a><?endloop?>
        </td>
        <td align="right"><font size="1">
            Gallery:
            <a href="gallery://image_add/">Add</a>
            | <a href="gallery://add/">New</a>
            | <a href="gallery://publish/">Publish</a>
            | <a href="gallery://transfer/">Transfer</a>
            | <a href="gallery://cd/">CD</a>
            <!-- | <a href="gallery://add/">Edit</a> -->
            <br>
            Clipboard: <a href="clipboard://view">View</a>
            | <a href="clipboard://paste">Paste</a>
            | <a href="clipboard://clear">Clear</a>
        </font></td>
    </tr>

</table>

<hr>

<?if subgallery_loop?>
<table>
    <tr>
        <td colspan="2"><font size="2">
            Sub Galleries
        </font></td>
    </tr>

    <tr>
        <td colspan="2"><font size="1">
            <ul>

            <?loop subgallery_loop?>
            <li>
                <a href="subgallery://<?subgallery_gallery_path?>"><?subgallery_name?></a>
            </li>
            <?endloop?>
    
            </ul>
        </font></td>
    </tr>
</table>

<hr>
<?endif?>

<?if num_images?>
    <table>
        <tr>
            <td><font size="1">

                <?num_images?> image(s) in gallery: 

                <a href="gallery://mh/25">25</a> 
                <a href="gallery://mh/50">50</a> 
                <a href="gallery://mh/100">100</a> 
                <a href="gallery://mh/1000000">All</a> 

                <?if page_loop?>: 
                    <?loop page_loop?>
                        <?if page_selected?>
                            <b><?page_number?></b>
                        <?else?>
                            <a href="gallery://page/<?page_number?>"><?page_number?></a>
                        <?endif?>
                    <?endloop?>
                <?endif?>

            </font></td>
        </tr>
    </table>
<?endif?>

<table>

    <?loop content_loop?>
    <?if first?>
        <tr>
    <?else?>
        <?if index % $images_per_row?>
        <?else?>
            </tr>
            <tr>
        <?endif?>
    <?endif?>

        <td align="center" <?if is_selected?>bgcolor="#888888"<?endif?>>
            <font size="1">

            <a href="photo://reorder/back(1,<?base_name?>)">&lt;</a> 
            move
            <a href="photo://reorder/forward(1,<?base_name?>)">&gt;</a><br>

            <a href="photo://select/<?base_name?>">
                <img src="file://<?thumbnail_path?>"><br>
                    <?if title?><?title?><?else?><?base_name?><?endif?>
            </a><br>
            </font>
        </td>

    <?if last?></tr><?endif?>
    <?endloop?>
</table>

</body>
</html>
    ',

    gal_display_image => '
        <html>
        <head></head>
        <body bgcolor="black">
        <table width="100%" height="100%">
            <tr>
                <td align="right"><font color="white" size="1"><a href="img://previous">&lt;&lt; previous</a></font></td>
                <td align="left"><font color="white" size="1"><a href="img://next">next &gt;&gt;</a></font></td>
            </tr>
            <tr>
                <td align="center" valign="center" colspan="2">
                    <a href="mark://<?base_name?>"><font color="white" size="1"><?if selected?>UNmark<?else?>Mark<?endif?></font></a>
                </td>
            </tr>
            <tr>
                <td align="center" valign="center" colspan="2">
                    <a href="img://next"><img src="file://<?main_path?>" border="0"></a>
                    <br>
                    <font color="white" size="1"><?base_name?>
                    <?if title?><br><?title?><?endif?>
                    <?if exif_aperture?>
                    <?if exif_iso_equiv_?>
                        <?exif_aperture?>, 
                        <?exif_exposure_time?>, 
                        iso <?exif_iso_equiv_?>, 
                        <?exif_exposure?>
                    <?endif?>
                    <?endif?>
                    <br><?source_path?>
                    </font>
                </td>
            </tr>
        </table>
        </body>
        </html>',

    gal_display_clipboard => qq`
        <html>

        <body>

        <table>

            <tr>
                <td>
                    Gallery: <a href="subgallery:///">Root</a><?loop gallery_path_loop?> / <a href="subgallery://<?gallery_link_path?>"><?gallery_path_name?></a><?endloop?>
                </td>
                <td align="right"><font size="1">
                    Gallery:
                    <a href="gallery://image_add/">Add</a>
                    | <a href="gallery://add/">New</a>
                    | <a href="gallery://publish/">Publish</a>
                    <!-- | <a href="gallery://add/">Edit</a> -->
                    <br>
                    Clipboard: <a href="clipboard://view">View</a>
                    | <a href="clipboard://view">Paste</a>
                </font></td>
            </tr>

        </table>

        <hr>

        Viewing Your Clipboard

        <table>
        <?loop content_loop?>
            <tr>
                <td>
                    <a href="photo://select/<?base_name?>">
                    <img src="file://<?thumbnail_path?>"><br>
                    <font size="1"><?base_name?></font></a>
                </td>
            </tr>
        <?endloop?>
        </table>

        </body>

        </html>
    `,
    gal_embed_resource => '<?if size eq "main"?><img src="<?main_url?>" width="<?main_width?>" height="<?main_height?>" border="0" style="border:solid 2px black"><br><?if exif_aperture?><?if exif_iso_equiv_?><?exif_aperture?>,<?exif_exposure_time?>, iso <?exif_iso_equiv_?>, <?exif_exposure?><?endif?><?endif?>
<?else?><div style="<?if float?>float:<?float?>;<?endif?>padding:6px;margin:4px;text-align:center;font-size:8pt;border:solid 2px #000000">'
                            . '<a href="<?page_url?>"><?if title?><br><?title?><?endif?>'
                            . '<img src="<?thumbnail_url?>" width="<?thumbnail_width?>" height="<?thumbnail_height?>" border="0"><?if title?><br><?title?><?endif?></a>'
                         .'</div><?endif?>',

    gal_default_gallery => <<'GALLERY_END',
<html>
    <head>
        <title><?if title?><?title?><?else?>Un-named Gallery<?endif?></title>
        <style>
        <!--

            body {
                background    : white ;
                color         : #5555dd ;
            }

            .gallery-frame {
                border        : solid 1px #000000 ;
                font-family   : arial, helvetica ;
                font-size     : 8pt ;
                padding       : 5px ;
                background    : #000000 ;
            }

            .gallery-display {
                text-align    : center ;
                vertial-align : middle ;
                width         : 100% ;
            }

            .gallery-link {
                font-family   : arial, helvetica ;
                font-size     : 8pt ;
                padding       : 5px ;
                color         : #000000 ;
            }

        -->
        </style>
    </head>

    <body>
        <table width="100%" height="100%"><tr><td align="center" valign="center">

        <table class="gallery-frame" cellpadding="5" cellspacing="0" border="0">
            <?loop gallery_images?>
                <?if first?><tr><?endif?>

                <?ifnot index % 5?>
                    </tr>
                    <tr>
                <?endif?>

                <td>
                    <a href="<?base_name?>.html">
                    <img src="<?thumbnail_url?>" height="<?thumbnail_height?>" width="<?thumbnail_width?>" border="0">
                    </a>
                </td>

                <?if last?></tr><?endif?>
            <?endloop?>
        </table>

        </td></tr></table>
    </body>
</html>
GALLERY_END

    gal_default_frame => <<'FRAME_END',
<html>
<!--
    Source Path: <?source_path?>
-->
    <head>
        <title><?if title?><?title?><?else?>Untitled<?endif?></title>
        <style>
        <!--

            body {
                background    : white ;
            }

            .gallery-frame {
                font-family   : arial, helvetica ;
                font-size     : 8pt ;
                padding       : 5px ;
                background    : black ;
                color         : #ffffff ;
            }

            .gallery-display {
                text-align    : center ;
                vertial-align : middle ;
                width         : 100% ;
            }

            .gallery-link {
                font-family   : arial, helvetica ;
                font-size     : 8pt ;
                padding       : 5px ;
                color         : #ffffff ;
            }

        -->
        </style>
    </head>

    <body>
        <table width="100%" height="100%"><tr><td align="center" valign="center">

        <table class="gallery-frame" cellpadding="5" cellspacing="0" border="0">
            <tr>
                <td width="33%">
                </td>
                <td width="33%" align="center">
                    <?title?>
                </td>
                <td width="33%" align="right">
                    <?if previous_base_name?>
                    <a href="<?previous_base_name?>.html"><font color="white">&lt;&lt;</a>
                    <?endif?>
                    <a href="index.html"><font color="white">^^</a>
                    <?if next_base_name?>
                    <a href="<?next_base_name?>.html"><font color="white">&gt;&gt;</a>
                    <?endif?>
                </td>
            </tr>

            <tr>
                <td colspan="3">
                    <?if next_base_name?><a href="<?next_base_name?>.html"><?endif?>
                    <img src="<?main_url?>" height="<?main_height?>" width="<?main_width?>" border="0">
                    <?if next_base_name?></a><?endif?>
                </td>
            </tr>

            <?if exif_aperture?>
            <?if exif_iso_equiv_?>
                <tr>
                    <td colspan="3" align="center">
                        <div style="width:<?main_width?>px;text-align:left">
                        <?exif_aperture?>, 
                        <?exif_exposure_time?>, 
                        iso <?exif_iso_equiv_?>, 
                        <?exif_exposure?>
                    </td>
                </tr>
            <?endif?>
            <?endif?>

            <?if description?>
            <tr>
                <td colspan="3" align="center">
                    <div style="width:<?main_width?>px;text-align:left">
                    <?description?>
                    </div>
                </td>
            </tr>
            <?endif?>
        </table>

        </td></tr></table>
        <font color="white"><?source_path?></font>
    </body>
</html>
FRAME_END

    gal_default_actions => <<'PHOTO_ACTION_END',
    <table>

        <tr><td><font size="1">
            <?num_selected?> image(s) selected.
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://rotate_clock">90 deg. clockwise</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://rotate_counterclock">90 deg. counter clockwise</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://blur">Blur</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://annotate">Annotate</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://emboss">Emboss</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://enhance">Enhance</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://equalize">Equalize</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://flip_vertical">Flip Vertical</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://flip_horizontal">Flip Horizontal</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://gamma">Gamma</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://implode">Implode</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://level">Level</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://modulate">Brightness/Saturation/Hue</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://motionblur">MotionBlue</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://negate">Negate</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://oil_paint">Oil Paint</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://roll">Roll</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://sharpen">Sharpen</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://solarize">Solarize</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://swirl">Swirl</a>
        </font></td></tr>

        <tr><td><font size="1">
            <a href="action://wave">Wave</a>
        </font></td></tr>

    </table>
PHOTO_ACTION_END

};

use strict 'vars', 'subs';
use vars qw/ 
    $STR
    $CFG 
    $STRINGS_CONFIG 
    $DEFAULT_CONFIG 
    $INIT
    $VER
/;

$INIT = 0;

sub import {
# --------------------------------------------------

    unless ( $INIT ) {

        my $home_dir = $ENV{HOME} || $ENV{HOMEDIRECTORY} || '/My Documents';
#	$home_dir = '/user';
        my $nikki_home_dir = $home_dir . '/nikki';
	my $gallery_look_path = '';

        $STR = bless {}, __PACKAGE__;
        $CFG = bless {
            config_path  => $nikki_home_dir,

            thumbnail    => 100,
            medium       => 700,

            jhead_path   => '/home/aki/bin/jhead',

            gallery_look_path => $gallery_look_path,

            image_transfer_name => 'p8183%03i.jpg',

            upload_quality => 85,
            upload_callback => sub {
                my $uploader_path = shift;
                system 'jhead', '-de', $uploader_path;
            },

            index_min_letters => '2',
            index_max_letters => 20,

            app_window_height => 700,
            app_window_width  => 700,

            no_busy_info      => 1,

        }, __PACKAGE__;

        if ( -f "$home_dir/nikki.cfg" ) {
            {
                local $/;
                require Symbol;
                my $fh = Symbol->gensym;
                open $fh, "$home_dir/nikki.cfg";
                my $dat = <$fh>;
                close $fh;

                my $user_opts = {
                    map { /^(.+?)\s+(.*)$/; ($1 => $2 ) } 
                        grep !/^\s*$/, 
                            split /\r?\n/, $dat
                };

                @$CFG{keys %$user_opts} = values %$user_opts;
            }
        }

        if ( -f "$home_dir/nikki.pcfg" ) {
            do "$home_dir/nikki.pcfg"
        }

        $INIT = 1;

    };

    my $call_pkg = caller;
    *{$call_pkg.'::STR'} = \$STR;
    *{$call_pkg.'::CFG'} = \$CFG;
    *{$call_pkg.'::VER'} = \$VER;
}

sub string {
# --------------------------------------------------
    my ( $self, $code ) = splice @_, 0, 2;
    return exists $STRINGS_CONFIG->{$code} ? 
        @_ ? sprintf $STRINGS_CONFIG->{$code}, @_ : $STRINGS_CONFIG->{$code}
        : $code;
}

sub entry {
# --------------------------------------------------
    my ( $self, $code ) = @_;
    return $STRINGS_CONFIG->{$code} || '';
}

sub config {
# --------------------------------------------------
}

BEGIN { $INC{'Nikki/Config.pm'}++ };

1;

############################################################
#

package Nikki::Client;

use strict;
use Exporter;
use Nikki::Config;
use vars qw/ $ATTRIBS $ERROR $HTML_ESC $HTML_UNESC $DATEENTRY_SIZE @EVENT_KEYS @ISA @EXPORT_OK $MAPS /;
use IO::Socket::INET;

@ISA = 'Exporter';

$ERROR = [];

$ATTRIBS = {
    _dirty => 0,
};

$HTML_ESC = {
    '>' => '&gt;',
    '<' => '&lt;',
    '&' => '&amp;',
};

@EVENT_KEYS = qw( 
    subject
    event
    itemid 
    security 
    allowmask 
    eventtime 
    current_mood 
    current_moodid 
    current_music 
    opt_preformatted 
    opt_nocomments 
    picture_keyword 
    opt_backdated 
    opt_noemail 
    unknown8bit 
    hasscreened 
);

$MAPS = {
    end => {
        '*' => '</b>',
        '_' => '</u>',
        '~' => '</i>',
        '`' => '</pre>',
    },
    start  => {
        '*' => '<b>',
        '_' => '<u>',
        '~' => '<i>',
        '`' => '<pre>',
    },
};


$HTML_UNESC = { reverse %$HTML_ESC };

$DATEENTRY_SIZE = length( pack "L*", (1..7) );

@EXPORT_OK = qw( decode encode gulp copy barf esc unesc html_esc html_unesc rand_str );

sub new {
# --------------------------------------------------
    my $pkg = shift;

    my $opts = shift || {};
    foreach my $k ( keys %$ATTRIBS ) {
        $opts->{$k} ||= $ATTRIBS->{$k};
    }

    my $config_path = $CFG->{config_path};
    unless ( -d $config_path ) {
        mkdir $config_path, 0700
            or die "Could not create path '$config_path' because: $!";
    }

    my $self = bless $opts, $pkg;

    return $self;
}

sub gallery {
# --------------------------------------------------
    my $self = shift;
    return $self->{gallery} ||= do {
        Nikki::Gallery->new;
    };
}

sub account_commit {
# --------------------------------------------------
# Creates the user account setups if required
#
    my ( $self, $args ) = @_;

    my $config_path = $CFG->{config_path};

    my $dir_name = $args->{username} . '_' . $args->{host};
    $dir_name =~ s,\W,_,g;
    my $dir_path = "$config_path/$dir_name";

#    if ( -d $dir_path ) {
#        warn "Config path already exists!";
#    }

# make the base dir and the sub paths
    foreach my $new_path ( 
        $dir_path, 
        "$dir_path/db",      # databases for user lookups
        "$dir_path/events",  # events one file per 
        "$dir_path/pending", # events to be sent to the server
        "$dir_path/data",    # misc data such as photos
    ) {
        mkdir $new_path, 0700;
    }

    my $user_info = $self->load_user or return;
    my $accounts  = $user_info->{accounts} || [];

# ensure sanity
    my @sane_acc_list;
    foreach my $acc ( @$accounts ) {
        next if (
            $acc->{username} eq $args->{username}
            and $acc->{host} eq $args->{host}
        );
        push @sane_acc_list, $acc;
    }

# If there is no settinf for this entry, we will
# treat it as if it is new and if "syncronize"
# is called, will download all pertinant data
# for the user.
    $args->{syncronized} ||= 0;

    push @sane_acc_list, $args;
    $user_info->{accounts} = \@sane_acc_list;

    $self->save_user;
}

sub account_default {
# --------------------------------------------------
# Set the provided account to be the default choice
#
    my ( $self, $account_name ) = @_;

    $account_name or return;
    my $accounts = $self->accounts or return;
    my $account  = $accounts->{$account_name} or return;

    my $user_info = $self->load_user or return;
    my $user_accounts  = $user_info->{accounts} or return;

    foreach my $acc ( @$user_accounts ) {
        if ( "$acc->{username}\@$acc->{host}" eq $account_name ) {
            $acc->{default} = 1;
        }
        else {
            delete $acc->{default};
        }
    }

    $self->save_user;
}

sub account_delete {
# --------------------------------------------------
# Deletes a particular account. Removes all data
# and directories associated to the account. This
# should be ok since aside from pending items (which
# probably don't matter anyways) everything can
# be re-acquired from the remote LJ server
#
    my ( $self, $account_name ) = @_;

    $account_name or return;
    my $accounts = $self->accounts or return;
    my $account  = $accounts->{$account_name} or return;

    ( my $account_dirname = $account_name ) =~ s,\W,_,g;

    my $account_path = $CFG->{config_path} . "/$account_dirname";
    fs_deltree( $account_path );

    my $user_info = $self->load_user or return;
    my $user_accounts  = $user_info->{accounts} or return;

    $user_info->{accounts} = [
        grep {
            "$_->{username}\@$_->{host}" ne $account_name
        } @$user_accounts
    ];

    $self->{_dirty}++;
}

sub account_post {
# --------------------------------------------------
# Post an event to an account. It will first save the
# event as pending. Should the update be successful,
# it will remove the event from the pending queue
#
    my ( $self, $args ) = @_;
    my $pend_save = $self->account_save_pending( $args );
    $args->{draftid} = $pend_save;

# configure the user viewing privileges
    if ( my $sec = lc $args->{security} ) {
        if ( $sec eq "public" ) {
            $args->{security} = "public";
        }
        elsif ( $sec eq "private" ) {
            $args->{security} = "private";
        }
        elsif ( $sec eq "friends" ) {
            $args->{security}  = "usemask";
            $args->{allowmask} = 1;
        }
    }

    my $event = $args->{event} or return $self->error( 'err_reqargs' );

    my ( $acc_name, $account ) = $self->account_selected( $args );
    my $ftp_account = $account->{ftp_account} || '';

# make a copy of the record we can whack
    $args = {%$args};

    my $stats;
    ( $args->{event}, $stats ) = $self->markup(
        $event,
        {
            resource => sub {
            # --------------------------------------------------
                my $attr = shift;
                my $gal  = $self->gallery;
                my $profile    = $gal->image_load_profile( $attr->{gallery_path} ) or return;

                my $tags = {%$profile};

                my $subset_dir;
                unless ( $subset_dir = $args->{subset_dir} ) {
                    $subset_dir = $args->{subset_dir} = $gal->ftp_subset_dir({ 
                        account     => $ftp_account,
                        auto_select => 1
                    });
                    $self->account_save_pending( $args );
                }

                my ( $acc_name, $account ) = $gal->account_selected({
                    account     => $ftp_account,
                    auto_select => 1
                });

                $acc_name or warn "No accounts found";

                $tags->{thumbnail_url} = $tags->{accounts}{$acc_name}{thumbnail_url};
                $tags->{main_url}      = $tags->{accounts}{$acc_name}{main_url};
                $tags->{page_url}      = $account->{url} . $subset_dir . "/$tags->{base_name}.html";

                @$tags{ keys %$attr } = values %$attr;
                my $out = Nikki::Template->parse(
                    $STR->entry( 'gal_embed_resource' ),
                    'gal_embed_resource',
                    $tags
                ) or warn Nikki::Template->error;
                return $out;
            }
        }
    );

# IF the user has asked to upload some images, do so
    if ( $stats and @{$stats->{gallery}||[]}) {
        my @image_list;
        my $imgs = $stats->{gallery};
        foreach my $img ( grep $_, @$imgs ) {
            push @image_list, $img->{gallery_path};
        };
        my $gal = $self->gallery or return; # huh? Why can't I do this?

        my ( $acc_name, $acc ) = $gal->account_selected({
            account => $ftp_account,
            auto_select => 1
        }) or return;

        my $subset_info = {%$args};
        $subset_info->{images} = \@image_list;
        $subset_info->{account} = $acc_name;

        $gal->ftp_upload_subset( $subset_info ) 
            or return $self->error( 
                $gal->error || 'Unknown Error'
            );
    }

    my @t = localtime;
    $t[5] += 1900; $t[4]++;
    my @n = qw( junk min hour day mon year );
    foreach my $i ( 1..5 ) {
        last if exists $args->{$n[$i]};
        $args->{$n[$i]} = $t[$i];
    }

    my $result = $self->request( $args, "postevent" ) or return;
    $self->account_delete_pending( $args ) or do {
        $self->error( "$!" );
        return
    };
    return 1;
}

sub account_editevent {
# --------------------------------------------------
# Does the same thing as account post except for 
# editing a previous entry, It will like the
# post method, store a version of the file as pending
# just in case something goes wrong
#
    my ( $self, $args ) = @_;
    my $pend_save = $self->account_save_pending( $args );
    $args->{draftid} = $pend_save;

    my $result = $self->request( 
        $args,
        'editevent',
        [qw(
            itemid 
        )]
    ) or return;

    $self->account_delete_pending( $args ) or do {
        $self->error( "$!" );
        return
    };
    return 1;
}

sub account_save_pending {
# --------------------------------------------------
# upon success retuns the key to the new
# event that was saved
#
    my ( $self, $args ) = @_;

    my ( $acc_name, $account ) = $self->account_selected( $args );

    ( my $path_dir = $acc_name ) =~ s,\W,_,g;
    my $db_path = $CFG->{config_path} . "/$path_dir/pending";

    my $draftid;

    unless ( $draftid = $args->{draftid} ) {
        do { 
            $draftid = rand_str() 
        } while ( -f "$db_path/$draftid" );
    }

    require Symbol;
    my $fh = Symbol->gensym;
    my $fpath = $db_path . "/" . $draftid;
    open $fh, ">$fpath";
    my $buf = encode( $args );
    print $fh $buf;
    close $fh;

    return $draftid;
}

sub account_list_pending {
# --------------------------------------------------
# Returns a list of all the pending items that 
# must be committed to the remote server. It lumps
# both edit pending and add pending together so beware
# when using this function. 
#
    my ( $self, $args ) = @_;

    my ( $acc_name, $account ) = $self->account_selected( $args );

    ( my $path_dir = $acc_name ) =~ s,\W,_,g;
    my $db_path = $CFG->{config_path} . "/$path_dir/pending";

    my @pending_items;
    require Symbol;
    my $dh = Symbol->gensym;
    opendir $dh, $db_path;
    while ( my $fentry = readdir $dh ) {
        next unless $fentry =~ m,^\w+$,;
        my $buf = '';
        my $fh = Symbol->gensym;
        open $fh, "<$db_path/$fentry";
        {
            local $/;        
            $buf = <$fh>;
        }
        my $pending_rec = decode( $buf );
        $pending_rec->{fentry} = $fentry;
        $pending_rec->{mtime} = ( stat( $fh ) )[9];
        push @pending_items, $pending_rec;

        close $fh;
    }
    close $dh;

    return [
        sort { $a->{mtime} <=> $b->{mtime}  } @pending_items
    ];
}

sub account_load_pending {
# --------------------------------------------------
# Load a draft item from the given account
#
    my ( $self, $args ) = @_;

    my ( $acc_name, $account ) = $self->account_selected( $args );

    my $draftid = $args->{draftid} or return;
    $draftid =~ s,\W,,g;
    $draftid or return;

    ( my $path_dir = $acc_name ) =~ s,\W,_,g;
    my $db_path = $CFG->{config_path} . "/$path_dir/pending/$draftid";

    return unless -f $db_path;

    my $buf = '';
    require Symbol;
    my $fh = Symbol->gensym;
    open $fh, "<$db_path";
    {
        local $/;
        $buf = <$fh>;
    }
    close $fh;

    my $rec = decode( $buf );

    return $rec;
}

sub account_delete_pending {
# --------------------------------------------------
# Delete a previous post that has not yet been
# committed to the server
#
    my ( $self, $args ) = @_;

    my ( $acc_name, $account ) = $self->account_selected( $args );

    ( my $path_dir = $acc_name ) =~ s,\W,_,g;
    my $db_path = $CFG->{config_path} . "/$path_dir/pending";

    unlink "$db_path/$args->{draftid}";
}

sub account_sync {
# --------------------------------------------------
# This syncronizes the information on the local client
# side to what is on the server. Information includes
# moods, entries and calendar events
#
# If there has never been a sync called on an account, 
# it simply import all the required information.
#
# At the end of the entire process, event information 
# will be indexed so keyword searching can be 
# accomplished
#
    my ( $self, $args ) = @_;

    my $prog_func = delete $args->{progress};

    my ( $acc_name, $account ) = $self->account_selected( $args );

    $account->{last_sync} and $args->{lastsync} = $account->{last_sync};

    if ( $prog_func ) {
        $prog_func->( 0, $STR->entry( "app_sync_start" ) );
    }

# Try to get all mood icons and etc
    my $moods       = $account->{moods} || {};
    my $top_mood    = 0;
    foreach my $i ( keys %$moods ) {
        $i > $top_mood and $top_mood = $i;
    }
    my $res = $self->login({
        account      => $acc_name,
        getmoods     => $top_mood,
        getmenus     => 1,
        getpickws    => 1,
        getpickwurls => 1,
    }) or return;

# First find what items need to be Synced
    my ( $rec, @sync_items );

    do {

        $rec = $self->request(
            $args,
            'syncitems',
        ) or return;

        my $sync_count = $rec->{sync_count};

        foreach my $i ( 1..$sync_count ) {
            my ( $type, $itemid ) = $rec->{"sync_${i}_item"} =~ m,(.)\-(\d+),;
            push @sync_items, {
                type   => $type,
                itemid => $itemid,
                time   => $rec->{"sync_${i}_time"},
                action => $rec->{"sync_${i}_action"}
            };
        }

        @sync_items and $args->{lastsync} = $sync_items[$#sync_items]{time}

    } until ( $rec->{sync_total} == $rec->{sync_count} );

    $self->dirty;

    if ( $account->{syncronized} ) {

# Now, sync the items that must be updated/downloaded
        my %downloaded;
        my $i = 0;
        foreach my $r ( @sync_items ) {

            $r->{type} eq 'L' or next;
            my $id = $r->{itemid};

            if ( $prog_func ) {
                $i++ % 10 or do {
                    my $percent = int( ( $i / @sync_items ) * 50 );
                    $prog_func->( $percent, $STR->string( app_sync_item => $id ) );
                };
            }

            $downloaded{$id}++ and next;
            $self->getevents({
                itemid        => $id,
                account       => $acc_name,
                noprops       => 0,
                prefersubject => 0,
                selecttype    => 'one',
            });

            $account->{last_sync} = $r->{'time'};
        };
    }

# If the system has never been syncronized before, we'll
# download things in the fastest way possible, by downloading
# multiple items at the same time
    else {
        $self->account_import({
            account => $acc_name,
            progress => sub { 
            # --------------------------------------------------
                my ( $percent, $message ) = @_;
                $prog_func->( int( ( $percent / 2 ) + 50 ), $message );
            },
        }) or return;

# we have now successfully acquired all available entries
        $account->{syncronized} = 1; 

        @sync_items and $account->{last_sync} = $sync_items[$#sync_items]{'time'};
    }

    $self->db_reindex({
        account => $acc_name,
        progress => sub { 
        # --------------------------------------------------
            my ( $percent, $message ) = @_;
            $prog_func->( int( ( $percent / 2 ) + 50 ), $message );
        },
    });

    $rec = {
        count       => $rec->{sync_count},
        total       => $rec->{sync_total},
        update_list => \@sync_items,
    };

    $prog_func and $prog_func->( 0, $STR->entry( "app_sync_reindex_start" ) );

    $self->save_user;

    return $rec;
}

sub account_import {
# --------------------------------------------------
# Import all the pertinant data for a user on the 
# very first run. this prevents multiple redundant
# accesses to the host when a single one will do. 
# (and helps us not get blacklisted ;)
#
    my ( $self, $args ) = @_;
    my ( $acc_name, $account ) = $self->account_selected( $args );

# Acquire all the user's entries. Does not reindex the database
    my $last_date;
    while (1) {
        my $get_opts = {
            selecttype => 'lastn',
            howmany    => 50,
            account    => $acc_name
        };
        $last_date and $get_opts->{beforedate} = $last_date;
        my $res = $self->getevents( $get_opts ) or return;
        keys %$res < 50 and last;
        $last_date = ( sort map { $_->{eventtime} } values %$res )[0];
    }

    return 1;
}

sub account_selected {
# --------------------------------------------------
# Return the name of the account as well as the 
# account variables associated. This is just
# shorthand for choosing which account to operate
# upon and unifies the interface
#
    my ( $self, $args ) = @_;

    my $acc_name = $args->{account}       or return;
    my $accounts = $self->accounts        or return;
    my $account  = $accounts->{$acc_name} or return;

    return ( $acc_name => $account );
}

sub accounts {
# --------------------------------------------------
# Returns a list of all the accounts availble on
# the system
#
    my $self = shift;
    my $user_info = $self->load_user       or return;
    my $accounts  = $user_info->{accounts} or return;
    my %account_lookup;
    my $i = 1;
    foreach my $acc ( @$accounts ) {
        $acc->{order} = $i++;
        $account_lookup{ "$acc->{username}\@$acc->{host}" } = $acc;
    }
    return \%account_lookup;
}

sub load_user {
# --------------------------------------------------
# Load all the user information. Nothing special here
#
    my $self = shift;

    if ( @_ ) {
        delete $self->{user_info}
    }

    $self->{user_info} ||= do {
        my $user_info;
        my $home_path = $CFG->{config_path};

        if ( -d $home_path ) {
            if ( -f "$home_path/nikki.cfg" ) {
                require Symbol;
                my $fh = Symbol->gensym;
                open $fh, "$home_path/nikki.cfg";
                {
                    local $/;
                    my $buf = <$fh>;
                    $user_info = decode( $buf );
                }
                close $fh;
            }
        }
        else {
        }

        unless ( $user_info ) {
            $user_info = {};
            $self->{_dirty}++;
        }

        $user_info;
    }
}

sub save_user {
# --------------------------------------------------
# Save all the user information. Nothing special here
#
    my $self = shift;

    if ( $self->{user_info} ) {
        require Symbol;
        my $fh = Symbol->gensym;
        my $home_path = $CFG->{config_path};
        open $fh, ">$home_path/nikki.cfg";
        my $buf = encode( $self->{user_info} );
        print $fh $buf;
        close $fh;
        $self->{_dirty} = 0;
    }
}

sub dirty {
# --------------------------------------------------
# You dirty scoundrel! If this is called, when
# this object is DESTROYED it will ensure that all
# information is saved.
#
    my $self = shift;
    $self->{_dirty}++;
}

sub error {
# --------------------------------------------------
# Loads the local error interface.
#
    my $self = shift;
    if ( @_ ) {
        push @$ERROR, $STR->string( @_ );
        return;
    }
    my $err = $ERROR;
    $ERROR = [];
    return wantarray ? @$err : $err;
}

sub account_test {
# --------------------------------------------------
# Attempts to login to the remote server to ensure
# that the user's login/password are correct
#
    my ( $self, $args ) = @_;
    my $opts = {
        account_data => {
            username => $args->{username},
            password => $args->{password},
            host     => $args->{host},
            port     => $args->{port},
            path     => $args->{path},
        },
    };

    my $res = $self->request( $opts, 'login' );
    return $res;
}

sub login {
# --------------------------------------------------
# Login to LJ is an interesting action. Not only
# does it tell you if you have access to 
# a server, but will also tell you extra information
# such as moods, shared journals you have access
# to and so on. Since the format all information is
# returned is flat, this will take the returned 
# information and convert it into a datastruture
# that may be easier to use.
#
    my ( $self, $args ) = @_;

    my $prog_func = delete $args->{progress};

    my ( $acc_name, $account ) = $self->account_selected( $args );

    my $result = $self->request( 
        $args,
        'login'
    ) or return;

    $account->{name} = $result->{name};

# accessible journals
    my $ac = $result->{access_count};
    my @access_journals;
    foreach ( 1 .. $ac ) {
        push @access_journals, $result->{"access_$_"};
    }
    $account->{access_journals} = \@access_journals;

# Friend groups
    my $gc = $result->{frgrp_maxnum};
    my %groups;
    foreach ( 1 .. $gc ) {
        exists $result->{"frgrp_${_}_name"} or next;
        $groups{$result->{"frgrp_${_}_name"}} = $result->{"frgrp_${_}_sortorder"};
    }

    $account->{friend_groups} = [ 
        sort { $groups{$a} <=> $groups{$b} } keys %groups 
    ];
    
# Pictures
    if ( my $pic_count = $result->{pickw_count} || 0 ) {
        my %pictures;
        foreach ( 1..$pic_count ) {
            my $k = $result->{"pickw_$_"};
            my $v = $result->{"pickwurl_$_"} || '';
            $pictures{$k} = $v;
        }
        $account->{pictures} = \%pictures;
    }

# Moods
    if ( exists $result->{mood_count} ) {
        my %moods;
        foreach my $i ( 1..$result->{mood_count} ) {
            $moods{$result->{"mood_${i}_id"}} = $result->{"mood_${i}_name"}
        }
        $account->{moods} = \%moods;
    }

    $self->dirty;

    return $account;
}

sub checkfriends {
# --------------------------------------------------
# Returns a true value if there are new entries.
# Once a new entry is reported, a "force" must
# be run to ensure that the server is polled again.
#
    my ( $self, $opts ) = @_;

    unless ( $opts->{force} ) {
        return 1 if $self->{_lu_newentries};
    }

    unless ( $self->{_lu_interval} <= time ) {
        return $self->{_lu_newentries};
    }

    $self->{_lastupdate} and $opts->{lastupdate} = $self->{lastupdate};
    $opts->{mode} = 'checkfriends';

    my $result = $self->request( $opts );

    unless ( $result and $result->{success} eq 'OK' ) {
        return;
    }

    $self->{_lu_interval} = $result->{interval} + time;

    return $self->{_lu_newentries} = $result->{new};
}

sub editfriendgroups {
# --------------------------------------------------
    my ( $self, $opts ) = @_;

    my $result = $self->request( 
        $opts, 
        'editfriendgroups',
        [qw( 
            editfriend_groupmask_friend 
            efg_delete_groupnum 
            efg_set_groupnum_name 
            efg_set_groupnum_sort 
        )]
    );

    return $result;
}

sub editfriends {
# --------------------------------------------------
    my ( $self, $opts ) = @_;

    my $result = $self->request( 
        $opts, 
        'editfriends',
        [qw( 
            editfriend_delete_user
            editfriend_add_i_user
        )]
    );

    return $result;
}

sub friendof {
# --------------------------------------------------
    my ( $self, $opts ) = @_;

    my $result = $self->request( $opts, 'friendof' );

    return $result;
}

sub getdaycounts {
# --------------------------------------------------
# This returns a hashed up list of all the users'
# post in the format
# $cal->{year}{mon}{day} = number of posts
# Since this function can take a while, unless
# force is called, it will limit itself to one call
# per session.
#
    my ( $self, $opts ) = @_;

    my $acc_name = $opts->{account}      or return;
    my $accounts = $self->accounts       or return;
    my $account  = $accounts->{$acc_name} or return;

    ( my $path_dir = $acc_name ) =~ s,\W,_,g;
    my $db_path = $CFG->{config_path} . "/$path_dir/db";


    $self->{_daycounts}{$acc_name} = undef if $opts->{force};

    return $self->{_daycounts}{$acc_name} ||= do { 

        my $calendar;

        COUNT_RESOLVE: {

            require Symbol;
            my $fh = Symbol->gensym;

            unless ( $opts->{force} ) {
                if ( -f $db_path . '/daycounts.xml' ) {
                    open $fh, "<$db_path/daycounts.xml";
                    {
                        my $buf;
                        local $/;
                        $buf = <$fh>;
                        $calendar = decode( $buf );
                    };
                    close $fh;
                    last;
                }
            }

            my $result = $self->request( $opts, 'getdaycounts' );

            foreach my $e ( keys %$result ) {
                next unless $e =~ m,^(\d\d\d\d)-(\d\d)-(\d\d)$,;
                $calendar->{int $1}{int $2}{int $3} = $result->{$e};
            }

# store the daycounts
            ( my $path_dir = $acc_name ) =~ s,\W,_,g;
            open $fh, ">$db_path/daycounts.xml" or die $!;
            my $buf = encode( $calendar || {} ); 
            print $fh $buf;
            close $fh;

        }

        $calendar;
    }
}

sub getevents {
# --------------------------------------------------
# This gets events for a span of time. This does
# cause a request to the server, it is usually
# better to use cached_getevent since it will be faster
# and will automatically call this function if required
#
# This returns a hashref indexed by eventid of events 
# found
#
    my ( $self, $opts ) = @_;

    my $result = $self->request( 
        $opts, 
        'getevents'
    ) or return;
        
    my %events;
    foreach my $i ( 1..$result->{events_count} ) {
        my $got_event = {};

        @$got_event{qw(
            itemid
            eventtime
            event
            security
            allowmask
            subject
        )} 

        = map {$_||''} 

        @$result{map { "events_${i}_$_" } qw{
            itemid
            eventtime
            event
            security
            allowmask
            subject
        }};

        $got_event->{props} = {};
        $events{$got_event->{itemid}} = $got_event;
    }

    my %properties;
    foreach my $i ( 1..$result->{prop_count} ) {
        my $itemid = $result->{"prop_${i}_itemid"};
        $events{$itemid}{props}{$result->{"prop_${i}_name"}} = $result->{"prop_${i}_value"}
    }
    my $acc_name = $opts->{account};
    $acc_name =~ s,\W,_,g;

    require Symbol;

    my $events_path = $CFG->{config_path} . "/$acc_name/events";

    foreach my $itemid ( keys %events ) {

        my $event = $events{$itemid};

        my $buf = encode( $event );
        my $fh = Symbol->gensym;
        open $fh, ">$events_path/$itemid" or die $!;
        print $fh $buf;
        close $fh;

    }

    return \%events;
}

sub cached_getevent {
# --------------------------------------------------
# Pull event from database if possible. If not available
# do a manual request and store the result before returning
# it
#
    my ( $self, $opts ) = @_;

    my $acc_name = $opts->{account}      or return;
    my $accounts = $self->accounts       or return;
    my $account  = $accounts->{$acc_name} or return;

    my %ranked_results;

    ( my $path_dir = $acc_name ) =~ s,\W,_,g;
    my $events_path = $CFG->{config_path} . "/$path_dir/events";

    my $record;

    require Symbol;

    if ( my $itemid = $opts->{itemid} ) {

        if ( -f "$events_path/$itemid"  ) {
            my $fh = Symbol->gensym;
            open $fh, "<$events_path/$itemid";
            my $buf;
            {
                local $/;
                $buf = <$fh>;
            }
            $record = decode( $buf );
            close $fh;
        }

        unless ( $record ) {

            my $result = $self->getevents({
                prefersubject => 0,
                account       => $acc_name,
                noprops       => 0,
                selecttype    => 'one',
                itemid        => $itemid
            }) or return;

            $record = $result->{$itemid};

        }

    }

    $record->{event} and $record->{event} =~ s,\r,,g;
    
    return $record;
}

sub syncitems {
# --------------------------------------------------
# Edit or delete a user's past journal entry
#
    my ( $self, $opts ) = @_;

    my $result = $self->request( 
        $opts,
        'syncitems'
    );

    return $result;
}

sub entry_template {
# --------------------------------------------------
# Loads a templated entry. This lets users do special
# things such as add special formatting to each entry 
# that normally would be a manual operation
#
    my ( $self, $t ) = @_;

# locate the template file we want to use.
    my $template_path = $CFG->{config_path} . '/templates/';
    if ( $t and -f $template_path . $t ) {
        $template_path .= $t;
    }
    elsif ( $template_path . 'default.template' ) {
        $template_path .= 'default.template';
    }
    else { return }

    return unless -f $template_path;

# slurp the template file into memory
    require Symbol;
    my $fh = Symbol->gensym;
    open $fh, "<$template_path" or return;
    my $buf = '';
    {
        local $/;
        $buf = <$fh> || '';
    }
    close $fh;

# execute the template parse upon it
    my $vars = {
        timestamp => scalar localtime,
    };

    $buf =~ s/
                (%%)
                |
                %(\!?)(.+?)%
            /
                $1 ? '%' 
                   : $2 ? `$3` 
                        : $vars->{$3} || ''
            /gex;

    return $buf;
}

sub request {
# --------------------------------------------------
# Hits up the remote LJ server foor more information.
#
    my ( $self, $opts, $mode, $req ) = @_;

    my $acc = $opts->{account_data};

    my $acc_name;
    unless ( $acc ) {
        ( $acc_name, $acc ) = $self->account_selected( $opts ) 
            or return $self->error( "No Accounts Configured" );
    }

    $opts         ||= {};

    $opts->{mode} ||= $mode or return;

    $opts->{clientversion} = 'WxPerl-Nikki/'.$VER;
    $opts->{lineendings}   = "\n";
    $opts->{user}          = $acc->{username};
    $opts->{ver}           = 1;

    if ( $req ) {
        foreach ( @$req ) {
            next if $opts->{$_};
            return $self->error( err_missing_key => $_  );
        }
    }

# try to use the more secure MD5 hash of the password
# if the Digest::MD5 module is available
    my $hpassword = '';
    eval {
        require Digest::MD5;
        $hpassword = Digest::MD5::md5_hex( $acc->{password} );
    };

    if ( $hpassword and !$@ ) {
        $opts->{hpassword} = $hpassword;
    }
    else {
        $opts->{password} = $acc->{password};
    }

    $opts->{lineendings} ||= "\r\n";

    my $fh = IO::Socket::INET->new(
        PeerAddr => $acc->{host},
        PeerPort => $acc->{port},
        Proto    => 'tcp',
    ) or return $self->error( err_cantconnect => "$acc->{host}:$acc->{port}", "$@" );

    my $buf  = join "&", map {
        esc( $_ ) . "=" . esc( $opts->{$_} )
    } keys %$opts;

    my $clen = length $buf;

    my $le = "\r\n";
    print $fh 
        "POST $acc->{path} HTTP/1.0$le"
      . "Host: $acc->{host}$le"
      . "Content-type: application/x-www-form-url-encoded$le"
      . "Content-length: $clen$le"
      . $le
      . $buf
      . $le;

# slurp the data. tsk tsk tsk, not good. bad boy. oh well
    {
        local $/;
        $buf = <$fh>;
    };

# strip out the httpd headers
    $buf =~ s,^.*\r?\n\r?\n,,s;

    my @reply_hacked = split /\r?\n/, $buf;
    my %result;

    for ( my $i = 0; @reply_hacked > $i ; $i += 2 ) {
        my ( $key, $val ) = ( @reply_hacked[$i,$i+1] );
        $result{$key} = unesc( $val );
    }

    unless ( $result{success} eq 'OK' ) {
        return $self->error( err_requestfail => $opts->{mode}, $result{errmsg} );
    }

    return \%result;
}

sub db_reindex {
# --------------------------------------------------
# builds the fast retreival index for searches based
# on date
#
# Record structure:
#
#  [ YEAR MON DAY HOUR MIN SEC ID ]
#
    my ( $self, $args ) = @_;

    my $prog_func = $args->{progress};
    my ( $acc_name, $account ) = $self->account_selected( $args );

    my %ranked_results;

    ( my $path_dir = $acc_name ) =~ s,\W,_,g;

    require Symbol;

    my $dh = Symbol->gensym;
    my $fh = Symbol->gensym;
    my $events_path = $CFG->{config_path} . "/$path_dir/events";
    opendir $dh, $events_path;
    my @lookup_index;

# Iterate through all the records while making the index
    my @fevents;
    while ( my $fevent = readdir $dh ) {
        next unless $fevent =~ m,^\d+$,;
        push @fevents, $fevent;
    };

    my $cnt = 0;
    my $per = 0;
    my $maxl = $CFG->{index_max_letters};
    my $minl = $CFG->{index_min_letters};

    my %word_info;
    my %calendar;

    foreach my $fevent ( @fevents ) {
        my $data_path = "$events_path/$fevent";

        $cnt++ % 10 or do {
            if ( $prog_func ) {
                $prog_func->(
                    int( ( $cnt / @fevents ) * 100 ),
                    $STR->string( app_sync_reindex => $cnt )
                );
            }
        };

        my $buf;
        open $fh, "<$data_path";
        {
            local $/;
            $buf = <$fh>;
        }
        close $fh;

        my $rec = decode( $buf );

# get the daycounter
        my ( $year, $mon, $day ) = map {int} $rec->{eventtime} =~ m,^(\d\d\d\d)-(\d\d)-(\d\d),;
        $calendar{$year}{$mon}{$day}++;

# get the consolidated text
        my $base_text = lc ( $rec->{event} . ' ' . $rec->{subject} );

# strip out html tag content
        $base_text =~ s/
            <(?: 
                [^">]|(["'])+(?:[^\1>]|\1)*?\1+?
            )*?>
        //gxs;

# tokenize into words
        my @words = grep { 
                my $i = length($_); 
                $i >= $minl and $i <= $maxl 
            } split /[^\w]+/, $base_text;

# take the words and count them 
        my %word_count;
        foreach my $w ( @words ) {
            $word_count{$w}++;
        }

        foreach my $w ( keys %word_count ) {
            $word_info{$w} ||= '';
            $word_info{$w} .= pack "LL", $fevent, $word_count{$w};
        }

        my @lookup_data = $rec->{eventtime} =~ m,(\d+),g;
        my $new_lookup_entry = [
            @lookup_data[0..5], $fevent, sprintf( "%04i-%02i-%02i %02i%02i%02i", @lookup_data[0..5] )
        ];
        push @lookup_index, $new_lookup_entry
    }
    closedir $dh;

# save the indexes
    my $datedb_path = $CFG->{config_path} . "/$path_dir/db/journal_events.dates";

    open $fh, ">$datedb_path";
    foreach my $item ( sort { $a->[7] cmp $b->[7] } @lookup_index ) {
        my $entry = pack( "L*", @$item[0..6] );
        print $fh $entry;
    }
    close $fh;

    my $datecount_path = $CFG->{config_path} . "/$path_dir/db/daycounts.xml";
    open $fh, ">$datecount_path";
    my $buf = encode(\%calendar);
    print $fh $buf;
    close $fh;

    my $indexdb_path = $CFG->{config_path} . "/$path_dir/db/journal_events.wordndx";
    my $datadb_path  = $CFG->{config_path} . "/$path_dir/db/journal_events.data";

    my $nh = Symbol->gensym;
    open $nh, ">$indexdb_path";
    open $fh, ">$datadb_path";
    my $fmt = '%-' . $maxl . 's';
    foreach my $w ( sort keys %word_info ) {
        printf $nh $fmt, $w;
        print $nh ( pack "LL", tell( $fh ), length( $word_info{$w} ) );
        print $fh $word_info{$w};
    }
    close $fh;
    close $nh;
}

sub db_query {
# --------------------------------------------------
# return a list of the itemids 
#
    my ( $self, $opts ) = @_;

    my $acc_name = $opts->{account}      or return;
    my $accounts = $self->accounts       or return;
    my $account  = $accounts->{$acc_name} or return;

    my %ranked_results;

    ( my $path_dir = $acc_name ) =~ s,\W,_,g;
    my $db_path = $CFG->{config_path} . "/$path_dir/db";

    require Symbol;

# search journal events by keyword
    if ( my $keywords = lc $opts->{keywords} ) {

        my $minl = $CFG->{index_min_letters};
        my $maxl = $CFG->{index_max_letters};

        my $nh = Symbol->gensym;
        my $dh = Symbol->gensym;

        open $nh, "$db_path/journal_events.wordndx";

        binmode $nh;

        my $entry_l = $maxl + length( pack "LL", 0, 0 );
        my $top_b   = ( ( -s $nh ) / $entry_l ) - 1;
        my $start_i = int( $top_b / 2 );

        $start_i = 100;

        my %fetch_cache;
        my $fetch_word_index = sub {
        # --------------------------------------------------
            my $word = shift;
            my $ub   = $top_b;
            my $lb   = 0;
            my $i    = $start_i;

            while (1) {
                my $rec = $fetch_cache{$i} ||= do {
                    my $ipos = $entry_l * $i;
                    seek $nh, $ipos, 0;
                    my $buf;
                    read $nh, $buf, $entry_l;
                    my $word = substr $buf, 0, $maxl, '';

                    my ( $ndxi, $ndxl ) = unpack( "LL", $buf );

                    $word =~ s,\s+$,,g;

                    {
                        word  => $word,
                        ndx_i => $ndxi,
                        ndx_l => $ndxl
                    };
                };

                unless ( my $r = $word cmp $rec->{word} ) {
                    return $rec;
                }
                elsif ( $r > 0 ) {
                    $lb = $i;
                }
                else {
                    $ub = $i;
                }

                return if $ub == $lb;

                my $p = int( ( $ub + $lb ) /  2 );
                if ( $i == $p ) { return; }
                $i = $p;
            }
        };

        my %buckets;
        foreach my $kw ( $keywords =~ m,([-+]?\w+),g ) {
            my $l = length( $kw );
            next if $l < $minl or $l > $maxl;

            my $p = substr( $kw, 0, 1 ) || '';
            if ( $p eq "+" ) {
                substr $kw, 0, 1, '';
                my $rec = $fetch_word_index->( $kw ) or return; # optimization
                push @{$buckets{'and'}}, $rec;
            }
            elsif ( $p eq "-" ) {
                substr $kw, 0, 1, '';
                my $rec = $fetch_word_index->( $kw ) or next;
                push @{$buckets{'not'}}, $rec;
            }
            else {
                my $rec = $fetch_word_index->( $kw ) or next;
                push @{$buckets{'or'}}, $rec;
            }
        };

        close $nh;

        open $dh, "$db_path/journal_events.data";
        binmode $dh;

        my $fetch_word_data = sub {
        # --------------------------------------------------
            my $word = shift;
            seek $dh, $word->{ndx_i}, 0;
            my $buf;
            read $dh, $buf, $word->{ndx_l};
            my %data = ( unpack "L*", $buf);
            return \%data; 
        };

        if ( $buckets{'or'} ) {
            foreach my $or_entry ( @{$buckets{'or'}} ) {
                my $results = $fetch_word_data->( $or_entry ) or next;
                foreach my $id ( keys %$results ) {
                    $ranked_results{$id} += $results->{$id};
                }
            }
        }

        if ( $buckets{'and'} ) {
            foreach my $and_entry ( @{$buckets{'and'}} ) {
                my $results = $fetch_word_data->( $and_entry ) or return;
                foreach my $id ( keys %ranked_results ) {
                    if ( $results->{$id} ) {
                        $ranked_results{$id} += $results->{$id};
                    }
                    else {
                        delete $ranked_results{ $id };
                    }
                }
                return unless keys %ranked_results;
            }
        }

        if ( $buckets{'not'} ) {
            foreach my $not_entry ( @{$buckets{'not'}} ) {
                my $results = $fetch_word_data->( $not_entry ) or return;
                foreach my $id ( keys %$results ) {
                    delete $ranked_results{$id};
                }
            }
        }


        close $dh;
    }

    if ( $opts->{"date-le"} or $opts->{"date-ge"} ) {

        my $dh = Symbol->gensym;
        my $datedb_path = "$db_path/journal_events.dates";
        open $dh, "<$datedb_path";
        my $upper_bound = int( ( -s $datedb_path ) / $DATEENTRY_SIZE ) - 1;
        my $lower_bound = 0;

        my %date_lookup;
        my $fetch_index = sub {
        # --------------------------------------------------
            my $i = shift;
            return $date_lookup{$i} ||= do {
                seek $dh, $DATEENTRY_SIZE * $i, 0;
                my $buf;
                read( $dh, $buf, $DATEENTRY_SIZE ) or die $!;
                my @result = unpack "L*", $buf;
                [
                    sprintf( "%04i-%02i-%02i %02i%02i%02i", @result[0..5] ),
                    $result[6]
                ]
            };
        };

# find the lower bound of the date span
        if ( my @startday = ( $opts->{"date-ge"} =~ m,(\d+),g ) ) {
            my $startday = sprintf( "%04i-%02i-%02i %02i%02i%02i", @startday );

            my $my_lower_bound = $lower_bound;
            $lower_bound = $upper_bound;
            my ( $buf, $i );

            if ( ( $startday cmp $fetch_index->($lower_bound)[0] ) > 0 ) {
                return;
            } 
            elsif ( ( $startday cmp $fetch_index->(0)[0] ) < 0 ) {
                $lower_bound = 0;
            }
            else {
                while ( 1 ) {
                    $lower_bound - $my_lower_bound <= 1 and last;
                    $i = int( ( $my_lower_bound + $lower_bound + rand) / 2 );
                    $buf = $fetch_index->( $i )[0];
                    if ( ( $buf cmp $startday ) >= 0 ) {
                        $lower_bound = $i;
                    }
                    else {
                        $my_lower_bound = $i;
                    }
                }
            }
        }

# find the upper bound of the date span
        if ( my @endday = ( $opts->{"date-le"} =~ m,(\d+),g ) ) {
            my $endday = sprintf( "%04i-%02i-%02i %02i%02i%02i", @endday );

            my $my_upper_bound = $upper_bound;
            $upper_bound = $lower_bound;
            my ( $buf, $i );

            if ( ( $endday cmp $fetch_index->($upper_bound)[0] ) < 0 ) {
                return;
            }
            elsif ( ( $endday cmp $fetch_index->($my_upper_bound)[0] ) > 0 ) {
                $upper_bound = $my_upper_bound;
            }
            else {
                while ( 1 ) {
                    $my_upper_bound - $upper_bound <= 1 and last;
                    $i = int( ( $my_upper_bound + $upper_bound + rand) / 2 );
                    $buf = $fetch_index->( $i )[0];
                    if ( ( $buf cmp $endday ) >= 0 ) {
                        $my_upper_bound = $i;
                    }
                    else {
                        $upper_bound = $i;
                    }
                }
            }
        }

        if ( %ranked_results ) {
            my %ok;
            for ( my $i = $lower_bound ; $i <= $upper_bound ; $i++ ) {
                seek $dh, $DATEENTRY_SIZE * $i, 0;
                my $buf;
                read( $dh, $buf, $DATEENTRY_SIZE ) or return;
                my @ev = unpack( "L*", $buf );
                my $itemid = $ev[6];
                if ( $ranked_results{$itemid} ) {
                    $ok{$itemid} = $ranked_results{$itemid};
                    if ( keys %ok == keys %ranked_results ) {
                        last;
                    }
                }

                %ranked_results = %ok;
            }
        }
        else {
            for ( my $i = $lower_bound ; $i <= $upper_bound ; $i++ ) {
                seek $dh, $DATEENTRY_SIZE * $i, 0;
                my $buf;
                read( $dh, $buf, $DATEENTRY_SIZE ) or return;
                my @ev = unpack( "L*", $buf );
                my $itemid = $ev[6];
                $ranked_results{$itemid} = $i;
            }
        }

        close $dh;
    }

    my @result_list;
    foreach my $itemid ( 
        sort { 
            $ranked_results{$b} <=> $ranked_results{$a} 
        } keys %ranked_results 
    ) {
        push @result_list, $self->cached_getevent({ 
            account => $acc_name,
            itemid => $itemid 
        });
    }

    return \@result_list;
}

sub DESTROY {
# --------------------------------------------------
    my $self = shift;
    if ( $self->{_dirty} ) {
        $self->save_user;
    }
}

sub fs_deltree {
# --------------------------------------------------
    my $path = shift;

    require Symbol;
    my $dh = Symbol->gensym;
    opendir $dh, $path;
    while ( my $fentry = readdir $dh ) {
        next if $fentry =~ m,^\.?\.?$,;
        my $fpath = "$path/$fentry";
        if ( -d $fpath ) {
            fs_deltree( $fpath );
        }
        else {
            unlink $fpath;
        }
    }
    close $dh;

    rmdir $path;
}

sub encode {
# --------------------------------------------------
    my $structure = shift;

    return unless ref $structure eq 'HASH';

    my $buf    = '';
    my $indent = 0;
    _encode( \$buf, $structure, $indent );
    return $buf;
}

sub _encode {
# --------------------------------------------------
    my ( $buf, $struct, $indent ) = @_;

    my $s = "  ";

    if ( ref $struct eq 'HASH' ) {
        $$buf .= ( $s x $indent ) . "<hash>\n";

        $indent++;
        foreach my $key ( keys %$struct ) {
            $$buf .= ( $s x $indent ) . "<item>\n";

            $indent++;
            $$buf .= ( $s x $indent ) . "<key>" . html_esc( $key ) . "</key>\n";

            $$buf .= ( $s x $indent ) . "<value>";



            if ( ref $struct->{$key} ) {
                $$buf .= "\n";
                _encode( $buf, $struct->{$key}, $indent + 1 );
                $$buf .= $s x $indent;
            }
            else {
                $$buf .= html_esc( $struct->{$key} || '' );
            }

            $$buf .= "</value>\n";

            $indent--;
            $$buf .= ( $s x $indent ) . "</item>\n";
        }
        $indent--;
           
        $$buf .= ( $s x $indent ) . "</hash>\n";
    }
    elsif ( ref $struct eq 'ARRAY' ) {
        $$buf .= ( $s x $indent ) . "<array>\n";
        $indent++;

        foreach my $item ( @$struct ) {
            $$buf .= ( $s x $indent ) . "<item>";
            $indent++;


            if ( ref $item ) {
                $$buf .= "\n";
                _encode( $buf, $item, $indent + 1 );
                $$buf .= $s x $indent;
            }
            else {
                $$buf .= html_esc( $item );
            }

            $indent--;
            $$buf .= "</item>\n";
        }

        $indent--;
        $$buf .= ( $s x $indent ) . "</array>\n";
    }
    else {
    }
}

sub decode {
# --------------------------------------------------
    my $buf = shift;

    my $structure = {};
    my $i         = 0;
    my $max       = length $buf or return;
    my $state     = 0;
    my ( $val, $tag );

    my ( @items_stack, @tag_stack, $tkey, $tval );
    my $items_stack = [];
    my $item_stack  = [];
    my $key_stack   = [];

    while ( $i < $max ) {

        my $j = index( $buf, '<', $i );
        $j == -1 and return $val;
        my $k = index( $buf, '>', $j );
        $k == -1 and return ">";

        my $v = $j - $i;
        my $temp_val = $v ? html_unesc( substr( $buf, $i, $v ) ) : '';

        $v    = $k - $j - 1;
        $v > 0 and $tag = lc( substr( $buf, $j + 1, $v ) );

        if ( substr( $tag, 0, 1 ) eq '/'  ) {
            my $prev_tag = pop @tag_stack;
            return die "Was expecting $prev_tag. Got $tag instead." unless "/$prev_tag" eq $tag;

            if ( $prev_tag eq 'hash' ) {
                $tval = $val = {};
                foreach my $i ( @$item_stack ) {
                    $val->{$i->[0]} = $i->[1];
                }
                $item_stack = pop @$items_stack;
                $tkey       = pop @$key_stack;
            }
            elsif ( $prev_tag eq 'array' ) {
                $tval = $val = [];
                push @$val, map { $_->[2] } @$item_stack;
                $item_stack = pop @$items_stack;
                $tkey       = pop @$key_stack;
            }
            elsif ( $prev_tag eq 'item' ) {
                push @$item_stack, [
                    $tkey, $tval, $val || $temp_val
                ];

                $tkey = $tval = $val = $temp_val = '';
            }
            elsif ( $prev_tag eq 'key' ) {
                $tkey = $temp_val;
            }
            elsif ( $prev_tag eq 'value' ) {
                $tval ||= $temp_val;
            }

        }
        else {
            push @tag_stack, $tag;

            if ( $tag eq 'hash' ) {
                push @$items_stack, $item_stack;
                $item_stack = [];
                push @$key_stack, $tkey;
            }
            elsif ( $tag eq 'array' ) {
                push @$items_stack, $item_stack;
                $item_stack = [];
                push @$key_stack, $tkey;
            }
        }

        $i = $k + 1;

    }

    return $tval;
}

sub gulp {
# --------------------------------------------------
    my $fpath = shift;
    require Symbol;
    my $fh = Symbol->gensym;
    my $buf;
    open $fh, "<$fpath" or return;
    {
        local $/;
        $buf = <$fh>;
    }
    close $fh;
    return $buf;
}

sub barf {
# --------------------------------------------------
# hehehehe >;}
#
    my ( $fpath, $buf ) = @_;
    require Symbol;
    my $fh = Symbol->gensym;
    open $fh, ">$fpath" or return;
    print $fh $buf;
    close $fh;
    return $fh;
}

sub copy {
# --------------------------------------------------
    my ( $s, $t ) = @_;

    {
        local *SRC;
        local *DEST;
        unless ( open SRC, "<$s" ) {
            warn "Problems opening '$s' for reading due to $!";
            return;
        }
        unless ( open DEST, ">$t" ) {
            warn "Problems opening '$t' for writing due to $!";
            return;
        };

        binmode SRC;
        binmode DEST;

        my $block = (stat(SRC))[11] || 4096;

        my $buf;
        while ( read SRC, $buf, $block ) {
            print DEST $buf;
        }

        close SRC;
        close DEST;
    }
}

sub esc {
# --------------------------------------------------
    my $text = shift;
    $text =~ s/([^a-zA-Z0-9 ])/sprintf "%%%02x", ord($1)/exg;
    $text =~ s/ /\+/g;
    return $text;
}

sub unesc {
# --------------------------------------------------
    my $text = shift;
    $text =~ s,\+, ,g;
    $text =~ s,\%(..),chr(hex($1)),ge;
    return $text;
}

sub html_esc {
# --------------------------------------------------
    my $text = shift;
    $text =~ s/
        ([^\w\s\/\\:"'\.\,\-\(\)\*\=\$\#\@\!\;\_\+\[\]\|\~\`])
    /
        $HTML_ESC->{$1}||sprintf( "&#%x;",ord($1) )
    /gex;
    return $text;
}

sub html_unesc {
# --------------------------------------------------
    my $text = shift;
    $text =~ s/
        &(\#)?(\w+);
    /
        $1 ? chr(hex($2)) : $HTML_UNESC->{"&$2;"}
    /gex;
    return $text;
}

sub rand_str { 
# --------------------------------------------------
    my $len = shift || 10;
    my @chars = ( 'a' .. 'z', 0..9 );
    my $str = join "", map {
        $chars[ int( rand() * @chars ) ];
    } ( 1..$len );
    return $str;
}

sub markup {
# --------------------------------------------------
    $_[0] eq 'Nikki::Client' and shift;
    ref $_[0] and shift;
    my ( $buf, $opts, $dependancies ) = @_;

    $dependancies ||= {};
    $opts         ||= {};
    my $sub_opts = {%$opts};
    $sub_opts->{substr} = 1;

    my @lines  = map { "$_\n" } ( split /\r?\n/, $buf );
    @lines or @lines = $buf;
    my $output = '';


    my $state = {
        type => ''
    };

    my $state_func = sub {
    # --------------------------------------------------
        my $args = $_[1];

        if ( $state->{type} ne $args->{type} ) {
            $_[0] = ( $state->{end} || '' ) . $args->{start} . $_[0];
            $state = {
                type => $args->{type},
                end => $args->{end}
            };
        }
    };

    foreach my $line ( @lines ) { MARKUP_LINE: {

        if ( not $opts->{substr} ) {

# Unordered lists
            if ( $line =~ m,^\s*\*, ) {
                my @hits = ( $line =~ m,\*,g );
                my @escd = ( $line =~ m,\*\*,g );
                my $ast_count = @hits - @escd * 2;

                if ( $ast_count % 2 ) {

                    my $spaces = 0;
                    $line =~ s/
                        (^\s*)\*(.*)
                    /
                        $spaces = length $1;
                        $1 . '<li>' . markup( $2, $sub_opts, $dependancies ) . '<\/li>'
                    /xe;

                    $state_func->( 
                        $line, 
                        { 
                            type  => 'ul', 
                            end => '</ul>', 
                            start => '<ul>' 
                        }
                    );

                    last;
                }
            }

# Numbered lists
            elsif ( $line =~ s/
                        ^(\s*)([\-\#])(.*)
                    /
                        $1 . '<li>' . markup( $3, $sub_opts, $dependancies ) . '<\/li>'
                    /xe ) {

                    $state_func->( 
                        $line, 
                        $2 eq '-' ?
                            { 
                                type => 'ul', 
                                end => '</ul>', 
                                start => '<ul>' 
                            }
                            :
                            { 
                                type => 'ol', 
                                end => '</ol>', 
                                start => '<ol>' 
                            }
                    );

                    last;
            }

# Preformatted
            elsif ( $line =~ s/^([\t\ ]+.*)/ "<pre>" . markup( $1, $sub_opts, $dependancies ) . "<\/pre>"  /ex ) {
                last;
            }

# Recurse up one state
            else {
                $state_func->( 
                    $line, 
                    { 
                        type  => 'basic', 
                        end => '', 
                        start => '' 
                    }
                );
            }

        } # end substr test

# Count the number of quote hits
        my @arhits = $line =~ m,([\*\_\^\~\`])(\1?),g; # `
        my %hits;
        for ( my $i = 0 ; $i < @arhits ; $i+=2 ) {
            my $k = $arhits[$i];
            unless ( $arhits[$i+1] ) {
                $hits{$k}++;
            }
        }

        foreach my $k ( keys %hits ) {
            $hits{$k} = int( $hits{$k} / 2 );
        }

        my %flip_flop;
        $line =~ s/

        # Format Tags
            ([\*\_\~\`])(\1?) 

        # Linking
            | (?:
                (\^\^)
                | \^\s*([^\^]+?)(?:\s*,\s*(.*?))?\s*(?:\^)
              )

        # Don't mess with anything in quotes
            | (
                <
                    (?:
                        [^>]*
                        |
                        (['"]) (?: . | \\\1 )*? (?: \1 | \> )
                    )
                >
              )

        /
            if ( $1 ) {
                if ( $2 ) {
                    $2
                }
                elsif ( $flip_flop{$1} ) {
                    $flip_flop{$1} = 0;
                    $MAPS->{end}{$1};
                }
                elsif ( $hits{$1} ) {
                    $hits{$1}--;
                    $flip_flop{$1} = 1;
                    $MAPS->{start}{$1};
                }
                else {
                    $1
                }
            }
            elsif ( $3 ) {
                '^'
            }
            elsif ( my $title = $4 ) {
                my $attr = $5 || ''; 
                my $url  = $5 || $4;

                if ( $title =~ s,^img\s*$,,i ) {
                    qq`<img src="$url">`;
                }
                elsif ( $title =~ m|^resource\s*$| and $attr ) {

                    $attr =~ m|\s*"([^"]+)"\s*(.*)\s*|;
                    my $gallery_path = $1;
                    $attr = $2;
                    my $attribs = {};
                    if ( $attr  ) {
                        $attribs = {
                            map {
                                m|^\s*(\w+)\s*:\s*(.*)\s*$|;
                                ($1 => $2)
                            } split m|;|, $attr
                        }
                    }

                    $attribs->{gallery_path} = $gallery_path;

                    push @{$dependancies->{gallery}}, $attribs;

                    ( $opts->{resource} ? $opts->{resource}->( $attribs ) : 
                        ( $attribs->{size} || '' ) eq 'main' 
                            ? qq`<img src="$attribs->{thumbnail_url}" width="$attribs->{thumbnail_width}" height="$attribs->{thumbnail_width}">` 
                            : qq`<img src="$attribs->{main_url}" width="$attribs->{main_width}" height="$attribs->{main_width}">` )
                }
                else {
                    ( $opts->{url} ? $opts->{url}->( $url, $title ) : '' ) || qq`<a href="$url">$title<\/a>`;
                }
            }
            elsif ( $6 ) {
                $6
            }
            else {
                ''
            }
        /gex;


    } $output .= $line; }

    $output .= $state->{end} || '';

    return wantarray ? ( $output, $dependancies ) : $output;
}

1;


############################################################
#
package Nikki::Gallery;

use strict;
use Nikki::Config;
Nikki::Client->import( qw/ encode decode gulp barf rand_str copy / );
use vars qw/ $ATTRIBS $ERROR $PROFILE_CACHE /;

$ATTRIBS = {
    base_path        => '',
    gallery_path     => '',
    thumbnail_extent => '100x100',
    main_extent      => '500x500',
};

$ERROR = [];

$PROFILE_CACHE = {};

sub new {
# --------------------------------------------------
    my $pkg = shift;

    my $opts = shift || {};
    foreach my $k ( keys %$ATTRIBS ) {
        $opts->{$k} ||= $ATTRIBS->{$k};
    }

    my $config_path = $CFG->{config_path};
    unless ( -d $config_path ) {
        mkdir $config_path, 0700
            or die "Could not create path '$config_path' because: $!";
    }

    my $self = bless $opts, $pkg;

    $self->{base_path} ||= $CFG->{config_path} . '/gallery' ;

    unless ( -d $self->{base_path} ) {
        mkdir $self->{base_path};
    }

    return $self;
}

sub error {
# --------------------------------------------------
    my $self = shift;
    if ( @_ ) {
        push @$ERROR, $STR->string( @_ );
        return;
    }
    my $err = $ERROR;
    $ERROR = [];
    return wantarray ? @$err : $err;
}

sub accounts {
# --------------------------------------------------
    my $self = shift;
    my $config = $self->load_config;
    my $accounts = $config->{accounts};
    my %account_lookup;
    my $i = 0;
    foreach my $acc ( @$accounts ) {
        $acc->{order} = $i++;
        $account_lookup{ "$acc->{username}\@$acc->{host}" } = $acc;
    }
    return \%account_lookup;
}

sub account_commit {
# --------------------------------------------------
    my ( $self, $profile ) = @_;

    my $config = $self->load_config;

# do an edit if we already hvae this account setup
    my $count;
    if ( my $accounts = $config->{accounts} ) {
        foreach my $i ( 0..$#$accounts ) {
            my $acc = $accounts->[$i];
            next unless 
                $acc->{username} eq $profile->{username}
                    and $acc->{host} eq $profile->{host}
                    and $acc->{port} eq $profile->{port};

            $profile->{order} = $acc->{order};
            splice @$accounts, $i, 1, $profile;
            $self->save_config( $config );
            return $config;
        }
    }

# nope, it doesn't exist in this database so manually add
    push @{$config->{accounts}}, $profile;
    $self->save_config( $config );
    return $config;
}

sub account_delete {
# --------------------------------------------------
    my ( $self, $account_name ) = @_;

    $account_name or return;
    my $accounts = $self->accounts or return;
    my $account  = $accounts->{$account_name} or return;

    ( my $account_dirname = $account_name ) =~ s,\W,_,g;

    my $config = $self->load_config or return;
    my $user_accounts  = $config->{accounts} or return;

    $config->{accounts} = [
        grep {
            "$_->{username}\@$_->{host}" ne $account_name
        } @$user_accounts
    ];

    $self->save_config( $config );
}

sub account_default {
# --------------------------------------------------
    my ( $self, $account_name ) = @_;

    $account_name or return;
    my $accounts = $self->accounts or return;
    my $account  = $accounts->{$account_name} or return;

    my $config = $self->load_config or return;
    my $user_accounts  = $config->{accounts} or return;

    foreach my $acc ( @$user_accounts ) {
        if ( "$acc->{username}\@$acc->{host}" eq $account_name ) {
            $acc->{default} = 1;
        }
        else {
            delete $acc->{default};
        }
    }

    $self->save_config( $config );
}

sub account_test {
# --------------------------------------------------
    my ( $self, $profile ) = @_;

    my $class = $profile->{use_sftp} ? 'Nikki::Client::SFTP' : 'Net::FTP';

    my $ftp;
    if ( $class eq 'Net::FTP' ) {
        require Net::FTP;

        $ftp = $class->new( 
            $profile->{host},

            Port => ( $profile->{port} || 21 ),
    #        Debug => 1 # uncomment to be able to see what's up
        ) or return $self->error( 
            $STR->string( gal_ftp_error => $@ )
        );

    }
    else {
        $ftp = $class->new( 
            $profile->{host},
        ) or return $self->error( 
            $STR->string( gal_ftp_error => $@ )
        );
    }

    $ftp->login( 
        ( $profile->{username} or return $self->error( 
            $STR->entry( 'gal_ftp_username' )
        ) ),
        ( $profile->{password} or return $self->error( 
            $STR->entry( 'gal_ftp_password' )
        ) )
    ) or return $self->error( 
        $STR->entry( 'gal_ftp_login' )
    );

    $ftp->binary; # don't worry about it too much

    my $test_data = encode({
        message => 'Hello World!',
    });

    my $test_fh = Nikki::Gallery::File->new( \$test_data );
    my $cwd     = $profile->{path} ? $profile->{path} . '/' : '';

    $ftp->put(
        $test_fh,
        $cwd . 'nikki_upload_test.txt'
    ) or return $self->error( 'gal_ftp_put' );

    $ftp->delete( $cwd . 'nikki_upload_test.txt' )
        or return $self->error( 'gal_ftp_delete' );

    $ftp->quit;

    return 1;
}

sub load_config {
# --------------------------------------------------
    my $self = shift;
    my $base_info_path = $self->{base_path} . '/info.dat';

    my $info = {};

    if ( -f $base_info_path ) {
        my $buf = gulp( $base_info_path ) or return;
        $info = decode( $buf ) or return;
    }

    return $info;
}

sub save_config {
# --------------------------------------------------
    my ( $self, $profile ) = @_;

    my $buf = encode( $profile );

    my $base_info = $self->{base_path} . '/info.dat';
    barf( $base_info, $buf ) or return;

    return $profile;
}

sub image_list {
# --------------------------------------------------
    my ( $self, $path ) = @_;
    
    $path ||= $self->{gallery_path};
    my $content_dir = $self->{base_path} . '/'.  $path;
    my $gal_info;

    if ( -f "$content_dir/info.dat" ) {
        my $buf = gulp( "$content_dir/info.dat" );
        $gal_info = decode( $buf );
    }
    $gal_info ||= {};


    my %content_items;

    require Symbol;
    my $dh = Symbol->gensym;
    opendir $dh, $content_dir;
    while ( my $fentry = readdir $dh  ) {
        next unless $fentry =~ /(\w+)\.dat$/i;
        next if $fentry eq 'info.dat';
        my $content_path = "/$path/$1";
        my $img_info = $self->image_load_profile( $content_path );
        $content_items{$img_info->{base_name}} = $img_info;
    }
    closedir $dh;

    my $image_order   = $gal_info->{image_order} || [];
    my @content_items = map {
        delete $content_items{$_}
    } grep $content_items{$_}, @$image_order;

    push @content_items, 
        sort { 
            ( $a->{exif} and $b->{exif} ?
            ( $a->{exif_date_time} eq '0000:00:00 00:00:00' or $b->{exif_date_time} eq '0000:00:00 00:00:00' ) ?
                $a->{source_path} cmp $b->{source_path}
                : ( $a->{exif_date_time} cmp $b->{exif_date_time} )
            : ( $a->{time_stamp} <=> $b->{time_stamp} ) ) || 0;
        } values %content_items;

    return \@content_items;
}

sub image_copy {
# --------------------------------------------------
    my $self = shift;
    my $target_path = shift;

    my @images = @_;

    $target_path ||= $self->{gallery_path};

    $target_path =~ s,[^\w/\-\s],,g;
    my $base_dir = $self->{base_path} . "/$target_path";

    foreach my $img ( @images ) {
        if ( $img =~ m|^\/| ) { substr $img, 0, 1 }
        else { $img = $target_path . "/$img" }
        my $ipath = "$self->{base_path}/$img";
        next unless -f "$ipath.dat";

        my $img_info = decode( gulp( "$ipath.dat" ) ) or next;

        my $tpath;
        do {
            $tpath = "$base_dir/" . rand_str();
        } while ( -f "$tpath.dat" );

        barf( "$tpath.dat", encode( $img_info ) );

        my $ext = $img_info->{ext} ||= do {
            $img_info->{source_path} =~ /(\w+)$/;
            lc $1 || 'jpg'
        };

        copy( 
            "${ipath}_main.$ext",
            "${tpath}_main.$ext",
        );

        copy( 
            "${ipath}_thumbnail.$ext",
            "${tpath}_thumbnail.$ext",
        );
    }

    return 1;
}

sub image_add {
# --------------------------------------------------
    my ( $self, $path ) = splice @_, 0, 2;

    $path ||= $self->{gallery_path};

    $path =~ s,[^\w/\-\s],,g;
    my $base_dir = $self->{base_path} . "/$path";

    return unless -d $base_dir;

    my $gal_info;
    if ( -f "$base_dir/info.dat" ) {
        my $buf = gulp( "$base_dir/info.dat" );
        $gal_info = decode( $buf );
    }
    $gal_info ||= {};

    foreach my $fpath ( @_ ) {

#        print $STR->string( gal_log_image_add => $fpath );

        my $ipath;
        do {
            $ipath = "$base_dir/" . rand_str();
        } while ( -f "$ipath.dat" );

        my ( $ext ) = $fpath =~ /(\w+)$/;
        $ext = lc $ext;

        my $imgs_info = {};

# create the thumbnail 
        my $res = $self->resize_image(
            $fpath,
            "${ipath}_thumbnail.$ext",
            $self->{thumbnail_extent}
        ) or next;

        @$imgs_info{ 
            map {"thumbnail_$_"} 
            keys %$res 
        } = values %$res;

# create the main 
        $res = $self->resize_image(
            $fpath,
            "${ipath}_main.$ext",
            $self->{main_extent}
        ) or next;

        @$imgs_info{ 
            map {"main_$_"} 
            keys %$res 
        } = values %$res;

        $imgs_info->{source_path} = $fpath;

        barf( "$ipath.dat", encode( $imgs_info ) );
    }

    barf( "$base_dir/info.dat", encode( $gal_info ) );
}

sub image_transfer {
# --------------------------------------------------
    my ( $self, $path, $target_path ) = splice @_, 0, 3;
    my $images = $self->image_list( $path );

    my $index = 0;

    require Symbol;
    my $inf = Symbol->gensym;
    foreach my $image ( @$images ) {

        my $ext = $image->{ext} ||= do {
            $image->{source_path} =~ /(\w+)$/;
            lc $1 || 'jpg'
        };

        my $target_fpath;

        do {
            $index++;
            $target_fpath = sprintf "$target_path/$CFG->{image_transfer_name}", $index;
        } while ( -f $target_fpath );

        if ( -f $image->{source_path}) {
            print "Copying '$image->{source_path}' to '$target_fpath'\n";

            copy(
                $image->{source_path},
                $target_fpath
            );
        }
    }
}

sub image_delete {
# --------------------------------------------------
    my ( $self, $ipath, $orig ) = @_;

    my $profile = $self->image_load_profile( $ipath ) or return;

# get rid of the profile
    unlink "$profile->{base_path}.dat";

# get rid of the images as well
    unlink $profile->{thumbnail_path};
    unlink $profile->{main_path};

# if requested, get rid of the original as well
    if ( $profile->{source_path} and $orig ) {
        unlink $profile->{source_path};
    }

    return 1;
}

sub image_edit {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $images = $args->{images} or return;
    @$images or return;

    my $action = $args->{action};

    my $process_func;

    if ( 'rotate_clockwise' eq $action ) {
        $process_func = sub {
            $_[0]->Rotate( degrees => 90 );
        };
    }
    elsif ( 'rotate_counter_clockwise' eq $action) {
        $process_func = sub {
            $_[0]->Rotate( degrees => 270 );
        };
    }
    elsif ( 'charcoal' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'emboss' eq $action ) {
        $process_func = sub {
            $_[0]->Emboss( 
                geometry => '', 
                radius => 123.2 , 
                sigma => 1.2
            );
        };
    }
    elsif ( 'blur' eq $action ) {
        $process_func = sub {
            $_[0]->Blur( order => 50 );
        };
    }
    elsif ( 'enhance' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'equalize' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'flip_vertical' eq $action ) {
        $process_func = sub {
            $_[0]->Flip;
        };
    }
    elsif ( 'flip_horizontal' eq $action ) {
        $process_func = sub {
            $_[0]->Flop;
        };
    }
    elsif ( 'gamma' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'gamma_up' eq $action ) {
        $process_func = sub {
            my $e = $_[0]->Gamma( gamma => 2 );
            $e and warn $e;
        };
    }
    elsif ( 'gamma_down' eq $action ) {
        $process_func = sub {
            my $e = $_[0]->Gamma( gamma => 1 );
            $e and warn $e;
        };
    }
    elsif ( 'desaturate' eq $action ) {
        $process_func = sub {
            my $e = $_[0]->Modulate( saturation => -100 );
            $e and warn $e;
        };
    }
    elsif ( 'level' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'mass_delete' eq $action ) {
        foreach my $name ( @$images ) {
            $self->image_delete( $name );
        }
        return 1;
    }
    elsif ( 'mass_delete_orig' ) {
        foreach my $name ( @$images ) {
            $self->image_delete( $name, 1 );
        }
        return 1;
    }
    elsif ( 'modulate' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'motion_blur' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'negate' eq $action ) {
        $process_func = sub {
            $_[0]->Negate( gray => 1 )
        };
    }
    elsif ( 'normalize' eq $action ) {
        $process_func = sub {
            $_[0]->Normalize
        };
    }
    elsif ( 'oil_paint' eq $action ) {
        $process_func = sub {
            $_[0]->OilPaint( radius => 10 );
        };
    }
    elsif ( 'roll' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'sharpen' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'solarize' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'swirl' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }
    elsif ( 'wave' eq $action ) {
        $process_func = sub {
            $_[0]->Charcoal( order => 50 );
        };
    }

    return unless $process_func;

    foreach my $name ( @$images ) {
        my $profile = $self->image_load_profile( $name );

        require Image::Magick;
        my $mm = Image::Magick->new;

        if ( my $err = $mm->Read( $profile->{main_path} ) ) {
            warn $err;
            next;
#            return;
        }

        if ( my $err = $process_func->( $mm ) ) {
            warn $err;
            next;
#            return;
        };


        my ( $vx, $vy )         = $mm->Get(qw( width height ));
        $profile->{main_width}  = $vx;
        $profile->{main_height} = $vy;

        $mm->Set( quality => 95 );
        if ( my $err = $mm->Write( $profile->{main_path} ) ) {
            warn $err;
            next;
#            return;
        };

        my $res = $self->resize_image(
            $profile->{main_path},
            $profile->{thumbnail_path},
            $self->{thumbnail_extent}
        );

        @$profile{
            map { "thumbnail_$_" }
            keys %$res
        } = values %$res;

        $self->image_save_profile( $name, $profile );
    }
}

sub image_save_profile {
# --------------------------------------------------
    my ( $self, $ipath, $profile ) = @_;

    $ipath =~ s,[^\w/\-\s],,g;

    my $root_path = $self->{base_path} || '';

    if ( '/' eq substr $ipath, 0, 1  ) {
        substr $ipath, 0, 1, ''
    }
    else {
        $root_path   .= ( $self->{gallery_path} ? '/' . $self->{gallery_path} : '' );
    }

    my $base_path = $root_path . "/$ipath.dat";
    return unless -f $base_path;

    barf( $base_path, encode( $profile ) );
}

sub account_selected {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $accounts = $self->accounts or return;
    my $acc_name = $args->{account};
    unless ( $acc_name ) {
        $args->{auto_select} or return;

        foreach my $an ( keys %$accounts ) {
            if ( $accounts->{$an}{default} ) {
                $acc_name = $an;
                last;
            }
        }

        $acc_name ||= (keys %$accounts)[0];
    }
    my $account  = $accounts->{$acc_name} or return;

    return ( $acc_name => $account );
}

sub ftp_subset_dir {
# --------------------------------------------------
# Returns a subset directory that the user can
# upload a small number of html frames into
#
    my ( $self, $args ) = @_;

    return $args->{subset_dir} if $args->{subset_dir};

    my ( $ftp, $ftp_base_path ) = $self->ftp_connect( $args );
    $ftp or do { 
       warn $self->error;
       return
    };

    my $subset_name;
    my $i = 0;
    do {
        $i < 10 or do {
            $subset_name = '';
            last;
        };
        $subset_name  = rand_str()
    } while (
        !$ftp->mkdir( "$ftp_base_path/subset/$subset_name", 1 )
    );

    return unless $subset_name;

    return "/subset/$subset_name";
}

sub ftp_upload_images {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $images = $args->{images} or return;
    @$images or return;

    my ( $acc_name, $acc ) = $self->account_selected( $args ) or return;

    my $base_path = $self->{base_path};

    my ( $ftp, $ftp_base_path ) = $self->ftp_connect( $args );

    my %built_paths;

    my @profiles;
    for my $fpath ( @$images ) {
        my $profile = $self->image_load_profile( $fpath );

        push @profiles, $profile;

        my $base_path = $self->{base_path};
        my $logical_image_path = ( $fpath =~ m,^/, ?
              "$self->{base_path}$fpath" 
            : "$acc->{base_path}" 
                . ( 
                    $self->{gallery_path} 
                    ? '/' . $self->{gallery_path} 
                    : '' 
                ) . "/$fpath" );
        my ( $gallery_path ) = ( $logical_image_path =~ m|^$base_path(.*)/[^/]+$| );
        my $ftp_logical_path = $ftp_base_path . $gallery_path;
        my $ftp_logical_fpath = $ftp_logical_path . "/$profile->{base_name}";

        unless ( $built_paths{$ftp_logical_path}++ ) {
            $ftp->cwd( $ftp_logical_path ) or do {
                $ftp->mkdir( $ftp_logical_path, 1 ) 
                    or return $self->error( "Cannot Create Full Path" );
            };
        }

        $ftp->put(
            $profile->{thumbnail_path},
            $ftp_logical_fpath . "_thumbnail.$profile->{ext}",
        ) or return $self->error( "Cannot Upload File: $profile->{thumbnail_path}" );

# For internal use, we use 95% image, for uploaded we use another percentage        
        ( my $uploader_path = $profile->{main_path} ) =~ s/_main\./_uploader\./;

        unless ( -f $uploader_path and (stat $uploader_path)[9] >= (stat $profile->{main_path})[9] ) {
            require Image::Magick; # downgrade image quality to 70%
            my $img = Image::Magick->new;
            $img->Read( $profile->{main_path} );
            $img->Set( quality => ( $CFG->{upload_quality} ) );
            $img->Write( $uploader_path );
            if ( my $cb = $CFG->{upload_callback} ) {
                $cb->( $uploader_path );
            }
        }

        $ftp->put(
            $uploader_path,
            $ftp_logical_fpath . "_main.$profile->{ext}",
        ) or return $self->error( "Cannot Upload File: $profile->{main_path}" );

        $profile->{accounts}{$acc_name}{uploaded} = time;

        $self->image_save_profile( $fpath, $profile );
    }

    $args->{ftp} or $ftp->quit;

    return \@profiles;
}

sub ftp_upload_subset {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $images = $args->{images} or return;
    @$images or return;

    my ( $acc_name, $acc ) = $self->account_selected( $args ) or return;

    my $subset_dir = $self->ftp_subset_dir( $args );

    my $profiles = $self->ftp_upload_images({
        images => $images,
        account => $acc_name,
    });

    $self->ftp_upload_frame({
        images     => $images,
        account    => $acc_name,
        subset_dir => $subset_dir,
    });

    foreach my $profile ( @$profiles ) {
        my $acc_info = $profile->{accounts}{$acc_name} || {};
        @$profile{ keys %$acc_info } = values %$acc_info;
    }

    my $buf = Nikki::Template->parse( 
        $STR->entry( 'gal_default_gallery' ),
        'gal_default_gallery',
        {
            gallery_images => $profiles
        }
    );

    my ( $ftp, $ftp_base_path ) = $self->ftp_connect( $args );
    my $main_frame_fh = Nikki::Gallery::File->new( \$buf );
    my $ftp_fpath = "$ftp_base_path/$subset_dir/index.html";
    $ftp->put(
        $main_frame_fh,
        $ftp_fpath
    );

    return 1;
}

sub ftp_upload_frame {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $images = $args->{images} or return;
    @$images or return;

    my ( $acc_name, $acc ) = $self->account_selected( $args ) or return;

    my $base_path = $self->{base_path};

    my ( $ftp, $ftp_base_path ) = $self->ftp_connect( $args );

    my @profiles = map {
        my $profile  = $self->image_load_profile( $_ );
        my $acc_info = $profile->{accounts}{$acc_name} || {};
        @$profile{ keys %$acc_info } = values %$acc_info;
        $profile;
    } @$images;

    for my $i ( 0..$#$images ) {
        my $fpath   = $images->[ $i ];
        my $profile = $profiles[ $i ];

        my $logical_image_path = ( $fpath =~ m,^/, ?
              "$self->{base_path}$fpath" 
            : "$acc->{base_path}" 
                . ( 
                    $self->{gallery_path} 
                    ? '/' . $self->{gallery_path} 
                    : '' 
                ) . "/$fpath" );

        my ( $gallery_path ) = ( $logical_image_path =~ m|^$base_path(.*)/[^/]+$| );
        my $ftp_logical_path = $ftp_base_path;
        $ftp_logical_path .= $args->{subset_dir} ? $args->{subset_dir} : $gallery_path;

        my $ftp_logical_fpath = $ftp_logical_path . "/$profile->{base_name}";

        my $tags = {%$profile};

        if ( $i > 0 ) {
            my $previous = $profiles[$i-1];
            @$tags{
                map { "previous_$_" } keys %$previous
            } = values %$previous;
        }

        if ( $i < $#$images ) {
            my $next = $profiles[$i+1];
            @$tags{
                map { "next_$_" } keys %$next
            } = values %$next;
        }

        my $buf = Nikki::Template->parse( 
            $STR->entry( 'gal_default_frame' ),
            'gal_default_frame',
            $tags
        );

        my $main_frame_fh = Nikki::Gallery::File->new( \$buf );

        my $base_fpath = "$ftp_logical_path/$profile->{base_name}.html";
        $ftp->put(
            $main_frame_fh,
            $base_fpath
        );

    };

    $args->{ftp} or $ftp->quit;

    return \@profiles;
};

sub gallery_add {
# --------------------------------------------------
    my ( $self, $path, $profile ) = @_;

    my $name = $profile->{name};

    $path ||= $self->{base_path} 
                . (
                    $self->{gallery_path} 
                        ?  '/' . $self->{gallery_path}
                        : '' 
                  ) 
                . '/' . $profile->{name};

    unless ( -d $path ) {
        mkdir $path, 0777 or return;
        $self->gallery_save_profile(
            $path,
            $profile
        );
    }

    return $profile;
}

sub gallery_save_profile {
# --------------------------------------------------
    my ( $self, $path, $profile ) = @_;

    $path ||= $self->{base_path} 
                . (
                    $self->{gallery_path} 
                        ?  '/' . $self->{gallery_path}
                        : '' 
                  ) 
                . $profile->{name};

    $path =~ /^\// or $path = $self->{base_path} . '/' . $path;
    $path .= '/info.dat';
    return barf( $path, encode( $profile ) );
}

sub gallery_load_profile {
# --------------------------------------------------
    my ( $self, $ipath ) = @_;

    $ipath =~ s,[^\w/\-\s],,g;

    unless ( $ipath ) {
        $ipath = $self->{gallery_path};
    }

    my $base_path = $self->{base_path}
                    . (
                        $ipath ?
                            "/$ipath"
                            : ""
                    )
                    .  "/info.dat";

    return unless -f $base_path;

    my $buf = gulp( $base_path );
    my $profile = decode( $buf );
}

sub gallery_reorder {
# --------------------------------------------------
    my $self      = shift;
    my $path      = shift;
    my @new_order = @_;

    my $gallery_profile = $self->gallery_load_profile( $path );

    $gallery_profile->{image_order} = \@new_order;

    return $self->gallery_save_profile( $path, $gallery_profile );
}

sub gallery_list {
# --------------------------------------------------
    my ( $self, $path ) = @_;

    $path ||= $self->{gallery_path};
    my $content_dir = $self->{base_path} 
                      . ( $path ? "/$path" : '');
    my $virt_path   = $path ? "$path/" : '';

    my @content_items;

    require Symbol;
    my $dh = Symbol->gensym;
    opendir $dh, $content_dir;
    while ( my $dentry = readdir $dh  ) {
        next if $dentry =~ m,^\.+$,;

        my $content_path = "$content_dir/$dentry";

        next unless -d $content_path;
        next if -f "$content_path/ignoreme.dat";

        my $gal_info = {
            logical_path => $content_path,
            logical_name => $dentry,
            name         => $dentry,
            gallery_path => $virt_path . $dentry
        };

        if ( -f ( my $info_path = "$content_path/info.dat" ) ) {
            my $buf = gulp( $info_path ) or next;
            if ( my $info_dat = decode( $buf ) ) {
                @$gal_info{ keys %$info_dat } = values %$info_dat;
            }
        }

        push @content_items, $gal_info;

    }
    closedir $dh;

    @content_items = sort {
        $a->{name} cmp $b->{name}
    } @content_items;

    return \@content_items;
}


sub gallery_resync {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $base_path = $self->{base_path} || '';

    my $gallery   = $args->{gallery} || '';
    if ( '/' eq substr $gallery, 0, 1  ) {
        substr $gallery, 0, 1, ''
    }
    else {
        $base_path   .= ( $self->{gallery_path} ? '/' . $self->{gallery_path} : '' );
    }

    my $gal_path  = $base_path . '/' . $gallery;
    return unless -d $gal_path;

# get a list of all the operative items
    require Symbol;
    my $dh = Symbol->gensym;

    require Image::Magick;

    opendir $dh, $gal_path;
    my @images;
    while ( my $fentry = readdir $dh ) {
        next unless $fentry =~ s,\.dat$,,i;
        next if $fentry eq 'info';
        my $image_path =  $gallery ? "$gallery/$fentry" : $fentry;

        my $profile = $self->image_load_profile( $image_path );
        my $im = Image::Magick->new;

        $im->Read( $profile->{thumbnail_path} );
        my ( $vx, $vy ) = $im->Get(qw( width height ));
        $profile->{thumbnail_width}  = $vx;
        $profile->{thumbnail_height} = $vy;

        $im = Image::Magick->new;
        $im->Read( $profile->{main_path} );
        ( $vx, $vy ) = $im->Get(qw( width height ));
        $profile->{main_width}  = $vx;
        $profile->{main_height} = $vy;

        $self->image_save_profile( $image_path, $profile );

    };
    close $dh;

    return 1;
}

sub ftp_upload_gallery {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $base_path = $self->{base_path};

    my $gal_path  = ( 
                        $args->{gallery} ? 
                        ( 
                            $args->{gallery} =~ m|^/| ?
                            $args->{gallery} :
                                $self->{gallery_path} ? 
                                    "/$self->{gallery_path}" :
                                    ''
                        ) :
                        (
                            $self->{gallery_path} ? 
                                "/$self->{gallery_path}" :
                                ''
                        )
                    );

    my $logical_gallery_path = $base_path . $gal_path;

    return unless -d $logical_gallery_path;

    my ( $acc_name, $acc ) = $self->account_selected( $args ) or return;

    my $gal_info;
    if ( -f "$logical_gallery_path/info.dat" ) {
        my $buf = gulp( "$logical_gallery_path/info.dat" );
        $gal_info = decode( $buf );
    }
    $gal_info ||= {};

# get a list of all the operative items
    require Symbol;
    my $dh = Symbol->gensym;

    my $images = $self->image_list( $gal_path );
    my @images = map {$_->{gallery_path}} @$images;

# now, push all the data required
    require Net::FTP;
    my ( $ftp, $ftp_base_path ) = $self->ftp_connect( $args );

    my $profiles = $self->ftp_upload_images({
        ftp => $ftp,
        images => \@images,
        account => $acc_name,
    });

    $self->ftp_upload_frame({
        ftp => $ftp,
        images => \@images,
        account => $acc_name,
    });

    foreach my $profile ( @$profiles ) {
        my $acc_info = $profile->{accounts}{$acc_name} || {};
        @$profile{ keys %$acc_info } = values %$acc_info;
    }

    my $buf = Nikki::Template->parse( 
        $STR->entry( 'gal_default_gallery' ),
        'gal_default_gallery',
        {
            gallery_images => $profiles
        }
    );

    my $main_frame_fh = Nikki::Gallery::File->new( \$buf );
    my $ftp_fpath = "$ftp_base_path/$gal_path/index.html";
    $ftp->put(
        $main_frame_fh,
        $ftp_fpath
    );

    return 1;
}

sub image_load_profile {
# --------------------------------------------------
    my ( $self, $ipath ) = @_;

    $ipath =~ s,[^\w/\-\s],,g;

    my $root_path = $self->{base_path} || '';

    if ( '/' eq substr $ipath, 0, 1  ) {
        substr $ipath, 0, 1, ''
    }
    else {
        $root_path .= ( $self->{gallery_path} ? '/' . $self->{gallery_path} : '' );
    }

    my $base_path = $root_path . "/$ipath.dat";
    return unless -f $base_path;

    if ( $PROFILE_CACHE->{$base_path}[0] >= (stat $base_path)[9] ) {
        return $PROFILE_CACHE->{$base_path}[1];
    }

    my $buf = gulp( $base_path ) or return;
    my $profile = decode( $buf );

    my $ext = $profile->{ext}  ||= 'jpg';
    
=tag
    ||= do {
        $profile->{main_path} =~ /(\w)$/;
        lc $1 || 'jpg'
    };
=cut

    my $fbase_path = $profile->{base_path} = $root_path . '/' . $ipath;
    $profile->{thumbnail_path} = $fbase_path . '_thumbnail.' . $ext;

    if ( $ext eq 'jpg' ) {
        if ( 
            not exists $profile->{exif} 
            and $profile->{source_path} 
            and $CFG->{jhead_path}
        ) {

            my $sp = '';
            foreach my $s ( $profile->{source_path}, "${fbase_path}_main.$ext", "${fbase_path}_thumbnail.$ext" ) {
                $sp = $s;
                last if -f $s;
            }

            my $exif  = `$CFG->{jhead_path} $sp`;
            my @lines = split /(?:[\n\r])+/, $exif;
            my %exif  = map {
                if ( /^([^:]+)\:(.*)$/ ) {
                    my $h = lc $1;
                    my $v = $2;
                    $h =~ s/^\s+|\s+$//g;
                    $h =~ s/\W+/_/g;
                    $v =~ s/^\s+|\s+$//g;
                    ( $h => $v  )
                }
                else {
                    ()
                }
            } @lines;
            $profile->{exif} = \%exif;

        }
    }

    if ( my $exif = $profile->{exif} ) {
        foreach my $ek ( keys %$exif ) {
            $profile->{"exif_".$ek} = $exif->{$ek};
        }
    }

    $ipath =~ m,(\w+)$,;
    $profile->{base_name}    = $1;
    $profile->{main_path}    = $fbase_path . '_main.' . $ext;
    $profile->{time_stamp}   = (stat( $base_path ))[9];
    $profile->{title}        ||= '';
    ( $profile->{base_dir}   = $profile->{base_path} ) =~ s,/?[^/]+$,,g;
    ( $profile->{gallery_path} ) = ( $fbase_path =~ m|^$self->{base_path}(.*)$| );


    my $accounts = $self->accounts || {};
    foreach my $acc_name ( keys %$accounts ) {
        my $acc = $accounts->{$acc_name};

        unless ( ref $profile->{accounts}{$acc_name} ) {
            $profile->{accounts}{$acc_name} = {};
        }

        my $base_url = "$acc->{url}/$profile->{gallery_path}";
        $profile->{accounts}{$acc_name}{thumbnail_url} = "${base_url}_thumbnail.$ext";
        $profile->{accounts}{$acc_name}{main_url} = "${base_url}_main.$ext";
    }

    foreach my $k ( keys %$profile ) {
        next unless $k =~ m,path,;
        $profile->{$k} =~ s,//,/,g;
    }

    $PROFILE_CACHE->{$base_path} = [ time, $profile ];

    return $profile;
}

sub resize_image {
# --------------------------------------------------
    my ( $self, $ipath, $opath, $extent, $quality ) = @_;

    require Image::Magick;
    my $img = Image::Magick->new;
    if ( my $err = $img->Read( $ipath ) ) {
        warn "$err on $ipath";
        return;
    }

    my ( $mx, $my ) = $extent =~ m,(\d+)\s*x\s*(\d+),;
    my ( $vx, $vy ) = $img->Get(qw( width height ));
    
    my $percent     = 1;

    if ( $vx > $mx ) {
        $percent = $mx / $vx;
    }

    if ( ( $vy * $percent ) > $my ) {
        $percent = $my / $vy;
    }

    if ( $percent != 1 ) {

        $vx = int( $percent * $vx );
        $vy = int( $percent * $vy );

        if ( my $err = $img->Resize( 
            width  => $vx,
            height => $vy,
            filter => 'Lanczos',
        ) ) {
#            blur   => 0.5
            warn $err;
            return;
        }
    }

    my $img_info = {
        width  => $vx,
        height => $vy
    };

    $img->Set( quality => ( $quality || 95 ) );
    $img->Write( $opath );
    $img = undef;

    return $img_info;
}

sub ftp_connect {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my ( $acc_name, $acc ) = $self->account_selected( $args ) or do { warn "No FTP account selected!"; return };

    if ( my $conn_info = $self->{ftp_conn}{$acc_name} ) {
        my $ftp = $conn_info->[0];
        if ( $ftp->binary ) { # ensure connection is still alive
            return wantarray ? @$conn_info : $ftp;
        }
    }

    my $class = $acc->{use_sftp} ? 'Nikki::Client::SFTP' : 'Net::FTP';

    my $ftp;
    if ( $class eq 'Net::FTP' ) {
        require Net::FTP;

        $ftp = $class->new( 
            $acc->{host},

            Port => ( $acc->{port} || 21 ),
    #        Debug => 1 # uncomment to be able to see what's up
        ) or return $self->error( 
            $STR->string( gal_ftp_error => $@ )
        );

    }
    else {
        $ftp = $class->new( 
            $acc->{host},
        ) or return $self->error( 
            $STR->string( gal_ftp_error => $@ )
        );
    }

    $ftp->login( 
        ( $acc->{username} or return $self->error( 
            $STR->entry( 'gal_ftp_username' )
        ) ),
        ( $acc->{password} or return $self->error( 
            $STR->entry( 'gal_ftp_password' )
        ) )
    ) or return $self->error( 
        $STR->entry( 'gal_ftp_login' )
    );

    $ftp->binary; 

    $acc->{path} =~ m|^/|;
    my $ftp_base_path = ( $acc->{path} =~ m|^/| ) ? 
                        $acc->{path}
                      : $ftp->pwd . '/' . $acc->{path};

    $self->{ftp_conn}{$acc_name} = [ $ftp, $ftp_base_path ];

    return wantarray ? ( $ftp, $ftp_base_path ) : $ftp;
}

sub paths {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my ( $acc_name, $acc ) = $self->account_selected( $args ) or return;

    my $base_path = $self->{base_path};

}

1;

package Nikki::Gallery::File;

sub new {
# --------------------------------------------------
    my ( $pkg, $buf ) = @_;
    return unless ref $buf eq 'SCALAR';

    require Symbol;
    my $fh = Symbol->gensym;
    tie *$fh, 'Nikki::Gallery::File', $buf ;
    return $fh;
}

sub BINMODE {
# --------------------------------------------------
    return 1;
}

sub TIEHANDLE {
# --------------------------------------------------
    my ( $pkg, $sref ) = @_;
    my $untied = {
        buf => $sref,
        i   => 0,
    };
    bless $untied, $pkg;
}

sub READ {
# --------------------------------------------------
    my ( $untied, undef, $len, $offset ) = @_;
    my $bufref = \$_[1];

    my $i = $untied->{i} + ( $offset || 0 );
    my $b = $untied->{buf};

    my $l = length( $$b );

    my $vl = $l - $i;

    if ( $vl < $len ) {
        $len = $vl;
    };

    $$bufref = substr( $$b, $i, $len );

    $untied->{i} += $len;

    return $len;
}

sub READLINE {
# --------------------------------------------------
    warn "readline called";
}

1;

package Nikki::Template;

use Nikki::Config;

use vars qw/ %COMPILED_TMPL $ERROR $OPS /;

$OPS = join "|", map { quotemeta } qw( % == - < > <= >= eq ne / * );

sub error {
# --------------------------------------------------
    my ( $pkg, $err ) = @_;
    if ( $err ) {
        $ERROR = $err;
        return;
    }
    $err = $ERROR;
    $ERROR = [];
    return wantarray ? @$err : $err;
}

sub parse {
# --------------------------------------------------
    my ( $pkg, $template, $name, $tags, $opts ) = @_;

    my $code;

    $code = $COMPILED_TMPL{$name} ||= do {
        my @chunks = split /(<\?.+?\?>)/, $template;

        my $pre_compile = q`sub {
            my $tags   = shift || {};
            $tags = {%$tags};

            my $output = '';
            my $loop_var;
            my $loop_i;
            my @loop_vars;
            my @tag_stack;
        `;

        my @work_stack;

        foreach my $chunk ( @chunks ) {
            unless ( substr( $chunk, 0, 2 ) eq '<?' ) {
                next unless defined $chunk and ( length $chunk > 0 );
                $pre_compile .= q|$output .= "| . quotemeta( $chunk ) . qq|";\n|;
                next;
            }

            $chunk =~ s,^\s*\<\?\s*|\s*\?\>\s*$,,g;

            if ( $chunk =~ m,^if(not)?\s+(.*?)\s*$,s ) {
                push @work_stack, 'if';

                my $not    = $1;
                my $ifhunk = $2;
                if ( $ifhunk =~ /^\w+$/ ) {
                    $pre_compile .= q`if ( ` . ( $not ? '!' : '' ) . q`( $tags->{"`. quotemeta($ifhunk) . qq`"} ) ) {\n`;
                }
                elsif ( $ifhunk =~ /^(\w+)\s+($OPS)\s+\"?(\$?[\s\w]+)\"?$/ ) {
                    my $first  = q`$tags->{"`. quotemeta($1) . '"} ';
                    my $op     = $2;
                    my $second = $3;
                    $second = (
                        $second =~ s,^\$,, 
                            ? q`$tags->{"`. quotemeta($second) . '"} ' 
                            : qq{ "$second" }
                    );

                    $pre_compile .= q`if ( ` . ( $not ? '!' : '' ) . "("
                                        . $first
                                        . $op
                                        . $second
                                        . " ) ) {\n";
                }

            }
            elsif ( $chunk =~ m,^else,) {
                $work_stack[$#work_stack] eq 'if' or return $pkg->error( "Missing Starting IF" );
                $pre_compile .= qq`} else { # elseif\n`;
            }
            elsif ( $chunk =~ m,^loop\s+(\w+), ) {
                push @work_stack, 'loop';
                $pre_compile .= q`push @loop_vars, [ $loop_var, $loop_i ];` . "\n";
                $pre_compile .= q`if ( $loop_var = $tags->{"` . quotemeta($1) . qq`"}` . " ) {\n";
                $pre_compile .= q`push @tag_stack, {%$tags};` . "\n";
                $pre_compile .= q`for ( $loop_i = 0 ; $loop_i < @$loop_var ; $loop_i++ ) {` . "\n";
                $pre_compile .= q`
                    $tags = {%$tags};
                    my $loop_tags = $loop_var->[$loop_i] or next;
                    @$tags{keys %$loop_tags} = values %$loop_tags;` . "\n";
                $pre_compile .= q`
                    $tags->{row_num} = $loop_i + 1;
                    $tags->{index}   = $loop_i;
                    $tags->{even}    = $loop_i % 2;
                    $tags->{odd}     = !$tags->{even};
                    $tags->{first}   = $loop_i == 0;
                    $tags->{last}    = $loop_i == @$loop_var;
                ` . "\n";
            }
            elsif ( $chunk =~ m,^endloop$, ) {
                $work_stack[$#work_stack] eq 'loop' or return $pkg->error( "Missing Starting LOOP" );
                $pre_compile .= qq`}\n`;
                $pre_compile .= q`$tags = pop @tag_stack;` . "\n";
                $pre_compile .= qq`}; #endloop\n`;
                $pre_compile .= q`( $loop_var, $loop_i ) = @{pop @loop_vars};` . "\n";
                pop @work_stack;
            }
            elsif ( $chunk =~ m,^endif$, ) {
                ( $work_stack[$#work_stack] || '' ) eq 'if' or return $pkg->error( "Missing Starting IF" . $pre_compile );
                $pre_compile .= qq`} # endif\n`;
                pop @work_stack;
            }
            else {
                $pre_compile .= q`$output .= $tags->{'` . quotemeta( $chunk ) . qq`'} || '';\n`;
            }

        }

        @work_stack and return $pkg->error( "Missing closing " . $work_stack[$#work_stack] . " tag" );

        $pre_compile .= q|
            return $output;
        }|;

# When there are code compilation problems. Dump pre-compiled code to /tmp/foo.txt
#        open F, ">/tmp/foo.txt";
#        print F $pre_compile;
#        close F;
        my $c = eval $pre_compile;

        $@ and warn $@;

        $c;
    };

    return $code ?  $code->( $tags ) : ();
}

1;

############################################################
#

package Nikki::Client::SFTP;

use strict;

sub new {
# --------------------------------------------------
    my ( $pkg, $host ) = splice @_, 0, 2;
    my $self = bless {@_}, $pkg;
    $self->{host} = $host;
    return $self;
}

sub login {
# --------------------------------------------------
    my ( $self, $username, $password) = @_;

    return $self->{sftp} ||= do {
        require Symbol;
        my $readfh  = Symbol->gensym;
        my $writefh = Symbol->gensym;

        $username ||= $self->{username};
        $password ||= $self->{password};

        require Net::SFTP;

        my $sftp;
        
        eval {
            $sftp = Net::SFTP->new( 
                $self->{host},
                user     => $username,
                password => $password,
            );
        };

        $sftp;
    }
}

sub pwd {
# --------------------------------------------------
    my $self = shift;
    my $sftp = $self->login;
    $sftp->do_realpath;
}

sub cwd {
# --------------------------------------------------
    my ( $self, $remote ) = @_;
    my $sftp = $self->login;
    return ( $sftp->do_stat( $remote ) || $sftp->do_lstat( $remote ) );
}

sub get {
# --------------------------------------------------
    my ( $self, $remote, $local ) = @_;
    my $sftp = $self->login;
    !$sftp->get( $remote, $local );
}

sub put {
# --------------------------------------------------
    my ( $self, $local, $remote ) = @_;

    if ( ref $local ) {
        require Symbol;
        my $tempfh = Symbol->gensym;
        my $rand   = rand(10000);
        my $tmp    = "/tmp";
         
        my $tempp;
        while ( -f ( $tempp  ="$tmp/temp_file_$rand" ) ) {
            rand( 10000 );
        }
        open $tempfh, ">$tempp";
        binmode $tempfh;
        binmode $local;

        my $buf;
        while ( read $local, $buf, 4096 ) {
            print $tempfh $buf;
        }
        close $tempfh;

        my $sftp = $self->login;
        my $e    = !$sftp->put( $tempp, $remote );

        unlink $tempp;

        return $e;
    }
    else {
        my $sftp = $self->login;
        !$sftp->put( $local, $remote );
    }
}

sub delete {
# --------------------------------------------------
    my ( $self, $remote ) = @_;
    my $sftp = $self->login;
    !$sftp->do_remove( $remote );
}

sub mkdir {
# --------------------------------------------------
    my ( $self, $remote, $recurse ) = @_;
    my $sftp = $self->login;
    my $e;
    require Net::SFTP::Attributes;
    my $attrs = Net::SFTP::Attributes->new;
    $attrs->perm( 0755 );

    unless ( $recurse ) {
        eval { $e = $sftp->do_mkdir( $remote, $attrs ) };
        return( !$@ );
    }
    else {
        my @delements = split m|\/|, $remote;
        shift @delements;

        my $full_path;

        foreach my $de ( @delements ) {
            $full_path .= '/' . $de;
            unless ( $self->cwd( $full_path ) ) {
                eval { $e = $sftp->do_mkdir( $full_path, $attrs ) };
                if ( $@ ) {
                    return;
                }
            }
        }

        return 1;
    }

}

sub quit {
# --------------------------------------------------
}

sub binary {
# --------------------------------------------------
    return 1;
}


1;

############################################################
#
package Nikki::Interface;

use strict;
use vars qw/ @ISA $CLI $IFACE /;

sub run {
# --------------------------------------------------
    my $pkg = shift;
    $CLI   = Nikki::Client->new( @_ );
    $IFACE = Nikki::Interface::GUI->new;
    $IFACE->run;
}

1;

############################################################
#
package Nikki::Interface::GUI;

use strict;
use Nikki::Config;
use Wx;
use vars qw( @ISA );

@ISA = 'Wx::App';

sub OnInit {
# --------------------------------------------------
    my ( $self ) = @_;

# create new MyFrame
    my $frame = $self->{mframe} = Nikki::Interface::GUI::MainFrame->new( 
        $STR->entry('app_title'),
        [-1,-1],
        [$CFG->{app_window_width},$CFG->{app_window_height}]
    );

# set it as top window (so the app will automatically close when
# the last top window is closed)
    $self->SetTopWindow( $frame );

# show the frame
    $frame->Show( 1 );

    return 1;
}

sub run {
# --------------------------------------------------
    my $self = shift;
    $self->MainLoop;
}

1;

############################################################

package Nikki::Interface::GUI::MainFrame;

use strict;
use vars qw( @ISA $MENU $MAIN_FRAME );
use Nikki::Config;
use Wx::Event qw( EVT_MENU );
use Wx qw( wxBITMAP_TYPE_ICO wxMENU_TEAROFF wxMAXIMIZE wxDEFAULT_FRAME_STYLE );
use Wx::MDI;

@ISA = 'Wx::MDIParentFrame';

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $self = $MAIN_FRAME = $pkg->SUPER::new( undef, -1, $_[0], $_[1], $_[2] );

# create the menus
    my $menu_structure = $STR->entry( 'app_menu_structure' ) || [];

    my $mbar = Wx::MenuBar->new();
    my $mi   = 1;
    foreach my $main_entry ( @$menu_structure ) {
        my $m = Wx::Menu->new( '', wxMENU_TEAROFF );
        $mbar->Append( $m, $main_entry->[0] );
        for ( my $i = 1; $i < @$main_entry ; $i++ ) {
            my $item = $main_entry->[$i];
            my $id = $mi++;
            $m->Append( $id, $item->[0], $item->[1] );
            if ( my $fun = $item->[2] ) {
                EVT_MENU( $self, $id, sub { shift->$fun( @_ )} );
            }
        }
    }

    $self->SetMenuBar( $mbar );

# create a status bar (note that the status bar that gets created
# has three panes, see the OnCreateStatusBar callback below
    $self->CreateStatusBar( 2 );

# and show a message
    $self->SetStatusText( $STR->entry( 'app_default_status' ), 1 );

    $self->CreateChildFrame( 'Nikki::Interface::GUI::EventNew' );
#    $self->CreateChildFrame( 'Nikki::Interface::GUI::Gallery::Settings' );
#    $self->CreateChildFrame( 'Nikki::Interface::GUI::Gallery' );
#    $self->CreateChildFrame( 'Nikki::Interface::GUI::ViewDrafts' );
#    $self->CreateChildFrame( 'Nikki::Interface::GUI::Accounts' );
#    $self->CreateChildFrame( 'Nikki::Interface::GUI::EventsCalendar' );

    return $self;
}

# self is an addition to demonstrate virtual callbacks...
# it ignores all parameters and creates a status bar with three fields
sub OnCreateStatusBar {
# --------------------------------------------------
    my $self = shift;
    my $status = Wx::StatusBar->new( $self, -1 );

    $status->SetFieldsCount( 3 );

    return $status;
}

# called when the user selects the 'Exit' menu item
sub OnQuit {
# --------------------------------------------------
    my ( $self, $event ) = @_;

# closes the frame
    $self->Close( 1 );
}

sub OnAccounts {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->CreateChildFrame( 'Nikki::Interface::GUI::Accounts' );
}

sub OnCreateNewEvent {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->CreateChildFrame( 'Nikki::Interface::GUI::EventNew' );
}

sub OnBrowseEvents {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->CreateChildFrame( 'Nikki::Interface::GUI::EventsCalendar' );
}

sub OnSearchEvents {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->CreateChildFrame( 'Nikki::Interface::GUI::EventsSearch' );
}

sub OnViewDrafts {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->CreateChildFrame( 'Nikki::Interface::GUI::ViewDrafts' );
}

sub OnGallery {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->CreateChildFrame( 'Nikki::Interface::GUI::Gallery' );
}

sub OnGallerySettings {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->CreateChildFrame( 'Nikki::Interface::GUI::Gallery::Settings' );
}

sub CreateChildFrame {
# --------------------------------------------------
# This creates a child window based on classname
# 
    my ( $self, $class, $opts ) = @_;
    $opts ||= {};
    my $title_name = $class->can( "get_title" ) ? $class->get_title( $opts ) : "Title";
    return $class->new( 
        $opts, 
        $self, 
        -1, 
        $title_name, 
        [-1,-1], 
        [-1,-1], 
        wxDEFAULT_FRAME_STYLE | wxMAXIMIZE
    );
}

use Wx qw( wxOK wxICON_INFORMATION wxVERSION_STRING );

# called when the user selects the 'About' menu item
sub OnAbout {
# --------------------------------------------------
    my ( $self, $event ) = @_;

# display a simple about box
    Wx::MessageBox( 
        $STR->string( 'app_about_text', $VER ),
        $STR->entry( 'app_about_title' ), 
        wxOK | wxICON_INFORMATION,
        $self 
    );
}

1;

############################################################
#
package Nikki::Interface::GUI::Accounts;

use strict;
use vars qw( @ISA );
use Nikki::Config;
use Wx::Event qw( EVT_BUTTON EVT_LIST_ITEM_SELECTED );
use Wx qw( 
    wxBITMAP_TYPE_ICO 
    wxMENU_TEAROFF 
    wxVERTICAL 
    wxGROW 
    wxALL
    wxHORIZONTAL
    wxTE_MULTILINE
    wxTE_PROCESS_ENTER 
    wxALIGN_RIGHT
    wxALIGN_CENTER
    wxDefaultPosition
    wxDefaultSize
    wxLC_LIST
    wxSUNKEN_BORDER 
    wxLC_EDIT_LABELS
    wxLC_SINGLE_SEL 
    wxLC_REPORT 
    wxLC_SINGLE_SEL 
    wxLIST_FORMAT_LEFT
    wxSIMPLE_BORDER 
    wxTE_PASSWORD 
    wxOK 
    wxICON_INFORMATION
    wxPD_ELAPSED_TIME 
    wxPD_AUTO_HIDE 
);
use Wx::MDI;

@ISA = 'Wx::MDIChildFrame';

sub get_title {
# --------------------------------------------------
    my ( $self, $opt ) = @_;
    return $STR->string( app_win_accounts => $opt->{itemid} || '?'  );
}

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $args = shift || {};
    my $self = $pkg->SUPER::new( @_ );

    my $main_sizer    = Wx::BoxSizer->new( wxVERTICAL );

# Control Widgets
    my $commit_row = Wx::BoxSizer->new( wxHORIZONTAL );
    my $commit_cancelbutton = Wx::Button->new(
        $self,
        -1,
        $STR->entry( 'app_widget_cancel' ),
        [0,0],
        [75,25]
    );

    EVT_BUTTON(
        $self,
        $commit_cancelbutton,
        sub { shift->OnCancel( @_ ) }
    );

    $commit_row->Add( $commit_cancelbutton, 1, wxGROW|wxALL, 3 );
    $main_sizer->Add( $commit_row, 0, wxGROW|wxALL, 0 );

# ACCOUNT LIST
    my $acc_list = $self->{ctl_listaccounts} = Wx::ListCtrl->new(
        $self,
        -1,
        wxDefaultPosition,
        [1,100], 
        wxSUNKEN_BORDER |wxLC_REPORT | wxLC_SINGLE_SEL  #|wxLC_EDIT_LABELS
    );
    my @c = split /\|/, $STR->entry( 'app_str_acc_columns' );
    $acc_list->InsertColumn( 1, $c[0], wxLIST_FORMAT_LEFT, 50 );
    $acc_list->InsertColumn( 1, $c[1], wxLIST_FORMAT_LEFT, 100 );
    $acc_list->InsertColumn( 2, $c[2], wxLIST_FORMAT_LEFT, 150 );
    $acc_list->InsertColumn( 3, $c[3], wxLIST_FORMAT_LEFT, 50 );

    EVT_LIST_ITEM_SELECTED( 
        $self, 
        $acc_list, 
        sub { shift->OnAccountSelect( @_ ) },
    );

    $main_sizer->Add( $acc_list, 0, wxGROW|wxALL, 3 );

# ADD/DELETE ACCOUNT
    my $action_row = Wx::BoxSizer->new( wxHORIZONTAL );

    my $act_sync = $self->{ctl_syncaccount} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_sync' ),
        [0, 0], 
        [75, 25] 
    );

    $action_row->Add( $act_sync, 0, wxALL, 3 );

    EVT_BUTTON(
        $self,
        $act_sync,
        sub { shift->OnAccountSync(@_) },
    );

    my $act_delete = $self->{ctl_deleteaccount} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_delete' ),
        [0, 0], 
        [75, 25] 
    );

    $action_row->Add( $act_delete, 0, wxALL, 3 );

    my $act_default = $self->{ctl_defaultaccount} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_default' ),
        [0, 0], 
        [75, 25] 
    );

    $action_row->Add( $act_default, 0, wxALL, 3 );

    EVT_BUTTON(
        $self,
        $act_default,
        sub { shift->OnAccountDefault(@_) },
    );

    EVT_BUTTON(
        $self,
        $act_delete,
        sub { shift->OnAccountDelete(@_) },
    );

    my $act_addnew = $self->{ctl_addnewaccount} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_addnew' ),
        [0, 0], 
        [75, 25] 
    );
    $action_row->Add( $act_addnew, 0, wxALL, 3 );

    EVT_BUTTON(
        $self,
        $act_addnew,
        sub { shift->OnAccountNew(@_) },
    );

    $main_sizer->Add( $action_row, 0, wxALIGN_RIGHT|wxALL, 0 );

# MODIFY ACCOUNT INFO
    my $bordered_box = Wx::StaticBox->new(
        $self,
        -1,
        $STR->entry( "app_lbl_acc_info" ),
        [-1,-1],
        [-1,-1],
        wxSIMPLE_BORDER 
    );

    my $bordered_box_sizer = Wx::StaticBoxSizer->new(
        $bordered_box,
        wxVERTICAL
    );

    my $info_row = Wx::FlexGridSizer->new( 6, 2, 3, 3 );

    my $host_label  = $self->{lbl_host} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_host" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $host_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $host_list = [
        split /\|/, $STR->entry( "app_str_hosts" )
    ];
    my $host_entry = $self->{ctl_hostentry} = Wx::ComboBox->new( 
        $self, 
        -1, 
        $STR->entry( "app_default_host" ), 
        [0,0], 
        [200, 25], 
        $host_list,
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $host_entry, 0, wxALL, 3 );
    $info_row->AddGrowableCol( 1 );

    my $port_label  = $self->{lbl_port} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_port" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $port_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $port_entry = $self->{ctl_portentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [100, 25], 
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $port_entry, 0, wxALL, 3 );

    my $path_label  = $self->{lbl_path} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_path" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $path_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $path_entry = $self->{ctl_pathentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [200, 25], 
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $path_entry, 0, wxALL, 3 );

    my $username_label  = $self->{lbl_username} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_username" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $username_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $username_entry = $self->{ctl_usernameentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [200, 25], 
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $username_entry, 0, wxALL, 3 );

    my $password_label  = $self->{lbl_password} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_password" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $password_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $password_entry = $self->{ctl_passwordentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [200, 25], 
        wxTE_PROCESS_ENTER | wxTE_PASSWORD 
    );
    $info_row->Add( $password_entry, 0, wxALL, 3 );

    my $ftp_account_label  = $self->{lbl_ftp_account} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_ftp_account" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $ftp_account_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $ftp_accounts = $Nikki::Interface::CLI->gallery->accounts;
    my $ftp_accounts_list = $ftp_accounts ? [
        map {
            $_ ? "$_" : $STR->entry( "app_default_account" )
        } sort "", keys %$ftp_accounts 
    ] : [];
    my $ftp_account_entry = $self->{ctl_ftpchoice} = Wx::Choice->new( 
        $self, 
        -1, 
        [0,0], 
        [100, 25], 
        $ftp_accounts_list
    );
    $info_row->Add( $ftp_account_entry, 1, wxGROW|wxALL, 3 );

# Not for now
#    my $save_pass_label  = $self->{lbl_save_pass} = Wx::StaticText->new(
#        $self,
#        -1,
#        $STR->string( "app_lbl_save_pass" ),
#        [ 100, 25 ],
#        wxDefaultSize,
#        wxALIGN_RIGHT
#    );
#    $info_row->Add( $save_pass_label, 0, wxALIGN_RIGHT|wxALL, 3 );
#
#    my $save_pass_entry = $self->{ctl_save_passentry} = Wx::CheckBox->new( 
#        $self, 
#        -1, 
#        "", 
#        [0,0], 
#        [100, 25], 
#        wxTE_PROCESS_ENTER 
#    );
#    $info_row->Add( $save_pass_entry, 1, wxGROW|wxALL, 3 );

    $bordered_box_sizer->Add( $info_row, 0, wxALIGN_CENTER|wxALL, 0 );

    my $infoaction_row = Wx::BoxSizer->new( wxHORIZONTAL );
    my $info_test = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_test' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON(
        $self,
        $info_test,
        sub { shift->OnAccountTest(@_) },
    );

    $infoaction_row->Add( $info_test, 0, wxALL, 3 );

    my $info_commit = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_commit' ),
        [0, 0], 
        [75, 25] 
    );

    $infoaction_row->Add( $info_commit, 0, wxALL, 3 );

    EVT_BUTTON(
        $self,
        $info_commit,
        sub { shift->OnAccountCommit(@_) },
    );

    $bordered_box_sizer->Add( $infoaction_row, 0, wxALIGN_RIGHT|wxALL, 3 );

    $main_sizer->Add( $bordered_box_sizer, 0, wxGROW|wxALL, 3 );

    $self->SetSizer( $main_sizer );
    $self->load_accounts;

    $self->OnAccountNew;

    return $self;
}

sub load_accounts {
# --------------------------------------------------
    my $self = shift;
    my $listctl = $self->{ctl_listaccounts};
    $listctl->DeleteAllItems;
    my $accounts = $Nikki::Interface::CLI->accounts;
    my $i = 0;
    foreach my $acc ( keys %$accounts ) {
        my $acc_info = $accounts->{$acc};
        my $id = $listctl->InsertStringItem( 
            $i++, 
            $acc_info->{default} ? $STR->entry( 'app_str_default_account' ) : ''
        );
        $listctl->SetItem( $id, 1, $acc_info->{username} );
        $listctl->SetItem( $id, 2, $acc_info->{host} );
        $listctl->SetItem( $id, 3, $acc_info->{port} );
    }
}

sub load_form {
# --------------------------------------------------
    my ( $self, $args ) = @_;
    $self->{ctl_hostentry}->SetValue( $args->{host} );
    $self->{ctl_portentry}->SetValue( $args->{port} );
    $self->{ctl_pathentry}->SetValue( $args->{path} );
    $self->{ctl_usernameentry}->SetValue( $args->{username} );
    $self->{ctl_usernameentry}->SetEditable( $args->{username_lock} ? 0 : 1 );
    $self->{ctl_passwordentry}->SetValue( $args->{password} ); 
    $self->{ctl_ftpchoice}->SetStringSelection( $args->{ftp_account} || $STR->entry( 'app_default_account' ) );
#    $self->{ctl_save_passentry}->SetValue( $args->{save_password} ); 
}

sub get_form {
# --------------------------------------------------
    my $self = shift;

    my $ftp_account = $self->{ctl_ftpchoice}->GetStringSelection;
    my ( $acc_name, $acc ) = $Nikki::Interface::CLI->gallery->account_selected({
        account => $ftp_account
    });
    my $args = {
        host        => $self->{ctl_hostentry}->GetValue,
        port        => $self->{ctl_portentry}->GetValue,
        path        => $self->{ctl_pathentry}->GetValue,
        username    => $self->{ctl_usernameentry}->GetValue,
        password    => $self->{ctl_passwordentry}->GetValue,
        ftp_account => $acc_name || '',
#        save_password => $self->{ctl_save_passentry}->GetValue,
    };

    $acc_name = $self->{ctl_usernameentry}->GetValue . '@' . $self->{ctl_hostentry}->GetValue;
    ( $acc_name, $acc ) = $Nikki::Interface::CLI->account_selected({
        account => $acc_name
    });

    if ( $acc ) {
        foreach my $k ( keys %{$acc||{}} ) {
            next if exists $args->{$k};
            $args->{$k} = $acc->{$k};
        }
    }

    return $args;
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->Close(1);
}

sub OnAccountDefault {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $ctl_listaccounts = $self->{ctl_listaccounts};

    my $idx       = $self->{idx};
    my $acc_name  = $ctl_listaccounts->GetItem( $idx, 1 )->GetText;
    my $host_name = $ctl_listaccounts->GetItem( $idx, 2 )->GetText;

    my $acc_key   = "$acc_name\@$host_name";

    $Nikki::Interface::CLI->account_default( $acc_key );
    $self->load_accounts;
}

sub OnAccountNew {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->load_form({
        host        => $STR->entry( 'app_default_host' ),
        port        => 80,
        path        => '/interface/flat',
        username    => '',
        password    => '',
        ftp_account => '',
    });
}


sub OnAccountDelete {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $ctl_listaccounts = $self->{ctl_listaccounts};

    my $idx       = $self->{idx};
    my $acc_name  = $ctl_listaccounts->GetItem( $idx, 1 )->GetText;
    my $host_name = $ctl_listaccounts->GetItem( $idx, 2 )->GetText;

    my $acc_key   = "$acc_name\@$host_name";

    $Nikki::Interface::CLI->account_delete( $acc_key );
    $self->load_accounts;
}

sub OnAccountSync {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $ctl_listaccounts = $self->{ctl_listaccounts};

    my $idx       = $self->{idx};
    my $acc_name  = $ctl_listaccounts->GetItem( $idx, 1 )->GetText or return;
    my $host_name = $ctl_listaccounts->GetItem( $idx, 2 )->GetText or return;

    my $account_key = "$acc_name\@$host_name";

    my $prg_dlg   = Wx::ProgressDialog->new(
        $STR->entry( 'app_str_acc_test' ),
        $STR->entry( 'app_str_sync_start' ),
        100,
        $self,
        wxPD_ELAPSED_TIME | wxPD_AUTO_HIDE 
    );

    my $progress_state = {};

    my $prg_update = sub {
    # --------------------------------------------------
        my ( $percent, $message ) = @_;
        $progress_state->{percent} = $percent,
        $progress_state->{message} = $message,

        $prg_dlg->Update(
            $progress_state->{percent} || 0,
            $progress_state->{message} || '',
        ) or do {
            $prg_dlg->Destroy;
            last
        };

        $Nikki::Interface::IFACE->Yield;
    };

    my $rec = $Nikki::Interface::CLI->account_sync({
        account => $account_key,
        progress => $prg_update
    });

    $prg_update->( 100, $STR->entry( "app_sync_done" ) );

    $Nikki::Interface::CLI->load_user( 1 ); # force reload the config
}


sub sync_reindex {
# --------------------------------------------------
    my ( $client, $account_key, $prog_func ) = @_;

    my $rec = $client->account_sync({
        account => $account_key,
        progress => $prog_func
    });

    $prog_func->( 100, $STR->entry( "app_sync_done" ) );

    return $client->save_user;
}


sub OnAccountSelect {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $ctl_listaccounts = $self->{ctl_listaccounts};

    my $idx       = $self->{idx} = $event->GetIndex;
    my $acc_name  = $ctl_listaccounts->GetItem( $idx, 1 )->GetText;
    my $host_name = $ctl_listaccounts->GetItem( $idx, 2 )->GetText;

    my $accounts  = $Nikki::Interface::CLI->accounts;
    my $account   = {%{$accounts->{"$acc_name\@$host_name"}}};

    $account->{username_lock} = 1;
    $self->load_form( $account );
}

sub OnAccountTest {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    if ( $Nikki::Interface::CLI->account_test(
        $self->get_form
    ) ) {
        Wx::MessageBox( 
            $STR->entry( 'app_str_acc_test_success' ), 
            $STR->entry( 'app_str_acc_test' ),
            wxOK | wxICON_INFORMATION,
            $self 
        );
    }
    else {
        Wx::MessageBox(
            $STR->string( app_str_acc_test_fail => $Nikki::Interface::CLI->error ), 
            $STR->entry( 'app_str_acc_test' ),
            wxOK | wxICON_INFORMATION,
            $self 
        );
    };

}

sub OnAccountCommit {
# --------------------------------------------------
# This function must determine if an account should
# be added or edited. 
#
    my ( $self, $event ) = @_;
    my $args = $self->get_form;
    $Nikki::Interface::CLI->account_commit( $args );
    $self->load_accounts;
}

1;

############################################################
#
package Nikki::Interface::GUI::EventNew::AdvDialog;

use strict;
use vars qw/ @ISA /;
use Wx qw(
    wxGROW 
    wxALL
    wxVERTICAL
    wxHORIZONTAL
    wxDefaultSize
    wxALIGN_RIGHT
    wxALIGN_CENTRE
);
use Wx::Event qw( EVT_BUTTON );

use Nikki::Config;
@ISA = 'Wx::Dialog';

sub new {
# --------------------------------------------------
    my $pkg = shift;

    my $self = $pkg->SUPER::new( @_ );
    my $parent = $self->GetParent;
    my ( $acc_name, $acc ) = $Nikki::Interface::CLI->account_selected({
        account => $parent->{ctl_accountsel}->GetStringSelection 
    });

    my $main_sizer = Wx::BoxSizer->new( wxVERTICAL );

    my $options_sizer = Wx::FlexGridSizer->new( 6, 2, 3, 3 );

# Security Setting
    my $sec_label  = $self->{lbl_security} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_widget_security" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $options_sizer->Add( $sec_label, 0, wxGROW|wxALL, 3 );

    my $sec_opt = $self->{ctl_security_choice} = Wx::Choice->new(
        $self,
        -1,
        [0,0],
        [200,25],
        [split /\|/, $STR->entry('app_str_security')]
    );
    $options_sizer->Add( $sec_opt, 0, wxGROW|wxALL, 3 );
    $options_sizer->AddGrowableCol( 1 );

# Picture Setting
    my $picture_label  = $self->{lbl_picture} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_widget_picture" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $options_sizer->Add( $picture_label, 0, wxGROW|wxALL, 3 );

    my $picture_choices = [
        '', sort keys %{$acc->{pictures}||{}}
    ];
    my $picture_opt = $self->{ctl_picture_choice} = Wx::Choice->new(
        $self,
        -1,
        [0,0],
        [200,25],
        $picture_choices
    );
    $options_sizer->Add( $picture_opt, 0, wxGROW|wxALL, 3 );
    $options_sizer->AddGrowableCol( 1 );

# Commentable Setting
    my $comm_label  = $self->{lbl_comment} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_widget_comment" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $options_sizer->Add( $comm_label, 0, wxGROW|wxALL, 3 );

    my $comm_opt = $self->{ctl_comment_choice} = Wx::Choice->new(
        $self,
        -1,
        [0,0],
        [200,25],
        [split /\|/, $STR->entry( 'app_str_comment' )]
    );
    $options_sizer->Add( $comm_opt, 0, wxGROW|wxALL, 3 );

# Music Setting
    my $music_label  = $self->{lbl_music} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_widget_music" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $options_sizer->Add( $music_label, 0, wxGROW|wxALL, 3 );

    my $music_entry = $self->{ctl_music_text} = Wx::TextCtrl->new(
        $self,
        -1,
        "",
        [0,0],
        [200,25],
    );
    $options_sizer->Add( $music_entry, 0, wxGROW|wxALL, 3 );

# Mood Setting
    my $mood_label  = $self->{lbl_mood} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_widget_mood" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $options_sizer->Add( $mood_label, 0, wxGROW|wxALL, 3 );

    my $mood_list = [sort values %{$acc->{moods}}];
    my $mood_entry = $self->{ctl_mood_choice} = Wx::ComboBox->new(
        $self,
        -1,
        "",
        [0,0],
        [150,25],
        $mood_list
    );
    $options_sizer->Add( $mood_entry, 0, wxALL, 3 );

# Control Widgets
    my $commit_row = Wx::BoxSizer->new( wxHORIZONTAL );
    my $commit_cancelbutton = Wx::Button->new(
        $self,
        -1,
        $STR->entry( 'app_widget_cancel' ),
        [0,0],
        [75,25]
    );

    EVT_BUTTON(
        $self,
        $commit_cancelbutton,
        sub { shift->OnCancel( @_ ) }
    );

    my $commit_okbutton = Wx::Button->new( 
        $self, 
        -1, 
        $STR->entry( 'app_widget_ok' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON(
        $self,
        $commit_okbutton,
        sub { shift->OnOk( @_ ) }
    );

    $commit_row->Add( $commit_cancelbutton, 0, wxGROW|wxALL, 3 );
    $commit_row->Add( $commit_okbutton,     0, wxGROW|wxALL, 3 );

    $main_sizer->Add( $options_sizer,   0, wxGROW|wxALL, 3 );
    $main_sizer->Add( $commit_row, 0, wxALIGN_CENTRE|wxALL, 3 );

    $self->SetSizer( $main_sizer );

    $self->load_fromparent;

    return $self;
}

sub load_fromparent {
# --------------------------------------------------
    my $self = shift;
    my $parent = $self->GetParent;

    $parent->{event_security}        and $self->{ctl_security_choice}->SetStringSelection($parent->{event_security});
    $parent->{event_picture_keyword} and $self->{ctl_picture_choice}->SetStringSelection($parent->{event_picture_keyword});
    $parent->{event_opt_comment}     and $self->{ctl_comment_choice}->SetStringSelection($parent->{event_opt_comment});
    $parent->{event_current_music}   and $self->{ctl_music_text}->SetValue($parent->{event_current_music});

    if ( my $moodid = $parent->{event_current_moodid} ) {
        my ( $acc_name, $acc ) = $Nikki::Interface::CLI->account_selected({
            account => $parent->{ctl_accountsel}->GetStringSelection 
        });

        my $mood_name = $acc->{moods}{$moodid};
        $parent->{event_current_mood} = $mood_name;
    }

    $parent->{event_current_mood}  and $self->{ctl_mood_choice}->SetValue($parent->{event_current_mood});
}

sub save_toparent {
# --------------------------------------------------
    my $self = shift;
    my $parent = $self->GetParent;

    $parent->{event_security}        = $self->{ctl_security_choice}->GetStringSelection;
    $parent->{event_picture_keyword} = $self->{ctl_picture_choice}->GetStringSelection;
    $parent->{event_opt_comment}     = $self->{ctl_comment_choice}->GetStringSelection;
    $parent->{event_current_music}   = $self->{ctl_music_text}->GetValue || '';
    $parent->{event_current_mood}    = $self->{ctl_mood_choice}->GetValue || '';
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->Close(1);
}

sub OnOk {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->save_toparent;
    $self->Close(1);
}

1;

############################################################
#
package Nikki::Interface::GUI::EventEdit;

use strict;
use vars qw( @ISA );
use Nikki::Config;
use Wx::Event qw( EVT_BUTTON );
use Wx qw( 
    wxBITMAP_TYPE_ICO 
    wxMENU_TEAROFF 
    wxVERTICAL 
    wxALIGN_LEFT
    wxLEFT
    wxRIGHT
    wxGROW 
    wxALL
    wxHORIZONTAL
    wxTE_MULTILINE
    wxTE_PROCESS_ENTER 
    wxALIGN_RIGHT
    wxNO_DEFAULT 
    wxICON_ERROR 
    wxICON_QUESTION
    wxYES_NO 
    wxYES
    wxCANCEL
    wxRESIZE_BORDER
    wxDEFAULT_FRAME_STYLE
);
use Wx::MDI;

@ISA = 'Wx::MDIChildFrame';

sub get_title {
# --------------------------------------------------
    my ( $self, $opt ) = @_;
    return $STR->string( app_win_event_edit => $opt->{itemid} || '?'  );
}

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $args = shift || {};
    my $self = $pkg->SUPER::new( @_ );

    my $textentry = $self->{ctl_textentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0, 250], 
        [100, 50], 
        wxTE_MULTILINE | wxTE_PROCESS_ENTER 
    );
    $self->{original_text} = '';

    my $subjectentry = $self->{ctl_subjectentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [100, 25], 
        wxTE_PROCESS_ENTER 
    );

    my $accounts = $Nikki::Interface::CLI->accounts;
    my $account_list = [ 
        sort { 
            $accounts->{$a}{order} <=> $accounts->{$b}{order} 
        } keys %$accounts 
    ];

    my $accountselect = $self->{ctl_accountsel} = Wx::Choice->new(
        $self,
        -1,
        [0,0], 
        [200, 25], 
        $account_list,
    );

    foreach my $acc_name ( keys %$accounts ) {
        next unless $accounts->{$acc_name}{default};
        $accountselect->SetStringSelection( $acc_name );
        last;
    }

    my $advancedselect = $self->{ctl_advancedsel} = Wx::Button->new( 
        $self, 
        -1, 
        $STR->entry( 'app_widget_advanced' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $advancedselect, 
        sub { shift->OnAdvancedSelect( @_ ) } # for inheritance
    );

    my $insertresource;

    if ( ref $self eq 'Nikki::Interface::GUI::EventNew' ) {
        $insertresource = $self->{ctl_insertresource} = Wx::Button->new( 
            $self, 
            -1, 
            $STR->entry( 'app_widget_resources' ),
            [0, 0], 
            [75, 25] 
        );

        EVT_BUTTON( 
            $self, 
            $insertresource, 
            sub { shift->OnInsertResource( @_ ) } # for inheritance
        );
    }

    my $dateentry = $self->{ctl_dateentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [200, 25], 
        wxTE_PROCESS_ENTER 
    );

    my $submitentry = $self->{ctl_submitentry} = Wx::Button->new( 
        $self, 
        -1, 
        $STR->entry( 'app_widget_submit' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $submitentry, 
        sub { shift->OnSubmitEvent( @_ ) } # for inheritance
    );

    my $cancelbutton = $self->{ctl_cancelbutton} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_cancel' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $cancelbutton, 
        sub { shift->OnCancel( @_ ) } # for inheritance
    );

    my $main_sizer    = Wx::BoxSizer->new( wxVERTICAL );
    my $subject_sizer = Wx::BoxSizer->new( wxHORIZONTAL );
    my $music_sizer   = Wx::BoxSizer->new( wxHORIZONTAL );
    my $tool_sizer    = Wx::BoxSizer->new( wxHORIZONTAL );
    my $bottom_sizer  = Wx::BoxSizer->new( wxHORIZONTAL );

    $tool_sizer->Add( $accountselect, 1, wxGROW|wxALL, 3 );
    $tool_sizer->Add( $cancelbutton,  0, wxGROW|wxALL, 3 );

    $subject_sizer->Add( $subjectentry,   1, wxGROW|wxALL, 3 );
    $subject_sizer->Add( $advancedselect, 0, wxGROW|wxALL, 3 );

    my $date_sizer = Wx::BoxSizer->new( wxHORIZONTAL );
    $date_sizer->Add( $dateentry, 0, wxALL, 3 );
    $bottom_sizer->Add( $date_sizer, 1, wxLEFT|wxRIGHT|wxGROW, 0 );
    $insertresource and $bottom_sizer->Add( $insertresource, 0, wxGROW|wxALL, 3 );
    $bottom_sizer->Add( $submitentry,    0, wxGROW|wxALL, 3 );

    $main_sizer->Add( $tool_sizer,    0, wxGROW|wxALL, 0 );
    $main_sizer->Add( $subject_sizer, 0, wxGROW|wxALL, 0 );
    $main_sizer->Add( $textentry,     9, wxGROW|wxALL, 3 );
    $main_sizer->Add( $bottom_sizer,  0, wxLEFT|wxRIGHT|wxGROW, 0 );
#    $main_sizer->Add( $music_sizer,  0, wxGROW|wxALL, 0 );

    $self->SetSizer( $main_sizer );

    if ( my $id = $args->{itemid} ) {
        $self->load_event( $args );
    }

    elsif ( $self->{draftid} = $args->{draftid} ) {
        $self->{draft_pre} = 1;
        $self->load_draft( $args );
    }

    return $self;
}

sub load_event {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $rec = $Nikki::Interface::CLI->cached_getevent( $args );

    $rec->{subject} and $self->{ctl_subjectentry}->SetValue( $rec->{subject} );
    if ( my $buf = $self->{original_text} = $rec->{event} ) {
        my $ctl = $self->{ctl_textentry}; 
        my $j = length $buf;
        for ( my $i = 0 ; $i <= $j ; $i += 200 ) {
            $ctl->AppendText( substr $buf, $i, 200 );
#            $ctl->SetValue( substr $buf, $i, 200 );
        }
    }

    my @t = localtime;

    $args->{year}    ||= $t[5] + 1900;
    $args->{mon}     ||= $t[4] + 1;
    $args->{day}     ||= $t[3];
    $args->{hour}    ||= $t[2];
    $args->{min}     ||= $t[1];

    my $date_str     = sprintf( "%04i-%02i-%02i %02i:%02i", @$args{qw( year mon day hour min )} );
    $self->{ctl_dateentry}->SetValue( $date_str );

    if (  my $acc_name = $rec->{account} ) {
        $self->{ctl_accountsel}->SetStringSelection( $acc_name );
    }

    foreach my $k ( @Nikki::Client::EVENT_KEYS ) {
        next if $k =~ m,subject|event,;
        $self->{"event_".$k} = $rec->{$k} || $rec->{props}{$k} || '';
    }
}

sub load_draft {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $rec = $Nikki::Interface::CLI->account_load_pending( $args );

    $rec->{subject} and $self->{ctl_subjectentry}->SetValue( $rec->{subject} );
    if ( my $buf = $rec->{event} ) {
        my $ctl = $self->{ctl_textentry}; $ctl->SetValue( "" );
        $self->{original_text} = $buf;
        my $j = length $buf;
        for ( my $i = 0 ; $i <= $j ; $i += 200 ) {
            $ctl->AppendText( substr $buf, $i, 200 );
        }
    };

    my @t = localtime;

    $args->{year}    ||= $t[5] + 1900;
    $args->{mon}     ||= $t[4] + 1;
    $args->{day}     ||= $t[3];
    $args->{hour}    ||= $t[2];
    $args->{min}     ||= $t[1];

    my $date_str     = sprintf( "%04i-%02i-%02i %02i:%02i", @$args{qw( year mon day hour min )} );
    $self->{ctl_dateentry}->SetValue( $date_str );

    foreach my $k ( @Nikki::Client::EVENT_KEYS ) {
        next if $k =~ m,subject|event,;
        $self->{"event_".$k} = $rec->{$k} || $rec->{props}{$k} || '';
    }
}

sub get_form {
# --------------------------------------------------
    my $self = shift;

    my $args = {
        subject => $self->{ctl_subjectentry}->GetValue,
        event   => $self->{ctl_textentry}->GetValue,
        account => $self->{ctl_accountsel}->GetStringSelection,
        status  => 'edit',
    };

    my $date_str = $self->{ctl_dateentry}->GetValue;
    if ( my @t = $date_str =~ /(\d{4})-(\d{2})-(\d{2})(?:\s+(\d{2}):(\d{2}))?/ ) {
        @$args{qw( year mon day hour min )} = @t;
    }
    else {
        my @t = localtime;
        $args->{year}    ||= $t[5] + 1900;
        $args->{mon}     ||= $t[4] + 1;
        $args->{day}     ||= $t[3];
        $args->{hour}    ||= $t[2];
        $args->{min}     ||= $t[1];
    };

    $self->{draftid} and $args->{draftid} = $self->{draftid};

    foreach my $k ( @Nikki::Client::EVENT_KEYS ) {
        next unless exists $self->{"event_".$k};
        $args->{$k} = $self->{"event_".$k};
    }

    return $args;
}

sub is_modified {
# --------------------------------------------------
    my $self = shift;

    return (
        $self->{original_text} ne $self->{ctl_textentry}->GetValue
        or $self->{ctl_subjectentry}->IsModified
    )
}

sub ResourceInsert {
# --------------------------------------------------
    my ( $self, $profile ) = @_;

    $self->{ctl_textentry}->WriteText(
        "^resource, \"$profile->{gallery_path}\" size:main^"
#        "^resource, \"$profile->{gallery_path}\" float:left; size:thumbnail^"
    );
}

sub OnInsertResource {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    if ( my $chooser = $self->{chooser} ) {
        $chooser->Destroy;
        $self->{chooser} = undef;
    }
    else {
        $chooser = Nikki::Interface::GUI::Gallery::Chooser->new(
            {
                target_func => sub { $self->ResourceInsert( @_ ) }
            },
            $self,
            -1,
            $STR->entry( 'app_win_advanced' ),
            [-1,-1],
            [500,250],
            wxDEFAULT_FRAME_STYLE | wxRESIZE_BORDER
        );
        $self->{chooser} = $chooser;
        $chooser->Show( 1 );
    }
}

sub OnSubmitEvent {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $entry = $self->get_form;

    $entry->{draftid} = $self->{draftid} || '';

    if ( $Nikki::Interface::CLI->account_editevent( $entry ) ) {
        $Nikki::Interface::CLI->account_delete_pending( $entry );
        delete $self->{draftid};
    }
    else {
        $self->{draftid} ||= $entry->{draftid};
        my $err = join " ", map { " - $_\n" } $Nikki::Interface::CLI->error;
        my $res = Wx::MessageBox(
            $STR->string( app_str_post_fail => $err ),
            $STR->entry( 'app_str_post_fail_title' ),
            wxNO_DEFAULT | wxICON_ERROR | wxYES_NO | wxCANCEL,
            $self
        );

        if ( $res == wxYES ) {
            my $data = $self->get_form;
            $data->{mode} = 'edit';
            $Nikki::Interface::CLI->account_save_pending( $data );
        }
        elsif ( $res == wxCANCEL ) {
            return
        }
        else {
            if ( my $pk = $self->{draftid} and not $self->{draft_pre} ) {
                $Nikki::Interface::CLI->account_delete_pending( $entry );
            }
        }
    };

    $self->Close( 1 );
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    if ( $self->is_modified ) {

        my $res = Wx::MessageBox(
            $STR->entry( 'app_str_cancel_quest' ),
            $STR->entry( 'app_str_cancel_title' ),
            wxNO_DEFAULT | wxICON_QUESTION | wxYES_NO | wxCANCEL,
            $self
        );

        if ( $res == wxYES) {
            my $data = $self->get_form;
            $data->{mode} = 'edit';
            $Nikki::Interface::CLI->account_save_pending( $data );
        }
        elsif ( $res == wxCANCEL ) {
            return
        }
        else {
            if ( my $pk = $self->{draftid} and not $self->{draft_pre} ) {
                $Nikki::Interface::CLI->account_delete_pending({ 
                    account => $self->{ctl_accountsel}->GetStringSelection,
                    draftid => $pk 
                });
            }
        }

    }

    $self->Close(1);
}

sub OnAdvancedSelect {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $dialog = Nikki::Interface::GUI::EventNew::AdvDialog->new(
        $self,
        -1,
        $STR->entry( 'app_win_advanced' ),
        [-1,-1],
        [300,250]
    );

    $dialog->ShowModal;
}

1;

############################################################
#
package Nikki::Interface::GUI::EventNew;

use strict;
use vars qw/ @ISA /;
use Nikki::Config;
@ISA = 'Nikki::Interface::GUI::EventEdit';

use Wx qw(
    wxNO_DEFAULT 
    wxICON_ERROR 
    wxICON_INFORMATION
    wxICON_QUESTION 
    wxCANCEL
    wxID_CANCEL
    wxYES_NO 
    wxYES
    wxID_OK 
);

sub get_title {
# --------------------------------------------------
    return $STR->entry( 'app_win_event_new' );
}

sub new {
# --------------------------------------------------
    my $pkg  = shift;
    my $args = shift || {};

    my $self = $pkg->SUPER::new( $args, @_ ) or return;

    my @t = localtime;

    $args->{year}    ||= $t[5] + 1900;
    $args->{mon}     ||= $t[4] + 1;
    $args->{day}     ||= $t[3];
    $args->{hour}    ||= $t[2];
    $args->{min}     ||= $t[1];

    my $date_str     = sprintf( "%04i-%02i-%02i %02i:%02i", @$args{qw( year mon day hour min )} );
    $self->{ctl_dateentry}->SetValue( $date_str );

    $self->{event_security} = 'Friends';

    $args->{event} ||= $Nikki::Interface::CLI->entry_template( $args->{t} ) || '';
    if ( $self->{draftid} = $args->{draftid} ) {
        $self->load_draft( $args );
    }

    return $self;
}

sub get_form {
# --------------------------------------------------
    my $self = shift;
    my $args = $self->SUPER::get_form;
    $args->{status} = 'create';
    return $args;
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    if ( $self->is_modified ) {

        my $res = Wx::MessageBox(
            $STR->entry( 'app_str_cancel_quest' ),
            $STR->entry( 'app_str_cancel_title' ),
            wxNO_DEFAULT | wxICON_QUESTION | wxYES_NO | wxCANCEL,
            $self
        );

        if ( $res == wxYES) {
            my $data = $self->get_form;
            $Nikki::Interface::CLI->account_save_pending( $data );
        }
        elsif ( $res == wxCANCEL ) {
            return
        }
        else {
            if ( my $pk = $self->{draftid} and not $self->{draft_pre} ) {
                $Nikki::Interface::CLI->account_delete_pending({ 
                    account => $self->{ctl_accountsel}->GetStringSelection,
                    draftid => $pk 
                });
            }
        }
    }

    $self->Close(1);
}

sub OnSubmitEvent {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $entry = $self->get_form;

    $entry->{draftid} = $self->{draftid} || '';

    if ( $Nikki::Interface::CLI->account_post( $entry ) ) {
        $Nikki::Interface::CLI->account_delete_pending( $entry );
        delete $self->{draftid};
    }
    else {
        $self->{draftid} ||= $entry->{draftid};
        my $err = join " ", map { " - $_\n" } $Nikki::Interface::CLI->error;
        my $res = Wx::MessageBox(
            $STR->string( app_str_post_fail => $err ),
            $STR->entry( 'app_str_post_fail_title' ),
            wxNO_DEFAULT | wxICON_ERROR | wxYES_NO | wxCANCEL,
            $self
        );

        if ( $res == wxYES ) {
            $Nikki::Interface::CLI->account_save_pending( 
                $self->get_form
            );
        }
        elsif ( $res == wxCANCEL ) {
            return
        }
        else {
            if ( my $pk = $self->{draftid} and not $self->{draft_pre} ) {
                $self->{draft_pre} = 1;
                $Nikki::Interface::CLI->account_delete_pending( $entry );
            }
        }
    };

    $self->Close( 1 );
}

1;

############################################################
#
package Nikki::Interface::GUI::EventsCalendar;

use strict;
use vars qw( @ISA );
use Wx::Event qw( EVT_BUTTON EVT_COMBOBOX EVT_CHOICE );
use Wx qw(
    wxBITMAP_TYPE_ICO 
    wxMENU_TEAROFF 
    wxVERTICAL 
    wxGROW 
    wxALL
    wxHORIZONTAL
    wxTE_MULTILINE
    wxTE_PROCESS_ENTER 
    wxALIGN_RIGHT
    wxSUNKEN_BORDER 
);
use Wx::MDI;
use Nikki::Config;
use Wx::Html;

@ISA = 'Wx::MDIChildFrame';

sub get_title {
# --------------------------------------------------
    return $STR->entry( 'app_win_calendar' );
}

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $args = shift || {};
    my $self = $pkg->SUPER::new( @_ );

    my $accounts = $Nikki::Interface::CLI->accounts;
    my $account_list = [ 
        sort { 
            $accounts->{$a}{order} <=> $accounts->{$b}{order} 
        } keys %$accounts 
    ];

    my $accountselect = $self->{ctl_accountsel} = Wx::Choice->new(
        $self,
        -1,
        [0,0], 
        [100, 25], 
        $account_list,
    );

    foreach my $acc_name ( keys %$accounts ) {
        next unless $accounts->{$acc_name}{default};
        $accountselect->SetStringSelection( $acc_name );
        last;
    }

    my $cancelbutton = $self->{ctl_cancelbutton} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_cancel' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $cancelbutton, 
        sub { shift->OnCancel( @_ ) } # for inheritance
    );

    EVT_CHOICE(
        $self,
        $accountselect,
        sub { shift->OnSelectAccount( @_ ) }
    );

    my $resultsdisplay = $self->{ctl_resultsdisplay} = Nikki::Interface::GUI::EventsCalendar::Display->new( 
        $self, 
        -1,
        [-1,-1],
        [-1,-1],
        wxSUNKEN_BORDER 
    );

    my $main_sizer = Wx::BoxSizer->new( wxVERTICAL );
    my $acc_sizer  = Wx::BoxSizer->new( wxHORIZONTAL );

    $acc_sizer->Add( $accountselect,  1, wxGROW|wxALL, 3 );
    $acc_sizer->Add( $cancelbutton,   0, wxGROW|wxALL, 3 );

    $main_sizer->Add( $acc_sizer,      0, wxGROW|wxALL, 0 );
    $main_sizer->Add( $resultsdisplay, 9, wxGROW|wxALL, 3 );

    $self->SetSizer( $main_sizer );

    $self->{ctl_resultsdisplay}->SetPage(
        $self->{ctl_resultsdisplay}->load_calendar({
            account => $account_list->[0],
        })
    );

    return $self;
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->Close( 1 );
}

sub OnSelectAccount {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->{ctl_resultsdisplay}->SetPage(
        $self->{ctl_resultsdisplay}->load_calendar({
            account => $self->{ctl_accountsel}->GetStringSelection
        })
    );
}

1;

############################################################
#

package Nikki::Interface::GUI::EventsCalendar::Display;

use strict;
use Wx qw(
    wxVERTICAL
    wxGROW
    wxALL
);
use Wx::FS;
use Wx::Html;
use Wx::MDI;
use Nikki::Config;

use vars qw/ @ISA /;
@ISA = 'Wx::HtmlWindow';

sub get_title {
# --------------------------------------------------
    return $STR->entry( 'app_win_calendar' );
}

sub RenderSearchList {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my ( $year, $mon, $day ) = map {$_||0} @$args{qw( year mon day )};

    my $day_end = $day ? $day : 32;

    my $search_args = { 
        "date-le" => sprintf( "%04i-%02i-%02i 23:59:59", $year, $mon, $day_end ),
        "date-ge" => sprintf( "%04i-%02i-%02i 00:00:00", $year, $mon, $day ),
        account   => $args->{account}
    };

    my $results = $Nikki::Interface::CLI->db_query( $search_args ) or return;

    my $output = '<table>';

    foreach my $result ( @$results ) {

        my $display = $result->{subject} || $result->{event};

        if ( length( $display ) > 100 ) {
            $display = substr( $display, 0, 100 ) . ' ...';
        }

        $display = Nikki::Client::html_esc( $display );

        $output .= qq|
            <tr><td><font size="1"><a href="edit://$result->{itemid}/$args->{account}"><u>$result->{eventtime}</u></a></font></td></tr>
            <tr><td><font size="1">$display</font></td></tr>
        |;
    }

    $output .= '</table>';

    return $output;
}

sub RenderCalendar {
# --------------------------------------------------
    my ( $self, $args ) = @_;

# The following should be rewritten to run off
# the cache instead of making a possibly
# erroneous request to livejournal
    my $cal = $Nikki::Interface::CLI->getdaycounts({
        account => $args->{account}
    });

    my ( $year, $mon, $day ) = @$args{qw( year mon day )};

    my $month_rec = $cal->{$year}{$mon} || {};

    my $days_of_week = $self->{_daysofweek} ||= do {[
        split /\|/, $STR->entry( 'app_str_daysofweek' )
    ]};

    my $months = $self->{_month} ||= do {[
        split /\|/, $STR->entry( 'app_str_months' )
    ]};

    require Time::Local;

    my $next_mo_tics  = $mon == 12 
                        ? Time::Local::timelocal( 0, 0, 0, 1, 0,    $year - 1900 + 1 )
                        : Time::Local::timelocal( 0, 0, 0, 1, $mon, $year - 1900 );

    my @last_mo_date  = localtime( $next_mo_tics - 1 );
    my $last_mo_dow   = $last_mo_date[6];
    my $first_mo_tics = Time::Local::timelocal( 0, 0, 0, 1, $mon - 1, $year - 1900 );
    my @first_mo_date = localtime( $first_mo_tics );

    my $mo_dow = $first_mo_date[6];

    my $start_cal_tics = $first_mo_tics - 60 * 60 * 24 * $mo_dow;
    my $end_cal_tics   = $next_mo_tics  + 60 * 60 * 24 * ( 6 - $last_mo_dow );

    my @weeks;

    my $cal_buf = '';

    my @days;
    for ( my $i = $start_cal_tics; $i < $end_cal_tics ; $i += 60 * 60 * 24 ) {

        my @i_date = localtime( $i );

        push @days, {
            year => $i_date[5] + 1900,
            mon  => $i_date[4] + 1,
            day  => $i_date[3],
            dow  => $i_date[6],
        };

        if ( $i_date[6] == 6 ) {
            push @weeks, [ @days ];
            @days = ();
        }

    }
    push @weeks, [@days];

    my $next_month_link = $mon == 12 ? "cal://" . ( $year + 1 ) . '/1'  : "cal://$year/" . ( $mon + 1 );
    $next_month_link    .= "/$args->{account}";
    my $prev_month_link = $mon == 1  ? "cal://" . ( $year - 1 ) . '/12' : "cal://$year/" . ( $mon - 1 );
    $prev_month_link    .= "/$args->{account}";

    $cal_buf = qq{
        <table width="170">
            <tr>

                <td align="left">
                    <a href="$prev_month_link">&lt;</a>
                </td>

                <td colspan="5" align="center"><font size="1">
                    <a href="cal://$year/$mon/$args->{account}">
                    $months->[$mon-1]&nbsp;$year
                    </a>
                </font></td>

                <td align="right">
                    <a href="$next_month_link">&gt;</a>
                </td>

            </tr>
    };

    foreach my $week ( @weeks ) {
        $cal_buf .= '<tr>';
        foreach my $day ( @$week ) {

            my $has_events = $cal->{$day->{year}}{$day->{mon}}{$day->{day}};
            my $sel_month   = $mon == $day->{mon};

            $cal_buf .= $has_events ? '<td bgcolor="#dddddd">' : '<td>';
            $cal_buf .= $sel_month   ? '<font size="3">' : '<font size="1">';

            if ( $sel_month and $day->{day} == $day ) {
                $cal_buf .= "<b>$day->{day}</b>";
            }
            else {
                $cal_buf .= $has_events ? qq|
                    <a href="cal://$day->{year}/$day->{mon}/$day->{day}/$args->{account}">
                        $day->{day}
                    </a>
                    | 
                    : 
                    $day->{day};
            }

            $cal_buf .= '</font>';
            $cal_buf .= '</td>';

        }
        $cal_buf .= '</tr>';
    }
    $cal_buf .= '</table>';

    return $cal_buf;
}

sub OnLinkClicked {
# --------------------------------------------------
    my ( $self, $link_info ) = @_;

    my $href = $link_info->GetHref;

    LINK_ACTION: {

        $href =~ m,^cal://(\d\d\d\d)/(\d?\d)/(?:(\d?\d)/)?(.*), and do {
            $self->SetPage(
                $self->load_calendar({ 
                    year    => $1, 
                    mon     => $2,
                    day     => $3,
                    account => $4
                })
            )
        };

        $href =~ m,^edit://(\d+)/(.*), and do {
            my $edit_window = $self->GetParent
                 ->GetParent
                 ->GetParent
                 ->CreateChildFrame( 
                     'Nikki::Interface::GUI::EventEdit',
                     {
                         itemid  => $1,
                         account => $2
                     }
                 );
            last;
        };

        $href =~ m,^draft://(\w+)(\/delete)?\/(.+), and do {
            my $draftid  = $1;
            my $acc_name = $3;

            if ( $2 ) { # delete 
                my $rec = $Nikki::Interface::CLI->account_delete_pending({
                    account => $acc_name,
                    draftid => $draftid,
                });

                $self->SetPage(
                    $self->RenderDraftsList({
                        account => $acc_name,
                        draftid => $draftid,
                    })
                );
            }

            else {

                my $rec = $Nikki::Interface::CLI->account_load_pending({
                    account => $acc_name,
                    draftid => $draftid,
                });

                my $itemid = $rec->{itemid} || '';

                my $pkg = $rec->{mode} 
                            ? 'Nikki::Interface::GUI::EventEdit'
                            : 'Nikki::Interface::GUI::EventNew';

                my $edit_window = $self->GetParent
                     ->GetParent
                     ->GetParent
                     ->CreateChildFrame( 
                         $pkg,
                         {
                             draftid => $draftid,
                             account => $acc_name,
                             itemid  => $itemid,
                         }
                     );

            };

            last;
        };
    }

}

sub RenderSearchResults {
# --------------------------------------------------
    my ( $self, $search_args ) = @_;

    my $results = $Nikki::Interface::CLI->db_query( $search_args ) or return;

    my $tags = {%$search_args};
    my @search_results;

    foreach my $result ( @$results ) {

        my $display = $result->{event};

        if ( length( $display ) > 300 ) {
            $display = substr( $display, 0, 300 ) . ' ...';
        }

        $display = Nikki::Client::html_esc( $display );

        my $entry = {%$result};
        $entry->{display} = $display;
        push @search_results, $entry;
    }

    @search_results and $tags->{search_results} = \@search_results;

    return Nikki::Template->parse(
        $STR->entry( 'app_display_search_results' ),
        'app_display_search_results',
        $tags
    );
}

sub RenderDraftsList {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my $drafts_list = $Nikki::Interface::CLI->account_list_pending( $args );

    my $tags = {%$args};
    my @drafts_list;
    foreach my $result ( reverse @$drafts_list ) {

        my $datestr = localtime $result->{mtime};
        my $display = $result->{event} || '';

        if ( length( $display ) > 300 ) {
            $display = substr( $display, 0, 300 ) . ' ...';
        }

        $display = Nikki::Client::html_esc( $display );

        my $draft_info = {%$result};
        $draft_info->{datestr} = $datestr;
        $draft_info->{display} = $display;
        push @drafts_list, $draft_info;
    }

    @drafts_list and $tags->{drafts_list} = \@drafts_list;

    return Nikki::Template->parse(
        $STR->entry( 'app_display_drafts' ),
        'app_display_drafts',
        $tags
    );
}

sub load_calendar {
# --------------------------------------------------
    my ( $self, $args ) = @_;

    my @today = localtime;

    $args->{year} ||= $today[5] + 1900;
    $args->{mon}  ||= $today[4] + 1;
#    $args->{day}  ||= $today[3];

    $args->{mon} < 1 and do {
        $args->{year}--;
        $args->{mon} = 12;
    };

    $args->{mon} > 12 and do {
        $args->{year}++;
        $args->{mon} = 1;
    };

    my $output = "<table><tr>";
    $output   .= '<td valign="top" width="170">' . $self->RenderCalendar( $args ) . "</td>";
    $output   .= '<td valign="top">' . ( $self->RenderSearchList( $args ) || '' ) . "</td>";
    $output   .= "</tr></table>";

    return $output;
}

1;

package Nikki::Interface::GUI::EventsSearch;

use strict;
use vars qw( @ISA );
use Wx::Event qw( EVT_BUTTON EVT_TEXT_ENTER );
use Wx qw(
    wxBITMAP_TYPE_ICO 
    wxMENU_TEAROFF 
    wxVERTICAL 
    wxGROW 
    wxALL
    wxHORIZONTAL
    wxTE_MULTILINE
    wxTE_PROCESS_ENTER 
    wxSUNKEN_BORDER 
);
use Wx::MDI;
use Nikki::Config;
use Wx::Html;

@ISA = 'Wx::MDIChildFrame';

sub get_title {
# --------------------------------------------------
    return $STR->entry( 'app_win_search' );
}

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $args = shift || {};
    my $self = $pkg->SUPER::new( @_ );

    my $subjectentry = $self->{ctl_keywordentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [100, 25], 
        wxTE_PROCESS_ENTER 
    );

    my $accounts = $Nikki::Interface::CLI->accounts;
    my $account_list = [ 
        sort { $accounts->{$a}{order} <=> $accounts->{$b}{order} } keys %$accounts 
    ];

    my $accountselect = $self->{ctl_accountsel} = Wx::Choice->new(
        $self,
        -1,
        [0,0], 
        [100, 25], 
        $account_list,
    );

    foreach my $acc_name ( keys %$accounts ) {
        next unless $accounts->{$acc_name}{default};
        $accountselect->SetStringSelection( $acc_name );
        last;
    }

    my $submitentry = $self->{ctl_submitentry} = Wx::Button->new( 
        $self, 
        -1, 
        $STR->entry( 'app_widget_search' ),
        [0, 0], 
        [75, 25]
    );

    my $cancelbutton = $self->{ctl_cancelbutton} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_cancel' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $cancelbutton, 
        sub { shift->OnCancel( @_ ) } # for inheritance
    );

    EVT_BUTTON( 
        $self, 
        $submitentry, 
        sub { shift->OnSearchEvents( @_ ) } # for inheritance
    );

    EVT_TEXT_ENTER( $self, $subjectentry, sub { shift->OnSearchEvents( @_ ) } );

    my $resultsdisplay = $self->{ctl_resultsdisplay} = Nikki::Interface::GUI::EventsCalendar::Display->new( 
        $self, 
        -1,
        [-1,-1],
        [-1,-1],
        wxSUNKEN_BORDER 
    );

    my $main_sizer = Wx::BoxSizer->new( wxVERTICAL );
    my $subj_sizer = Wx::BoxSizer->new( wxHORIZONTAL );
    my $acc_sizer  = Wx::BoxSizer->new( wxHORIZONTAL );

    $subj_sizer->Add( $subjectentry,   1, wxGROW|wxALL, 3 );
    $subj_sizer->Add( $submitentry,    0, wxGROW|wxALL, 3 );

    $acc_sizer->Add( $accountselect,   1, wxGROW|wxALL, 3 );
    $acc_sizer->Add( $cancelbutton,    0, wxGROW|wxALL, 3 );

    $main_sizer->Add( $acc_sizer,      0, wxGROW|wxALL, 0 );
    $main_sizer->Add( $subj_sizer,     0, wxGROW|wxALL, 0 );
    $main_sizer->Add( $resultsdisplay, 9, wxGROW|wxALL, 3 );

    $self->SetSizer( $main_sizer );

    return $self;
}

sub RenderSearchResults {
# --------------------------------------------------
    my ( $self, $search_args ) = @_;

    my $results = $Nikki::Interface::CLI->db_query( $search_args ) or return;

    my $output = '<table>';

    foreach my $result ( @$results ) {

        my $display = $result->{event};

        if ( length( $display ) > 300 ) {
            $display = substr( $display, 0, 300 ) . ' ...';
        }

        $display = Nikki::Client::html_esc( $display );

        $output .= qq|
            <tr>
                <td>
                <a href="edit://$result->{itemid}/$search_args->{account}">
                    <u><font size="1">$result->{eventtime}</font></u>
                </a>
                </td>
            </tr>
            <tr>
                <td><font size="1">
                    $display
                </font></td>
            </tr>
        |;
    }

    $output .= '</table>';

    return $output;
}

sub OnSearchEvents {
# --------------------------------------------------
    my ( $self, $events ) = @_;

    $self->{ctl_resultsdisplay}->SetPage(
        $self->RenderSearchResults({
            account  => $self->{ctl_accountsel}->GetStringSelection,
            keywords => $self->{ctl_keywordentry}->GetValue
        }) || ''
    );
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->Close( 1 );
}

1;

############################################################
#
package Nikki::Interface::GUI::ViewDrafts;

use strict;
use vars qw( @ISA );
use Wx::Event qw( EVT_BUTTON EVT_TEXT_ENTER EVT_CHOICE EVT_TIMER );
use Wx qw(
    wxBITMAP_TYPE_ICO 
    wxMENU_TEAROFF 
    wxVERTICAL 
    wxGROW 
    wxALL
    wxHORIZONTAL
    wxTE_MULTILINE
    wxTE_PROCESS_ENTER 
    wxSUNKEN_BORDER 
);
use Wx::MDI;
use Nikki::Config;
use Wx::Html;

@ISA = 'Wx::MDIChildFrame';

sub get_title {
# --------------------------------------------------
    return $STR->entry( 'app_win_draft' );
}

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $args = shift || {};
    my $self = $pkg->SUPER::new( @_ );

    my $main_sizer = Wx::BoxSizer->new( wxVERTICAL );

    my $accounts = $Nikki::Interface::CLI->accounts;
    my $account_list = [ 
        sort { 
            $accounts->{$a}{order} <=> $accounts->{$b}{order} 
        } keys %$accounts 
    ];

    my $accountselect = $self->{ctl_accountsel} = Wx::Choice->new(
        $self,
        -1,
        [0,0], 
        [100, 25], 
        $account_list,
    );

    foreach my $acc_name ( keys %$accounts ) {
        next unless $accounts->{$acc_name}{default};
        $accountselect->SetStringSelection( $acc_name );
        last;
    }

    EVT_CHOICE(
        $self,
        $accountselect,
        sub { shift->OnSelectAccount( @_ ) }
    );

    my $cancelbutton = $self->{ctl_cancelbutton} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_cancel' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $cancelbutton, 
        sub { shift->OnCancel( @_ ) } # for inheritance
    );

    my $acc_sizer  = Wx::BoxSizer->new( wxHORIZONTAL );
    $acc_sizer->Add( $accountselect,   1, wxGROW|wxALL, 3 );
    $acc_sizer->Add( $cancelbutton,    0, wxGROW|wxALL, 3 );

    $main_sizer->Add( $acc_sizer,      0, wxGROW|wxALL, 0 );

    my $results_display = $self->{ctl_resultsdisplay} = Nikki::Interface::GUI::EventsCalendar::Display->new( 
        $self, 
        -1,
        [-1,-1],
        [-1,-1],
        wxSUNKEN_BORDER 
    );

    $main_sizer->Add( $results_display, 9, wxGROW|wxALL, 3 );
    $self->SetSizer( $main_sizer );

    my $redraw_timer = $self->{timer_redraw} = Wx::Timer->new( $self, 1 );
    $redraw_timer->Start( 1000 );
    EVT_TIMER( $self, 1, sub { shift->load_draftlist() });

    $self->load_draftlist;

    return $self;
}

sub load_draftlist {
# --------------------------------------------------
    my $self = shift;

    $self->{prev_page} ||= '';
    my $new_page = $self->{ctl_resultsdisplay}->RenderDraftsList({
        account => $self->{ctl_accountsel}->GetStringSelection
    });

    if ( $self->{prev_page} ne $new_page ) {
        $self->{ctl_resultsdisplay}->SetPage( $new_page );
        $self->{prev_page} = $new_page;
    }
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->Close( 1 );
}

sub OnSelectAccount {
# --------------------------------------------------
    shift->load_draftlist;
}

sub DESTROY {
# --------------------------------------------------
    my $self = shift;
    if ( my $tr = $self->{timer_redraw} ) {
        $tr->Stop;
    }
}

1;

############################################################
# 
package Nikki::Interface::GUI::Gallery::Chooser;

use strict;
use vars qw/ @ISA /;
use Wx qw(
    wxGROW 
    wxALL
    wxVERTICAL
    wxHORIZONTAL
    wxDefaultSize
    wxALIGN_RIGHT
    wxALIGN_CENTRE
    wxSUNKEN_BORDER
);
use Wx::Event qw( EVT_CLOSE );

use Nikki::Config;
@ISA = 'Wx::Dialog';

sub new {
# --------------------------------------------------
    my $pkg  = shift;
    my $args = shift;

    my $self = $pkg->SUPER::new( @_ );

    my $main_sizer = Wx::BoxSizer->new( wxVERTICAL );

    @$self{ keys %$args } = values %$args;
    $args->{chooser} = 1;

    my $gal_win = $self->{gallery_win} = Nikki::Interface::GUI::Gallery::Display->new(
        $args,
        $self, 
        -1,
        [-1,-1],
        [-1,-1],
        wxSUNKEN_BORDER 
    );

    $main_sizer->Add( $gal_win, 1, wxGROW|wxALL, 3 );

    $self->SetSizer( $main_sizer );

    EVT_CLOSE( $self, sub { shift->OnClose( @_ ) } );

    return $self;
}

sub OnClose {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->GetParent->{chooser} = undef;
    $event->Skip;
}

1;

############################################################
# 
package Nikki::Interface::GUI::Gallery;

use strict;
use vars qw( @ISA );

use Wx::Event qw( 
    EVT_BUTTON 
    EVT_TEXT_ENTER 
    EVT_SIZE 
    EVT_CHOICE 
);

use Wx qw(
    wxBITMAP_TYPE_ICO 
    wxALIGN_RIGHT
    wxMENU_TEAROFF 
    wxVERTICAL 
    wxGROW 
    wxALL
    wxHORIZONTAL
    wxTE_MULTILINE
    wxTE_PROCESS_ENTER 
    wxSUNKEN_BORDER 
);
use Wx::MDI;
use Nikki::Config;
use Wx::Html;

@ISA = 'Wx::MDIChildFrame';

sub get_title {
# --------------------------------------------------
    return $STR->entry( 'app_win_photo' );
}

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $args = shift || {};
    my $self = $pkg->SUPER::new( @_ );

    my $main_sizer = Wx::BoxSizer->new( wxVERTICAL );

    my $cancelbutton = $self->{ctl_cancelbutton} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_cancel' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $cancelbutton, 
        sub { shift->OnCancel( @_ ) } # for inheritance
    );

    my $acc_sizer  = Wx::BoxSizer->new( wxHORIZONTAL );
    $acc_sizer->Add( $cancelbutton,    1, wxGROW|wxALL, 3 );
    $main_sizer->Add( $acc_sizer,      0, wxGROW|wxALIGN_RIGHT, 3 );

    my $gal_win = $self->{gallery_win} = Nikki::Interface::GUI::Gallery::Display->new(
        $args,
        $self, 
        -1,
        [-1,-1],
        [-1,-1],
        wxSUNKEN_BORDER 
    );

    $main_sizer->Add( $gal_win, 1, wxGROW|wxALL, 3 );

    $self->SetSizer( $main_sizer );
    
    return $self;
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->Close( 1 );
}

sub OnSelectAccount {
# --------------------------------------------------
}


1;

############################################################
#
package Nikki::Interface::GUI::Gallery::Display;

use strict;
use vars qw( @ISA $INC_COUNTER );

use Wx::Event qw( 
    EVT_BUTTON 
    EVT_TEXT_ENTER 
    EVT_CHOICE 
    EVT_TIMER 
    EVT_MENU
    EVT_SIZE 
    EVT_RIGHT_DOWN
    EVT_RIGHT_UP
    EVT_LEFT_DCLICK
);

use Wx qw(
    wxBITMAP_TYPE_ICO 
    wxMENU_TEAROFF 
    wxVERTICAL 
    wxGROW 
    wxALL
    wxHORIZONTAL
    wxTE_MULTILINE
    wxTE_PROCESS_ENTER 
    wxSUNKEN_BORDER 

    wxOPEN
    wxMULTIPLE

    wxID_CANCEL
);

use Wx::MDI;
use Nikki::Config;
use Wx::Html;

@ISA = 'Wx::HtmlWindow';

sub new {
# --------------------------------------------------
    my $pkg  = shift;
    my $args = shift;

    Wx::Image::AddHandler( Wx::JPEGHandler->new );

    my $self = $pkg->SUPER::new( @_ );

    @$self{keys %$args} = values %$args;
    $self->{chooser} = $args->{chooser} || 0;

    $self->{gallery} = $Nikki::Interface::CLI->gallery;

    EVT_SIZE( 
        $self, 
        sub { shift->resize_gallery } 
    );

# This has been commented out since
# sub resize_gallery should capture the 
# initial resize to fit into the windowframe
# Leaving the following code in here will simply
# cause needless calculations and slow the initial 
# draw down 
#
#    $self->dirty;
#    $self->load_page;

    EVT_RIGHT_DOWN(
        $self,
        sub {
            shift->right_down( @_ );
        }
    );

    EVT_RIGHT_UP(
        $self,
        sub {
            shift->context_menu( @_ );
        }
    );

    EVT_LEFT_DCLICK(
        $self,
        sub {
            shift->choose_image( @_ );
        }
    );

    return $self;
}

sub choose_image {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    if (
        $self->{last_selected} 
        and my $profile = $self->{gallery}->image_load_profile( $self->{last_selected} )
    ) {
        if ( $self->{target_func}) {
            $self->{target_func}->( $profile );
            $self->{selected_images} = {};
#            $self->GetParent->Close; # interface is nicer if the dialog doesn't close
        }
        else {
            my $image_list = $self->{gallery}->image_list;
            my $edit_window = $self->open_child_window(
                 'Nikki::Interface::GUI::Gallery::Zoom',
                 {
                     gallery => $self->{gallery},
                     photo   => $self->{last_selected},
                     image_list => $image_list,
                     browser => $self,
                 }
            );
        }
    }
}

sub right_down {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->{right_button_down} = 1;
    $event->Skip;
}

sub context_menu {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    $self->{right_button_down} = 0;

    my $pt = $event->GetPosition;
    my ( $x, $y ) = ( $pt->x, $pt->y );

    my $menu = $self->{menu_structure} ||= do {
        my $menu_structure = $STR->entry( 'gal_menu_structure' );

        my $m = Wx::Menu->new( '' );

        my $id = 100;
        foreach my $menu_entry ( @$menu_structure ) {
            GAL_MENU_STRUCT: {

            if ( not ref $menu_entry ) {
                $m->AppendSeparator;
                next;
            }

            $id++;
            $m->Append( 
                $id, 
                $menu_entry->[0],
                $menu_entry->[1]
            );

            if ( my $fun = $menu_entry->[2] ) {
                my $act_func = $menu_entry->[3] ?
                    sub { shift->$fun( $menu_entry->[3], @_ ) }
                  : sub { shift->$fun( @_ ) };

                EVT_MENU( 
                    $self, 
                    $id, 
                    $act_func
                );
            }

            }
        };

        $m;
    };

    $self->PopupMenu( $menu, $x, $y);
    return 1;
};

sub open_child_window {
# --------------------------------------------------
    my ( $self, $class, $args ) = @_;
    $Nikki::Interface::IFACE->{mframe}->CreateChildFrame( $class, $args );
}

sub image_action {
# --------------------------------------------------
    my ( $self, $action, $event ) = @_;

    if ( 'edit_description' eq $action ) {
        my $edit_window = $self->open_child_window(
             'Nikki::Interface::GUI::Gallery::Image',
             {
                 gallery => $self->{gallery},
                 action  => $action,
                 photo   => $self->{last_selected}
             }
        );

        my ( $x, $y ) = $self->GetViewStart;
        $self->dirty;
        $self->load_page;
        $self->Scroll( $x, $y );

        return;
    }

    elsif ( 'gimp_original' eq $action ) {
        my $photo = $self->{last_selected} or return;
        my $photo_rec = $self->{gallery}->image_load_profile( $photo );
        my $source_path = $photo_rec->{"source_path"};

        return if fork;
        exec "gimp-remote", "-n", $source_path;
        return;
    }

    elsif ( 'gimp_medium' eq $action ) {
        my $photo = $self->{last_selected} or return;
        my $photo_rec = $self->{gallery}->image_load_profile( $photo );
        my $source_path = $photo_rec->{"main_path"};

        system "gimp-remote", "-n", $source_path;
        return;
    }

    elsif ( 'copy_single' eq $action ) {
        my $photo = $self->{last_selected} or return;
        $self->{gallery}{clipboard}{"/$self->{gallery}{gallery_path}/$photo"} = 1;

        my ( $x, $y ) = $self->GetViewStart;
        $self->dirty;
        $self->load_page;
        $self->Scroll( $x, $y );
        return;
    }

    elsif ( 'copy_selected' eq $action ) {
        my $selected_images = $self->{selected_images} || {};
        foreach my $image ( keys %$selected_images ) {
            $self->{gallery}{clipboard}{"/$self->{gallery}{gallery_path}/$image"} = 1;
        }

        my ( $x, $y ) = $self->GetViewStart;
        $self->dirty;
        $self->load_page;
        $self->Scroll( $x, $y );
        return;
    }

    elsif ( 'paste' eq $action ) {
        my $selected_images = $self->{selected_images} || {};
        $self->{gallery}->image_copy( keys %$selected_images );
    }

    elsif ( 'edit_view' eq $action ) {
        my $image_list = $self->{gallery}->image_list;
        my $edit_window = $self->open_child_window(
             'Nikki::Interface::GUI::Gallery::Zoom',
             {
                 gallery => $self->{gallery},
                 photo   => $self->{last_selected},
                 image_list => $image_list,
             }
        );
    }

    elsif ( 'sort_bytime' eq $action ) {
        my $contents  = $self->{gallery}->image_list;
        my $selected_images = $self->{selected_images} || {};
        $self->{gallery}->image_copy( keys %$selected_images );
    }

    elsif ( 'edit_delete' eq $action ) {
        my $photo = $self->{last_selected} or return;
        $self->{gallery}->image_delete( $photo ) or return;

        my ( $x, $y ) = $self->GetViewStart;
        $self->dirty;
        $self->load_page;
        $self->Scroll( $x, $y );

        return;
    }
    elsif ( 'edit_view_all' eq $action ) {
        foreach my $im (keys %{$self->{selected_images}||{}}) {
            my $image_list = $self->{gallery}->image_list;
            my $edit_window = $self->open_child_window(
                 'Nikki::Interface::GUI::Gallery::Zoom',
                 {
                     gallery => $self->{gallery},
                     action  => $action,
                     photo   => $im,
                     image_list => $image_list
                 }
            );
        }

        my ( $x, $y ) = $self->GetViewStart;
        $self->dirty;
        $self->load_page;
        $self->Scroll( $x, $y );

        return;
    }
    elsif ( 'edit_select_all' eq $action ) {
        my $contents = $self->{gallery}->image_list;

        $self->{selected_images} = {
            map {( $_->{base_name} => 1 )} @$contents
        };

        my ( $x, $y ) = $self->GetViewStart;
        $self->dirty;
        $self->load_page;
        $self->Scroll( $x, $y );
        return;
    }
    elsif ( 'edit_deselect_all' eq $action ) {
        $self->{selected_images} = {};
        my ( $x, $y ) = $self->GetViewStart;
        $self->dirty;
        $self->load_page;
        $self->Scroll( $x, $y );
        return;
    }

    my $selected_images = $self->{selected_images};
    $selected_images = [ 
        grep { $selected_images->{$_} } keys %$selected_images
    ];
    return unless @$selected_images;

    my $args = {
        images => $selected_images,
        action => $action
    };

    $self->{gallery}->image_edit( $args );

    my ( $x, $y ) = $self->GetViewStart;
    $self->dirty;
    $self->load_page;
    $self->Scroll( $x, $y );
}

sub selected_images {
# --------------------------------------------------
    my $self = shift;
    my $selected_images = $self->{selected_images} or return [];
    my @selected = grep $selected_images->{$_}, keys %$selected_images;
    return \@selected;
}

sub OnLinkClicked {
# --------------------------------------------------
    my ( $self, $link_info ) = @_;

    my $href = $link_info->GetHref;

    LINK_ACTION: {

        $href =~ m|^gallery://(.*)| and do {
            $self->gallery_action( $1 );
            last;
        };

        $href =~ m|^subgallery://(.*)| and do {
#            if ( $1 ne $self->{gallery}{gallery_path} ) {
                $self->{selected_images} = {}; # dump old selects
                $self->{gallery}{gallery_path} = $1;
                $self->dirty;
                $self->load_page;
#            }
            last;
        };

        $href =~ m|^clipboard://(.*)| and do {
            if ( 'view' eq $1 ) {
                $self->dirty;
                $self->load_clipboard;
            }
            elsif ( 'paste' eq $1 ) {
                $self->dirty;
                my $clipboard = $self->{gallery}{clipboard} || {};
                $self->{gallery}->image_copy(
                    $self->{gallery}{gallery_path},
                    keys %$clipboard
                );

                my ( $x, $y ) = $self->GetViewStart;
                $self->dirty;
                $self->load_page;
                $self->Scroll( $x, $y );
            }
            elsif ( 'clear' eq $1 ) {
                $self->{gallery}{clipboard} = {};
            }
            last;
        };

        $href =~ m|^photo://reorder/(.*)| and do {
            my $func     = $1;
            my $vector   = 0;
            my $anchor   = '';

            if ( $func =~ /back\((\d+),(\w+)\)/ ) {
                $vector = -$1;
                $anchor = $2;
            }
            elsif ( $func =~ /forward\((\d+),(\w+)\)/ ) {
                $vector = $1;
                $anchor = $2;
            }
            else { last };

            $vector or return;

            my $contents  = $self->{gallery}->image_list;
            my $selected = $self->{selected_images} ||= {};

            my ( @to_move, @base_items, $positional_index );
            foreach my $item ( @$contents ) {
                my $base_name = $item->{base_name};

                if ( $base_name eq $anchor) {
                    $positional_index = @base_items;

                    unless ( keys %$selected ) {
                        push @to_move, $item;
                        next;
                    }
                }

                if ( $selected->{$base_name} ) {
                    push @to_move, $item;
                }
                else {
                    push @base_items, $item;
                }
            }

# if we are moving item forard
            if ( $vector > 0 ) {

# If the user has the anchor as one of the selected movments
# we don't have to apply anny corection factor
                $vector += $selected->{$anchor} 
                    ?  0 

# however if the user user has not selected the anchor as one of
# the items to move, we must offset by just one in the case of selection
# movements and offset by two in the case of item movements
                    : keys %$selected ? 0 : 0;
            }

# If we are moving the item backwards
            else {
                $vector += $selected->{$anchor} ? 0 : 0;
            }

# Now insert into the base items the new selection
            $positional_index += $vector;
            $positional_index > @base_items and $positional_index = @base_items;
            $positional_index < 0 and $positional_index = 0;

            splice @base_items, $positional_index, 0, @to_move;

# Now, inform the system of this new order
            $self->{gallery}->gallery_reorder(
                $self->{gallery}{gallery_path},
                ( map {$_->{base_name}} @base_items )
            );

            $self->{selected_images} = {}; # dump old selects

# Guess we have to redraw all the screen stuff
            my ( $x, $y ) = $self->GetViewStart;
            $self->dirty;
            $self->load_page;
            $self->Scroll( $x, $y );

            last;

        };

        $href =~ m,^photo://select/(.*), and do {
            $self->{selected_images}{$1} = $self->{right_button_down} || not( $self->{selected_images}{$1} || 0 );
            $self->{last_selected} = $1;
            unless ( $self->{right_button_down} ) {
                my ( $x, $y ) = $self->GetViewStart;
                $self->dirty;
                $self->load_page;
                $self->Scroll( $x, $y );
            }
            last;
        };

        $href =~ m,^photo://(\w+)\/(.*), and do {

            my $edit_window = $self->open_child_window(
                 'Nikki::Interface::GUI::Gallery::Zoom',
                 {
                     gallery => $self->{gallery},
                     action  => $1,
                     photo   => $2
                 }
            );

            last;
        };

        return $self->SUPER::OnLinkClicked( $link_info );

    }
}

sub gallery_action {
# --------------------------------------------------
    my ( $self, $path ) = @_;

    if ( $path =~ /^add/ ) {

        my $dlg_name = Wx::TextEntryDialog->new(
            $self,
            $STR->entry('app_dlg_newgal_message' ),
            $STR->entry('app_dlg_newgal_title' )
        );

        if ( $dlg_name->ShowModal == wxID_CANCEL ) {
            return;
        }
        elsif ( my $name = $dlg_name->GetValue ) {
            $self->{gallery}->gallery_add(
                undef,
                {
                    name => $name,
                }
            ) and do {
                $self->dirty;
                $self->load_page;
            }
        }

    }

    elsif ( $path =~ /^publish/ ) {

        $Nikki::Interface::CLI->gallery->gallery_resync;
        $Nikki::Interface::CLI->gallery->ftp_upload_gallery({
            auto_select => 1
        });
    }

    elsif ( $path =~ /transfer/ ) {
        my $whereto_dlg = Wx::DirDialog->new(
            $self,
            -1,
            $CFG->{gallery_look_path},
        );

# Seems we have to rebless this object into Wx::DirDialog 
# since in my version of Wx:: it only blesses as a Wx::Dialog
# It appears the initialization on the Wx side is fine, however
        unless ( ref $whereto_dlg eq 'Wx::DirDialog' ) {
            $whereto_dlg = bless $whereto_dlg, 'Wx::DirDialog';
        }

        if ( $whereto_dlg->ShowModal == wxID_CANCEL ) {
            return;
        }
        else {
            if ( my $selected = $whereto_dlg->GetPath ) {
                $self->{gallery}->image_transfer( undef, $selected );
            }
        }

    }

    elsif ( $path =~ /^image_add/ ) {

        my $dlg_imgs = Wx::FileDialog->new(
            $self,
            $STR->entry( 'app_dlg_images_import' ),
            '', # prev file
            $CFG->{gallery_look_path}, # prev dir
            $STR->entry( 'app_dlg_images_files' ),
            wxOPEN|wxMULTIPLE
        );

        if ( $dlg_imgs->ShowModal == wxID_CANCEL ) {
            return;
        }
        else {
            if ( my @selected = $dlg_imgs->GetPaths ) {
                my $busy_info = $CFG->{no_busy_info} ? undef : Wx::BusyInfo->new(
                    $STR->entry( 'gal_image_acquiring' )
                );
                $self->{gallery}->image_add( undef, @selected );
                $self->dirty;
                $self->load_page;
            }
        }
    }
    
    elsif ( $path =~ /^mh\/(\d+)/ ) {
        $self->{mh} = int $1;
        $self->dirty;
        $self->load_page;
    }

    elsif ( $path =~ /^page\/(\d+)/ ) {
        $self->{nh} = int $1;
        $self->dirty;
        $self->load_page;
    }


}

sub RenderBrowser {
# --------------------------------------------------
    my ( $self, $path ) = @_;
    my $buf = '';

    my $galleries = $self->{gallery}->gallery_list( $path );
    my $contents  = $self->{gallery}->image_list( $path );
    my $widest    = 0;
    foreach my $item ( @$contents ) {
        $widest < $item->{thumbnail_width}
            and $widest = $item->{thumbnail_width};
    }

    my ( $w, $h ) = $self->GetSizeWH;

# prevent wierd multiple calls on instantiation
    return '' unless $w > 100; 

    my $tags = {};

# Create the pager that will allow users to receed out of Gallery
    if ( my $curr_gal = $self->{gallery}{gallery_path} ) {
        my @elements  = grep $_, split m,/,, $curr_gal;
        my @gallery_path_loop;
        my $curr_path = '';
        foreach my $e ( @elements ) {
            $curr_path    .= $e;

            push @gallery_path_loop, {
                gallery_link_path => $curr_path,
                gallery_path_name => $e
            };

            $curr_path    .= '/';
        }

        $tags->{gallery_path_loop} = \@gallery_path_loop;
    };

# Create a loop struct for sub galleries to this folder
    if ( @$galleries ) {
        my @subgallery_loop;
        foreach my $gallery ( @$galleries ) {
            my $gal_profile = {};
            @$gal_profile{
                map { "subgallery_$_" }
                keys %$gallery
            } = values %$gallery;
            push @subgallery_loop, $gal_profile;
        }

        $tags->{subgallery_loop} = \@subgallery_loop;
    }

    my $per_row = int( $w / ( $widest + 20 ) ) || 1;
    $tags->{images_per_row} = $per_row;

# Loop struct each of the images in this current gallery
#    my $mh = $self->{mh} || 10000000;
    my $mh = $self->{mh} || 25;
    my $nh = $self->{nh} || 1;

# Setup the paging information

    my $si = ( ( $nh - 1 ) * $mh );
    my $ei = $si + $mh;
    $ei > $#$contents and $ei = @$contents;

    my @content_loop;
#    foreach my $i ( 0..$#$contents ) {
    foreach my $i ( $si..($ei-1) ) {
        my $item = $contents->[ $i ];
        my $content_item = {%$item};
        $content_item->{is_selected} = $self->{selected_images}{$item->{base_name}};
        push @content_loop, $content_item;
    }

    $tags->{content_loop} = \@content_loop;

    my $num_pages = int( $#$contents / $mh + ( $#$contents % $mh ? 1 : 0 ) );
    my @page_loop;
    foreach my $i ( 1..$num_pages ) {
        push @page_loop, {
            page_number   => $i,
            page_selected => ( $i == $nh )
        };
    }
    @page_loop > 1 and $tags->{page_loop} = \@page_loop;

    $tags->{num_images} = @$contents;

    my $display = Nikki::Template->parse(
        $STR->entry( 'gal_display_gallery' ),
        'gal_display_gallery',
        $tags
    );

    return $display;
}

sub RenderClipboard {
# --------------------------------------------------
    my ( $self, $path ) = @_;
    my $buf = '';

    my $galleries = $self->{gallery}->gallery_list( $path );
    my $contents  = $self->{gallery}->image_list( $path );
    my $widest    = 0;
    foreach my $item ( @$contents ) {
        $widest < $item->{thumbnail_width}
            and $widest = $item->{thumbnail_width};
    }

    my ( $w, $h ) = $self->GetSizeWH;

# prevent wierd multiple calls on instantiation
    return '' unless $w > 100; 

    my $tags = {};

# Create the pager that will allow users to receed out of Gallery
    if ( my $curr_gal = $self->{gallery}{gallery_path} ) {
        my @elements  = grep $_, split m,/,, $curr_gal;
        my @gallery_path_loop;
        my $curr_path = '';
        foreach my $e ( @elements ) {
            $curr_path    .= $e;

            push @gallery_path_loop, {
                gallery_link_path => $curr_path,
                gallery_path_name => $e
            };

            $curr_path    .= '/';
        }

        $tags->{gallery_path_loop} = \@gallery_path_loop;
    };

    my $clipboard = $self->{gallery}{clipboard} || {};
    my @content_loop;
    foreach my $img ( keys %$clipboard ) {
        my $profile = $self->{gallery}->image_load_profile( $img );
        push @content_loop, $profile;
    }
    @content_loop and $tags->{content_loop} = \@content_loop;

    my $display = Nikki::Template->parse(
        $STR->entry( 'gal_display_clipboard' ),
        'gal_display_clipboard',
        $tags
    );

    return $display;
}

sub load_page {
# --------------------------------------------------
    my ( $self, $path ) = @_;
    return unless $self->{dirty};
    $self->{dirty} = 0;
    my $page = $self->RenderBrowser or return;
    $self->SetPage( $page );
}

sub load_clipboard {
# --------------------------------------------------
    my ( $self, $path ) = @_;
    return unless $self->{dirty};
    $self->{dirty} = 0;
    my $page = $self->RenderClipboard or return;
    $self->SetPage( $page );
};

sub resize_gallery {
# --------------------------------------------------
    my $self = shift;

    my ( $w, $h ) = $self->GetSizeWH;
    my $dim_str = "${w}x${h}";
    if ( not $self->{prev_dim} or $dim_str ne $self->{prev_dim} ) {
        $self->dirty;
        $self->load_page;
        $self->{prev_dim} = $dim_str;
    }
}

sub dirty { $_[0]->{dirty}++ }

1;

############################################################
#
package Nikki::Interface::GUI::Gallery::Image;

use strict;
use vars qw( @ISA );
use Wx::Event qw( EVT_BUTTON EVT_TEXT_ENTER EVT_SIZE EVT_CHOICE );
use Wx qw(
    wxBITMAP_TYPE_ICO 
    wxMENU_TEAROFF 
    wxVERTICAL 
    wxGROW 
    wxALL
    wxDEFAULT
    wxHORIZONTAL
    wxTE_MULTILINE
    wxTE_PROCESS_ENTER 
    wxSUNKEN_BORDER 
    wxBITMAP_TYPE_JPEG
    wxDefaultSize
    wxALIGN_RIGHT
    wxALIGN_CENTER
    wxTE_MULTILINE
    wxALIGN_TOP
);
use Wx::MDI;
use Nikki::Config;
use Wx::Html;

@ISA = 'Wx::MDIChildFrame';

sub get_title {
# --------------------------------------------------
    return $STR->entry( 'app_win_pedit' );
}

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $args = shift || {};

    my $self = $pkg->SUPER::new( @_ );

    $self->{gallery} = $args->{gallery};
    $self->{photo}   = $args->{photo};

    my $main_sizer = Wx::BoxSizer->new( wxVERTICAL );

    my $title_ctl = Wx::StaticText->new(
        $self,
        -1,
        $STR->string( app_lbl_photo => $args->{photo} ),
        [0,0],
        [100,25],
        wxDEFAULT | wxALIGN_CENTER
    );

    my $cancel_button = $self->{ctl_cancelbutton} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_cancel' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $cancel_button, 
        sub { shift->OnCancel( @_ ) } # for inheritance
    );

    my $top_row = Wx::BoxSizer->new( wxHORIZONTAL );
    $top_row->Add( $title_ctl, 1, wxGROW|wxALL, 3 );
    $top_row->Add( $cancel_button, 0, wxGROW|wxALL, 3 );
    $main_sizer->Add( $top_row, 0, wxGROW|wxALL, 0 );

    my $profile = $self->{gallery}->image_load_profile( $args->{photo} );

    my $bmp = $self->{img} = Wx::Bitmap->new(
        $profile->{thumbnail_path},
        wxBITMAP_TYPE_JPEG
    );
    my $img = Wx::StaticBitmap->new(
        $self,
        -1,
        $bmp,
        [-1,-1]
    );

    my $options_sizer = Wx::FlexGridSizer->new( 6, 2, 3, 3 );

# Title Setting
    my $title_label  = $self->{lbl_title} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_widget_photo_title" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $options_sizer->Add( $title_label, 0, wxGROW|wxALL, 3 );

    my $title_opt = $self->{ctl_title_text} = Wx::TextCtrl->new(
        $self,
        -1,
        "",
        [0,0],
        [200,25],
        wxDEFAULT
    );
    $options_sizer->Add( $title_opt, 0, wxGROW|wxALL, 3 );
    $options_sizer->AddGrowableCol( 1 );

# Description Setting
    my $description_label  = $self->{lbl_description} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_widget_photo_description" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $options_sizer->Add( $description_label, 0, wxGROW|wxALL, 3 );

    my $description_opt = $self->{ctl_description_text} = Wx::TextCtrl->new(
        $self,
        -1,
        "",
        [0,0],
        [200,25],
        wxDEFAULT | wxTE_MULTILINE
    );
    $options_sizer->Add( $description_opt, 1, wxGROW|wxALL, 3 );
    $options_sizer->AddGrowableCol( 1 );
    $options_sizer->AddGrowableRow( 1 );


# Artist Setting
    my $artist_label  = $self->{lbl_artist} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_widget_photo_artist" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $options_sizer->Add( $artist_label, 0, wxGROW|wxALL, 3 );

    my $artist_opt = $self->{ctl_artist_text} = Wx::TextCtrl->new(
        $self,
        -1,
        "",
        [0,0],
        [200,25],
        wxDEFAULT
    );
    $options_sizer->Add( $artist_opt, 0, wxGROW|wxALL, 3 );
    $options_sizer->AddGrowableCol( 1 );

    my $edit_sizer = Wx::BoxSizer->new( wxHORIZONTAL );
    $edit_sizer->Add( $img, 0, wxALL|wxALIGN_TOP, 4 );
    $edit_sizer->Add( $options_sizer, 1, wxGROW|wxALL, 4 );

    $main_sizer->Add( $edit_sizer, 1, wxGROW|wxALL, 0 );

# Submit 
    my $submitentry = $self->{ctl_submitentry} = Wx::Button->new( 
        $self, 
        -1, 
        $STR->entry( 'app_widget_submit' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $submitentry, 
        sub { shift->OnSubmit( @_ ) } # for inheritance
    );

    my $bottom_sizer  = Wx::BoxSizer->new( wxHORIZONTAL );
    $bottom_sizer->Add( $submitentry,  0, wxGROW|wxALL, 3 );
    $main_sizer->Add( $bottom_sizer,  0, wxALIGN_RIGHT|wxALL, 0 );

    $self->SetSizer( $main_sizer );


    my $profile = $self->{gallery}->image_load_profile(
        $self->{photo}
    );

    $self->load_form( $profile );

    return $self;
}

sub get_form {
# --------------------------------------------------
    my $self = shift;
    my $form = {
        title       => $self->{ctl_title_text}->GetValue,
        artist      => $self->{ctl_artist_text}->GetValue,
        description => $self->{ctl_description_text}->GetValue
    };
    return $form;
}

sub load_form {
# --------------------------------------------------
    my ( $self, $args ) = @_;
    $self->{ctl_title_text}->SetValue( $args->{title} || '' );
    $self->{ctl_artist_text}->SetValue( $args->{artist} || '' );
    $self->{ctl_description_text}->SetValue( $args->{description} || '' );
}

sub is_modified {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    return (
        $self->{ctl_title_text}->IsModified
        or $self->{ctl_description_text}->IsModified
        or $self->{ctl_artist_text}->IsModified
    );
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->Close( 1 );
}

sub OnSubmit {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    if ( $self->is_modified ) {
        my $profile = $self->{gallery}->image_load_profile(
            $self->{photo}
        );
        my $new_values = $self->get_form;
        @$profile{keys %$new_values} = values %$new_values;
        $self->{gallery}->image_save_profile(
            $self->{photo},
            $profile
        );
    }

    $self->Close( 1 );
}

1;


############################################################
#
package Nikki::Interface::GUI::Gallery::Zoom;

use strict;
use vars qw( @ISA );
use Nikki::Config;
use Wx::Event qw( EVT_BUTTON );
use Wx qw( 
    wxVERTICAL 
    wxHORIZONTAL
    wxGROW 
    wxALL
    wxBITMAP_TYPE_JPEG
);
use Wx::MDI;
use Wx::Html;

@ISA = 'Wx::MDIChildFrame';

sub get_title {
# --------------------------------------------------
    my ( $self, $opt ) = @_;
    return $STR->entry( 'app_win_zoom' );
}

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $args = shift || {};

    my $self = $pkg->SUPER::new( @_ );
    @$self{keys %$args} = values %$args;

    my $main_sizer = Wx::BoxSizer->new( wxVERTICAL );

    my $cancelbutton = $self->{ctl_cancelbutton} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_cancel' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON( 
        $self, 
        $cancelbutton, 
        sub { shift->OnCancel( @_ ) } # for inheritance
    );

    my $acc_sizer  = Wx::BoxSizer->new( wxHORIZONTAL );
    $acc_sizer->Add( $cancelbutton,    1, wxGROW|wxALL, 3 );
    $main_sizer->Add( $acc_sizer,      0, wxGROW|wxALL, 3 );

    my $profile = $self->{gallery}->image_load_profile( $args->{photo} );

    my $html_ctl = $self->{display_html} = Nikki::Interface::GUI::Gallery::Zoom::Display->new(
        $self, 
        -1,
        [-1,-1],
        [-1,-1]
    );

    my $page = Nikki::Template->parse(
        $STR->entry('gal_display_image'),
        'gal_display_image',
        {
            %$profile, 
            selected => $self->{browser}{selected_images}{$profile->{base_name}}
        }
    );
    $html_ctl->SetPage( $page );

    $main_sizer->Add( $html_ctl, 1, wxGROW|wxALL, 3 );

    $self->SetSizer( $main_sizer );

    return $self;
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->Close( 1 );
}

1;
############################################################
#
package Nikki::Interface::GUI::Gallery::Zoom::Display;

use strict;
use vars qw( @ISA );

use Nikki::Config;

use Wx::Html;
@ISA = 'Wx::HtmlWindow';

sub OnLinkClicked {
# --------------------------------------------------
    my ( $self, $link_info ) = @_;

    my $href = $link_info->GetHref;

    LINK_ACTION: {

        my $parent = $self->GetParent;

        $href =~ m|^img://(.*)| and do {

            my $direction = $1;

# First, get the index of the current phootograph we are viewing
            my $photo_id = $parent->{photo};
            my $photo_index;
            my $photos_list = $parent->{image_list} || [];
            foreach my $i ( 0..$#$photos_list ) {
                next unless $photos_list->[$i]{base_name} eq $photo_id;
                $photo_index = $i;
                last;
            }

# Then, index + or - depending on what we need
# and correct to ensure we are within bounds
            $photo_index += ( $direction eq 'next' ) ? 1 : -1;
            $photo_index %= @$photos_list;

            my $profile = $photos_list->[$photo_index];
            $parent->{photo} = $profile->{base_name};

            my $page = Nikki::Template->parse(
                $STR->entry('gal_display_image'),
                'gal_display_image',
                {%$profile, selected => $parent->{browser}{selected_images}{$profile->{base_name}}}
            );
            $self->SetPage( $page );

            last;
        };

        $href =~ m|^mark://(.*)| and do {
            my $browser = $parent->{browser};
            my $selected = $browser->{selected_images} ||= {};
            $selected->{$1} = $selected->{$1} ? 0 : 1;
            $browser->dirty;
            $browser->load_page;

# First, get the index of the current phootograph we are viewing
            my $photo_id = $parent->{photo};
            my $photo_index;
            my $photos_list = $parent->{image_list} || [];
            foreach my $i ( 0..$#$photos_list ) {
                next unless $photos_list->[$i]{base_name} eq $photo_id;
                $photo_index = $i;
                last;
            }

            my $profile = $photos_list->[$photo_index];
            $parent->{photo} = $profile->{base_name};

            my $page = Nikki::Template->parse(
                $STR->entry('gal_display_image'),
                'gal_display_image',
                {%$profile, selected => $parent->{browser}{selected_images}{$profile->{base_name}}}
            );
            $self->SetPage( $page );

            last;
        };

        return $self->SUPER::OnLinkClicked( $link_info );
    };

    return;
}


1;
############################################################
#
package Nikki::Interface::GUI::Gallery::Settings;

use strict;
use vars qw( @ISA );
use Nikki::Config;
use Wx::Event qw( EVT_BUTTON EVT_LIST_ITEM_SELECTED );
use Wx qw( 
    wxBITMAP_TYPE_ICO 
    wxMENU_TEAROFF 
    wxVERTICAL 
    wxGROW 
    wxALL
    wxHORIZONTAL
    wxTE_MULTILINE
    wxTE_PROCESS_ENTER 
    wxALIGN_RIGHT
    wxALIGN_CENTER
    wxDefaultPosition
    wxDefaultSize
    wxLC_LIST
    wxSUNKEN_BORDER 
    wxLC_EDIT_LABELS
    wxLC_SINGLE_SEL 
    wxLC_REPORT 
    wxLC_SINGLE_SEL 
    wxLIST_FORMAT_LEFT
    wxSIMPLE_BORDER 
    wxTE_PASSWORD 
    wxOK 
    wxICON_INFORMATION
    wxPD_ELAPSED_TIME 
    wxPD_AUTO_HIDE 
);
use Wx::MDI;

@ISA = 'Wx::MDIChildFrame';

sub get_title {
# --------------------------------------------------
    my ( $self, $opt ) = @_;
    return $STR->string( app_win_accounts => $opt->{itemid} || '?'  );
}

sub new {
# --------------------------------------------------
    my $pkg = shift;
    my $args = shift || {};
    my $self = $pkg->SUPER::new( @_ );

    my $main_sizer    = Wx::BoxSizer->new( wxVERTICAL );

# Control Widgets
    my $commit_row = Wx::BoxSizer->new( wxHORIZONTAL );
    my $commit_cancelbutton = Wx::Button->new(
        $self,
        -1,
        $STR->entry( 'app_widget_cancel' ),
        [0,0],
        [75,25]
    );

    EVT_BUTTON(
        $self,
        $commit_cancelbutton,
        sub { shift->OnCancel( @_ ) }
    );

    $commit_row->Add( $commit_cancelbutton, 1, wxGROW|wxALL, 3 );
    $main_sizer->Add( $commit_row, 0, wxGROW|wxALL, 0 );

# ACCOUNT LIST
    my $acc_list = $self->{ctl_listaccounts} = Wx::ListCtrl->new(
        $self,
        -1,
        wxDefaultPosition,
        [1,100], 
        wxSUNKEN_BORDER |wxLC_REPORT | wxLC_SINGLE_SEL  #|wxLC_EDIT_LABELS
    );

    my @c = split /\|/, $STR->entry( 'app_str_ftp_columns' );
    $acc_list->InsertColumn( 1, $c[0], wxLIST_FORMAT_LEFT, 50 );
    $acc_list->InsertColumn( 1, $c[1], wxLIST_FORMAT_LEFT, 100 );
    $acc_list->InsertColumn( 2, $c[2], wxLIST_FORMAT_LEFT, 150 );
    $acc_list->InsertColumn( 3, $c[3], wxLIST_FORMAT_LEFT, 50 );
    $acc_list->InsertColumn( 4, $c[4], wxLIST_FORMAT_LEFT, 200 );
    $acc_list->InsertColumn( 5, $c[5], wxLIST_FORMAT_LEFT, 200 );
    $acc_list->InsertColumn( 6, $c[6], wxLIST_FORMAT_LEFT, 50 );

    EVT_LIST_ITEM_SELECTED( 
        $self, 
        $acc_list, 
        sub { shift->OnAccountSelect( @_ ) },
    );

    $main_sizer->Add( $acc_list, 0, wxGROW|wxALL, 3 );

# ADD/DELETE ACCOUNT
    my $action_row = Wx::BoxSizer->new( wxHORIZONTAL );

    my $act_delete = $self->{ctl_deleteaccount} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_delete' ),
        [0, 0], 
        [75, 25] 
    );

    $action_row->Add( $act_delete, 0, wxALL, 3 );

    EVT_BUTTON(
        $self,
        $act_delete,
        sub { shift->OnAccountDelete(@_) },
    );

    my $act_default = $self->{ctl_defaultaccount} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_default' ),
        [0, 0], 
        [75, 25] 
    );

    $action_row->Add( $act_default, 0, wxALL, 3 );

    EVT_BUTTON(
        $self,
        $act_default,
        sub { shift->OnAccountDefault(@_) },
    );

    my $act_addnew = $self->{ctl_addnewaccount} = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_addnew' ),
        [0, 0], 
        [75, 25] 
    );
    $action_row->Add( $act_addnew, 0, wxALL, 3 );

    EVT_BUTTON(
        $self,
        $act_addnew,
        sub { shift->OnAccountNew(@_) },
    );

    $main_sizer->Add( $action_row, 0, wxALIGN_RIGHT|wxALL, 0 );

# MODIFY ACCOUNT INFO
    my $bordered_box = Wx::StaticBox->new(
        $self,
        -1,
        $STR->entry( "app_lbl_acc_info" ),
        [-1,-1],
        [-1,-1],
        wxSIMPLE_BORDER 
    );

    my $bordered_box_sizer = Wx::StaticBoxSizer->new(
        $bordered_box,
        wxVERTICAL
    );

    my $info_row = Wx::FlexGridSizer->new( 6, 2, 3, 3 );

    my $host_label  = $self->{lbl_host} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_host" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $host_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $host_entry = $self->{ctl_hostentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "",
        [0,0], 
        [200, 25], 
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $host_entry, 0, wxALL, 3 );
    $info_row->AddGrowableCol( 1 );

    my $port_label  = $self->{lbl_port} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_port" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $port_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $port_entry = $self->{ctl_portentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [100, 25], 
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $port_entry, 0, wxALL, 3 );

    my $path_label  = $self->{lbl_path} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_ftp_path" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $path_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $path_entry = $self->{ctl_pathentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [200, 25], 
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $path_entry, 0, wxALL, 3 );


    my $url_label  = $self->{lbl_url} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_ftp_url" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $url_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $url_entry = $self->{ctl_urlentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [200, 25], 
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $url_entry, 0, wxALL, 3 );

    my $username_label  = $self->{lbl_username} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_username" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $username_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $username_entry = $self->{ctl_usernameentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [200, 25], 
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $username_entry, 0, wxALL, 3 );

    my $password_label  = $self->{lbl_password} = Wx::StaticText->new(
        $self,
        -1,
        $STR->entry( "app_lbl_password" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $password_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $password_entry = $self->{ctl_passwordentry} = Wx::TextCtrl->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [200, 25], 
        wxTE_PROCESS_ENTER | wxTE_PASSWORD 
    );
    $info_row->Add( $password_entry, 0, wxALL, 3 );

    my $use_sftp_label  = $self->{lbl_use_sftp} = Wx::StaticText->new(
        $self,
        -1,
        $STR->string( "app_lbl_use_sftp" ),
        [ 100, 25 ],
        wxDefaultSize,
        wxALIGN_RIGHT
    );
    $info_row->Add( $use_sftp_label, 0, wxALIGN_RIGHT|wxALL, 3 );

    my $use_sftp_entry = $self->{ctl_use_sftpentry} = Wx::CheckBox->new( 
        $self, 
        -1, 
        "", 
        [0,0], 
        [100, 25], 
        wxTE_PROCESS_ENTER 
    );
    $info_row->Add( $use_sftp_entry, 1, wxGROW|wxALL, 3 );

# Not for now
#    my $save_pass_label  = $self->{lbl_save_pass} = Wx::StaticText->new(
#        $self,
#        -1,
#        $STR->string( "app_lbl_save_pass" ),
#        [ 100, 25 ],
#        wxDefaultSize,
#        wxALIGN_RIGHT
#    );
#    $info_row->Add( $save_pass_label, 0, wxALIGN_RIGHT|wxALL, 3 );
#
#    my $save_pass_entry = $self->{ctl_save_passentry} = Wx::CheckBox->new( 
#        $self, 
#        -1, 
#        "", 
#        [0,0], 
#        [100, 25], 
#        wxTE_PROCESS_ENTER 
#    );
#    $info_row->Add( $save_pass_entry, 1, wxGROW|wxALL, 3 );

    $bordered_box_sizer->Add( $info_row, 0, wxALIGN_CENTER|wxALL, 0 );

    my $infoaction_row = Wx::BoxSizer->new( wxHORIZONTAL );
    my $info_test = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_test' ),
        [0, 0], 
        [75, 25] 
    );

    EVT_BUTTON(
        $self,
        $info_test,
        sub { shift->OnAccountTest(@_) },
    );

    $infoaction_row->Add( $info_test, 0, wxALL, 3 );

    my $info_commit = Wx::Button->new(
        $self, 
        -1, 
        $STR->entry( 'app_widget_commit' ),
        [0, 0], 
        [75, 25] 
    );

    $infoaction_row->Add( $info_commit, 0, wxALL, 3 );

    EVT_BUTTON(
        $self,
        $info_commit,
        sub { shift->OnAccountCommit(@_) },
    );

    $bordered_box_sizer->Add( $infoaction_row, 0, wxALIGN_RIGHT|wxALL, 3 );

    $main_sizer->Add( $bordered_box_sizer, 0, wxGROW|wxALL, 3 );

    $self->SetSizer( $main_sizer );

    $self->{gallery} = Nikki::Gallery->new;

    $self->load_accounts;

    $self->OnAccountNew;

    return $self;
}

sub load_accounts {
# --------------------------------------------------
    my $self = shift;
    my $listctl = $self->{ctl_listaccounts};
    $listctl->DeleteAllItems;
    my $accounts = $self->{gallery}->accounts;
    my $i = 0;
    foreach my $acc ( keys %$accounts ) {
        my $acc_info = $accounts->{$acc};
        my $id = $listctl->InsertStringItem( 
            $i++, 
            $acc_info->{default} ? $STR->entry( 'app_str_default_account' ) : ''
        );
        $listctl->SetItem( $id, 1, $acc_info->{username} );
        $listctl->SetItem( $id, 2, $acc_info->{host} );
        $listctl->SetItem( $id, 3, $acc_info->{port} );
        $listctl->SetItem( $id, 4, $acc_info->{path} );
        $listctl->SetItem( $id, 5, $acc_info->{url} );
        $listctl->SetItem( $id, 6, $acc_info->{use_sftp} ? 'SFTP' : 'FTP' );
    }
}

sub load_form {
# --------------------------------------------------
    my ( $self, $args ) = @_;
    $self->{ctl_hostentry}->SetValue( $args->{host} );
    $self->{ctl_portentry}->SetValue( $args->{port} );
    $self->{ctl_pathentry}->SetValue( $args->{path} );
    $self->{ctl_urlentry}->SetValue( $args->{url} || '' );
    $self->{ctl_usernameentry}->SetValue( $args->{username} );
    $self->{ctl_usernameentry}->SetEditable( $args->{username_lock} ? 0 : 1 );
    $self->{ctl_passwordentry}->SetValue( $args->{password} ); 
    $self->{ctl_use_sftpentry}->SetValue( $args->{use_sftp} ); 
#    $self->{ctl_save_passentry}->SetValue( $args->{save_password} ); 
}

sub get_form {
# --------------------------------------------------
    my $self = shift;
    my $args = {
        host => $self->{ctl_hostentry}->GetValue,
        port => $self->{ctl_portentry}->GetValue,
        path => $self->{ctl_pathentry}->GetValue,
        url  => $self->{ctl_urlentry}->GetValue,
        username => $self->{ctl_usernameentry}->GetValue,
        password => $self->{ctl_passwordentry}->GetValue,
        use_sftp => $self->{ctl_use_sftpentry}->GetValue
#        save_password => $self->{ctl_save_passentry}->GetValue,
    };
    return $args;
}

sub OnCancel {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->Close(1);
}

sub OnAccountNew {
# --------------------------------------------------
    my ( $self, $event ) = @_;
    $self->load_form({
        host     => '',
        path     => '',
        port     => 21,
        url      => 'http://',
        username => '',
        password => '',
    });
}

sub OnAccountDefault {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $ctl_listaccounts = $self->{ctl_listaccounts};

    my $idx       = $self->{idx};
    my $acc_name  = $ctl_listaccounts->GetItem( $idx, 1 )->GetText;
    my $host_name = $ctl_listaccounts->GetItem( $idx, 2 )->GetText;

    my $acc_key   = "$acc_name\@$host_name";

    $self->{gallery}->account_default( $acc_key );
    $self->load_accounts;
}

sub OnAccountDelete {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $ctl_listaccounts = $self->{ctl_listaccounts};

    my $idx       = $self->{idx};
    my $acc_name  = $ctl_listaccounts->GetItem( $idx, 1 )->GetText;
    my $host_name = $ctl_listaccounts->GetItem( $idx, 2 )->GetText;

    my $acc_key   = "$acc_name\@$host_name";

    $self->{gallery}->account_delete( $acc_key );
    $self->load_accounts;
}

sub sync_reindex {
# --------------------------------------------------
    my ( $client, $account_key, $prog_func ) = @_;

    my $rec = $client->account_sync({
        account => $account_key,
        progress => $prog_func
    });

    $prog_func->( 100, $STR->entry( "app_sync_done" ) );

    return $client->save_user;
}


sub OnAccountSelect {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    my $ctl_listaccounts = $self->{ctl_listaccounts};

    my $idx       = $self->{idx} = $event->GetIndex;
    my $acc_name  = $ctl_listaccounts->GetItem( $idx, 1 )->GetText;
    my $host_name = $ctl_listaccounts->GetItem( $idx, 2 )->GetText;

    my $accounts  = $self->{gallery}->accounts;
    my $account   = {%{$accounts->{"$acc_name\@$host_name"}}};

    $account->{username_lock} = 1;
    $self->load_form( $account );
}

sub OnAccountTest {
# --------------------------------------------------
    my ( $self, $event ) = @_;

    if ( $self->{gallery}->account_test(
        $self->get_form
    ) ) {
        Wx::MessageBox( 
            $STR->entry( 'app_str_acc_test_success' ), 
            $STR->entry( 'app_str_acc_test' ),
            wxOK | wxICON_INFORMATION,
            $self 
        );
    }
    else {
        Wx::MessageBox(
            $STR->string( app_str_acc_test_fail => $self->{gallery}->error ), 
            $STR->entry( 'app_str_acc_test' ),
            wxOK | wxICON_INFORMATION,
            $self 
        );
    };

}

sub OnAccountCommit {
# --------------------------------------------------
# This function must determine if an account should
# be added or edited. 
#
    my ( $self, $event ) = @_;
    my $args = $self->get_form;
    $self->{gallery}->account_commit( $args );
    $self->load_accounts;
}

1;

package main;

$|++;
Nikki::Interface->run;

__END__
